/**
 * @license
 * Copyright 2022 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports,require("@tensorflow/tfjs-core")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).tf=t.tf||{},t.tf)}(this,(function(t,e){"use strict";function n(t){if(t&&t.__esModule)return t;var e=Object.create(null);return t&&Object.keys(t).forEach((function(n){if("default"!==n){var r=Object.getOwnPropertyDescriptor(t,n);Object.defineProperty(e,n,r.get?r:{enumerable:!0,get:function(){return t[n]}})}})),e.default=t,e}function r(t,e){return e.forEach((function(e){Object.keys(e).forEach((function(n){if("default"!==n&&!(n in t)){var r=Object.getOwnPropertyDescriptor(e,n);Object.defineProperty(t,n,r.get?r:{enumerable:!0,get:function(){return e[n]}})}}))})),t}var a=n(e);e.env().registerFlag("KEEP_INTERMEDIATE_TENSORS",(function(){return!1}),(function(t){t&&console.warn("Keep intermediate tensors is ON. This will print the values of all intermediate tensors during model inference. Not all models support this mode. For details, check e2e/benchmarks/ model_config.js. This significantly impacts performance.")}));var o,s,i=function(t,e){return i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&(t[n]=e[n])},i(t,e)};function u(t,e,n,r){return new(n||(n=Promise))((function(a,o){function s(t){try{u(r.next(t))}catch(t){o(t)}}function i(t){try{u(r.throw(t))}catch(t){o(t)}}function u(t){var e;t.done?a(t.value):(e=t.value,e instanceof n?e:new n((function(t){t(e)}))).then(s,i)}u((r=r.apply(t,e||[])).next())}))}function p(t,e){var n,r,a,o,s={label:0,sent:function(){if(1&a[0])throw a[1];return a[1]},trys:[],ops:[]};return o={next:i(0),throw:i(1),return:i(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function i(o){return function(i){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;s;)try{if(n=1,r&&(a=2&o[0]?r.return:o[0]?r.throw||((a=r.return)&&a.call(r),0):r.next)&&!(a=a.call(r,o[1])).done)return a;switch(r=0,a&&(o=[2&o[0],a.value]),o[0]){case 0:case 1:a=o;break;case 4:return s.label++,{value:o[1],done:!1};case 5:s.label++,r=o[1],o=[0];continue;case 7:o=s.ops.pop(),s.trys.pop();continue;default:if(!(a=s.trys,(a=a.length>0&&a[a.length-1])||6!==o[0]&&2!==o[0])){s=0;continue}if(3===o[0]&&(!a||o[1]>a[0]&&o[1]<a[3])){s.label=o[1];break}if(6===o[0]&&s.label<a[1]){s.label=a[1],a=o;break}if(a&&s.label<a[2]){s.label=a[2],s.ops.push(o);break}a[2]&&s.ops.pop(),s.trys.pop();continue}o=e.call(t,s)}catch(t){o=[6,t],r=0}finally{n=a=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,i])}}}function c(t){var e="function"==typeof Symbol&&Symbol.iterator,n=e&&t[e],r=0;if(n)return n.call(t);if(t&&"number"==typeof t.length)return{next:function(){return t&&r>=t.length&&(t=void 0),{value:t&&t[r++],done:!t}}};throw new TypeError(e?"Object is not iterable.":"Symbol.iterator is not defined.")}function l(t,e){var n="function"==typeof Symbol&&t[Symbol.iterator];if(!n)return t;var r,a,o=n.call(t),s=[];try{for(;(void 0===e||e-- >0)&&!(r=o.next()).done;)s.push(r.value)}catch(t){a={error:t}}finally{try{r&&!r.done&&(n=o.return)&&n.call(o)}finally{if(a)throw a.error}}return s}function d(t,e,n){if(n||2===arguments.length)for(var r,a=0,o=e.length;a<o;a++)!r&&a in e||(r||(r=Array.prototype.slice.call(e,0,a)),r[a]=e[a]);return t.concat(r||Array.prototype.slice.call(e))}!function(t){t[t.DT_INVALID=0]="DT_INVALID",t[t.DT_FLOAT=1]="DT_FLOAT",t[t.DT_DOUBLE=2]="DT_DOUBLE",t[t.DT_INT32=3]="DT_INT32",t[t.DT_UINT8=4]="DT_UINT8",t[t.DT_INT16=5]="DT_INT16",t[t.DT_INT8=6]="DT_INT8",t[t.DT_STRING=7]="DT_STRING",t[t.DT_COMPLEX64=8]="DT_COMPLEX64",t[t.DT_INT64=9]="DT_INT64",t[t.DT_BOOL=10]="DT_BOOL",t[t.DT_QINT8=11]="DT_QINT8",t[t.DT_QUINT8=12]="DT_QUINT8",t[t.DT_QINT32=13]="DT_QINT32",t[t.DT_BFLOAT16=14]="DT_BFLOAT16",t[t.DT_QINT16=15]="DT_QINT16",t[t.DT_QUINT16=16]="DT_QUINT16",t[t.DT_UINT16=17]="DT_UINT16",t[t.DT_COMPLEX128=18]="DT_COMPLEX128",t[t.DT_HALF=19]="DT_HALF",t[t.DT_RESOURCE=20]="DT_RESOURCE",t[t.DT_VARIANT=21]="DT_VARIANT",t[t.DT_UINT32=22]="DT_UINT32",t[t.DT_UINT64=23]="DT_UINT64",t[t.DT_FLOAT_REF=101]="DT_FLOAT_REF",t[t.DT_DOUBLE_REF=102]="DT_DOUBLE_REF",t[t.DT_INT32_REF=103]="DT_INT32_REF",t[t.DT_UINT8_REF=104]="DT_UINT8_REF",t[t.DT_INT16_REF=105]="DT_INT16_REF",t[t.DT_INT8_REF=106]="DT_INT8_REF",t[t.DT_STRING_REF=107]="DT_STRING_REF",t[t.DT_COMPLEX64_REF=108]="DT_COMPLEX64_REF",t[t.DT_INT64_REF=109]="DT_INT64_REF",t[t.DT_BOOL_REF=110]="DT_BOOL_REF",t[t.DT_QINT8_REF=111]="DT_QINT8_REF",t[t.DT_QUINT8_REF=112]="DT_QUINT8_REF",t[t.DT_QINT32_REF=113]="DT_QINT32_REF",t[t.DT_BFLOAT16_REF=114]="DT_BFLOAT16_REF",t[t.DT_QINT16_REF=115]="DT_QINT16_REF",t[t.DT_QUINT16_REF=116]="DT_QUINT16_REF",t[t.DT_UINT16_REF=117]="DT_UINT16_REF",t[t.DT_COMPLEX128_REF=118]="DT_COMPLEX128_REF",t[t.DT_HALF_REF=119]="DT_HALF_REF",t[t.DT_RESOURCE_REF=120]="DT_RESOURCE_REF",t[t.DT_VARIANT_REF=121]="DT_VARIANT_REF",t[t.DT_UINT32_REF=122]="DT_UINT32_REF",t[t.DT_UINT64_REF=123]="DT_UINT64_REF"}(o||(o={})),function(t){var e;(e=t.CheckpointFormatVersion||(t.CheckpointFormatVersion={}))[e.LEGACY=0]="LEGACY",e[e.V1=1]="V1",e[e.V2=2]="V2"}(s||(s={}));var h={};function f(t){return h[t]}function m(t,n,r,a,o){var s=n.inputParams[t];if(s&&void 0!==s.inputIndexStart){var i=s.inputIndexStart,u=0===s.inputIndexEnd?void 0:void 0===s.inputIndexEnd?i+1:s.inputIndexEnd;if("tensor"===s.type)return y(n.inputNames[s.inputIndexStart],r,a,o);if("tensors"===s.type)return n.inputNames.slice(i,u).map((function(t){return y(t,r,a,o)}));var p=y(n.inputNames.slice(i)[0],r,a,o),c=p.dataSync();return"number"===s.type?c[0]:e.util.toNestedArray(p.shape,c)}var l=n.attrParams[t];return l&&l.value}function y(t,e,n,r){var a=l(b(t),2),o=a[0],s=a[1];if(null!=r){var i=r.getHashTableHandleByName(o);if(null!=i)return i}var u=n.currentContextIds.find((function(t){return!!e[v(o,t)]}));return void 0!==u?e[v(o,u)][s]:void 0}function g(t,e){var n=l(b(t),3),r=n[0],a=n[1],o=n[2];return[v(r,e&&e.currentContextId),a,o]}function v(t,e){return e?"".concat(t,"-").concat(e):t}function b(t){var e=t.split(":");if(1===e.length)return[t,0,void 0];var n=e[0],r=3===e.length?e[1]:void 0;return[n,Number(e[e.length-1]),r]}function x(t,e,n){var r=m("pad",t,e,n);if("explicit"===r){r=m("explicitPaddings",t,e,n);for(var a=[[0,0],[0,0],[0,0],[0,0]],o=0;o<4;o++)a[o][0]=r[2*o],a[o][1]=r[2*o+1];return a}return r}function N(t){return t.kept?t:e.clone(t)}var w={__proto__:null,json:[{tfOpName:"Add",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"AddV2",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"AddN",category:"arithmetic",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}]},{tfOpName:"BiasAdd",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"Sub",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"RealDiv",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Div",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"DivNoNan",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"FloorDiv",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Mul",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Maximum",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Minimum",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Pow",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"SquaredDifference",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Mod",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"FloorMod",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}]},k={__proto__:null,json:[{tfOpName:"Abs",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Acos",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Asin",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Atan",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Atan2",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"y",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Ceil",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ClipByValue",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"clipValueMin",type:"number"},{start:2,name:"clipValueMax",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Complex",category:"basic_math",inputs:[{start:0,name:"real",type:"tensor"},{start:1,name:"imag",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ComplexAbs",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Cos",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Cosh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Elu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Exp",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Floor",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Log",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Imag",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"Tout",name:"outputType",type:"dtype",notSupported:!0}]},{tfOpName:"Neg",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Real",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"Tout",name:"outputType",type:"dtype",notSupported:!0}]},{tfOpName:"Prelu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"alpha",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Relu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Relu6",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Selu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sigmoid",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sin",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sinh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sqrt",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Rsqrt",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Square",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Tan",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Tanh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sign",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Round",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Expm1",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Log1p",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Reciprocal",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Softplus",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Asinh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Acosh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Atanh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Erf",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Prod",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axes",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool",notSupported:!0},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LeakyRelu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"alpha",name:"alpha",type:"number",defaultValue:.2},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"IsNan",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}]},T={__proto__:null,json:[{tfOpName:"EmptyTensorList",category:"control",inputs:[{start:0,name:"elementShape",type:"shape"},{start:1,name:"maxNumElements",type:"number"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"LoopCond",category:"control",inputs:[{start:0,name:"pred",type:"tensor"}]},{tfOpName:"Switch",category:"control",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"pred",type:"tensor"}]},{tfOpName:"Merge",category:"control",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}]},{tfOpName:"Enter",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"frame_name",name:"frameName",type:"string"},{tfName:"is_constant",name:"isConstant",type:"bool"}]},{tfOpName:"Exit",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"NextIteration",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"TensorArrayV3",category:"control",inputs:[{start:0,name:"size",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"element_shape",name:"elementShape",type:"shape"},{tfName:"dynamic_size",name:"dynamicSize",type:"bool"},{tfName:"clear_after_read",name:"clearAfterRead",type:"bool"},{tfName:"identical_element_shapes",name:"identicalElementShapes",type:"bool"},{tfName:"tensor_array_name",name:"name",type:"string"}]},{tfOpName:"TensorArrayWriteV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"index",type:"number"},{start:2,name:"tensor",type:"tensor"},{start:3,name:"flowIn",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"TensorArrayReadV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"index",type:"number"},{start:2,name:"flowIn",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"TensorArrayGatherV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"flowIn",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"element_shape",name:"elementShape",type:"shape"}]},{tfOpName:"TensorArrayScatterV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"tensor",type:"tensor"},{start:3,name:"flowIn",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"TensorArrayConcatV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"flowIn",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"element_shape_except0",name:"elementShapeExcept0",type:"shape",notSupported:!0}]},{tfOpName:"TensorArraySplitV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"tensor",type:"tensor"},{start:2,name:"lengths",type:"number[]"},{start:3,name:"flowIn",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"TensorArraySizeV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"flowIn",type:"number"}]},{tfOpName:"TensorArrayCloseV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"}]},{tfOpName:"StatelessIf",category:"control",inputs:[{start:0,name:"cond",type:"tensor"},{start:1,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"then_branch",name:"thenBranch",type:"func"},{tfName:"else_branch",name:"elseBranch",type:"func"}]},{tfOpName:"If",category:"control",inputs:[{start:0,name:"cond",type:"tensor"},{start:1,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"then_branch",name:"thenBranch",type:"func"},{tfName:"else_branch",name:"elseBranch",type:"func"}]},{tfOpName:"StatelessWhile",category:"control",inputs:[{start:0,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"cond",name:"cond",type:"func"},{tfName:"body",name:"body",type:"func"}]},{tfOpName:"While",category:"control",inputs:[{start:0,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"cond",name:"cond",type:"func"},{tfName:"body",name:"body",type:"func"}]},{tfOpName:"TensorListScatter",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListScatterV2",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"elementShape",type:"shape"},{start:3,name:"numElements",type:"number"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListGather",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListGetItem",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"index",type:"number"},{start:2,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListSetItem",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"index",type:"number"},{start:2,name:"tensor",type:"tensor"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListReserve",category:"control",inputs:[{start:0,name:"elementShape",type:"shape"},{start:1,name:"numElements",type:"number"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListFromTensor",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListStack",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"},{tfName:"num_elements",name:"numElements",type:"dtype"}]},{tfOpName:"TensorListSplit",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"elementShape",type:"shape"},{start:2,name:"lengths",type:"number[]"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListConcat",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"}],attrs:[{tfName:"element_shape",name:"elementShape",type:"shape"},{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListConcatV2",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"}],attrs:[{tfName:"element_shape",name:"elementShape",type:"shape"},{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListPopBack",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListPushBack",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"tensor",type:"tensor"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListLength",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"}]},{tfOpName:"TensorListResize",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"size",type:"number"}]}]},_={__proto__:null,json:[{tfOpName:"AvgPool",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MaxPool",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[],notSupported:!0},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MaxPoolWithArgmax",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"include_batch_in_index",name:"includeBatchInIndex",type:"bool"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"AvgPool3D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MaxPool3D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Conv1D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"stride",name:"stride",type:"number"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NWC"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"dilation",name:"dilation",type:"number",defaultValue:1}]},{tfOpName:"Conv2D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"useCudnnOnGpu",name:"useCudnnOnGpu",type:"bool"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"_FusedConv2D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"},{start:2,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"num_args",name:"numArgs",type:"number"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"use_cudnn_on_gpu",name:"useCudnnOnGpu",type:"bool",defaultValue:!0},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]",defaultValue:[1,1,1,1]},{tfName:"fused_ops",name:"fusedOps",type:"string[]",defaultValue:[]},{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:1e-4},{tfName:"leakyrelu_alpha",name:"leakyreluAlpha",type:"number",defaultValue:.2}]},{tfOpName:"Conv2DBackpropInput",category:"convolution",inputs:[{start:2,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"},{start:0,name:"outputShape",type:"number[]"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"dilations",name:"dilations",type:"number[]",notSupported:!0}]},{tfOpName:"DepthwiseConv2d",category:"convolution",inputs:[{start:0,name:"input",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"DepthwiseConv2dNative",category:"convolution",inputs:[{start:0,name:"input",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"FusedDepthwiseConv2dNative",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"},{start:2,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"num_args",name:"numArgs",type:"number"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]",defaultValue:[1,1,1,1]},{tfName:"fused_ops",name:"fusedOps",type:"string[]",defaultValue:[]},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]}]},{tfOpName:"Conv3D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"Dilation2D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"rates",name:"dilations",type:"number[]"},{tfName:"padding",name:"pad",type:"string"}]}]},S={__proto__:null,json:[{tfOpName:"Fill",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"},{start:1,name:"value",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"LinSpace",category:"creation",inputs:[{start:0,name:"start",type:"number"},{start:1,name:"stop",type:"number"},{start:2,name:"num",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"OneHot",category:"creation",inputs:[{start:0,name:"indices",type:"tensor"},{start:1,name:"depth",type:"number"},{start:2,name:"onValue",type:"number",defaultValue:1},{start:3,name:"offValue",type:"number",defaultValue:0}],attrs:[{tfName:"axis",name:"axis",type:"number",notSupported:!0},{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"Ones",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"OnesLike",category:"creation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"}]},{tfOpName:"RandomStandardNormal",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"seed",name:"seed",type:"number",defaultValue:0},{tfName:"seed2",name:"seed2",type:"number",defaultValue:0,notSupported:!0},{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"T",name:"T",type:"number",notSupported:!0}]},{tfOpName:"RandomUniform",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"minval",name:"minval",type:"number",defaultValue:0},{tfName:"maxval",name:"maxval",type:"number",defaultValue:1},{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"seed",name:"seed",type:"number",defaultValue:0},{tfName:"seed2",name:"seed2",type:"number",defaultValue:0,notSupported:!0},{tfName:"T",name:"T",type:"number",notSupported:!0}]},{tfOpName:"Range",category:"creation",inputs:[{start:0,name:"start",type:"number"},{start:1,name:"stop",type:"number"},{start:2,name:"step",type:"number",defaultValue:0}],attrs:[{tfName:"Tidx",name:"dtype",type:"dtype"}]},{tfOpName:"TruncatedNormal",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"means",name:"mean",type:"number",defaultValue:0},{tfName:"stddev",name:"stdDev",type:"number",defaultValue:1},{tfName:"seed",name:"seed",type:"number"},{tfName:"seed2",name:"seed2",type:"number",defaultValue:0,notSupported:!0},{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"T",name:"T",type:"number",notSupported:!0}]},{tfOpName:"Zeros",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"ZerosLike",category:"creation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"Multinomial",category:"creation",inputs:[{start:0,name:"logits",type:"tensor"},{start:1,name:"numSamples",type:"number"}],attrs:[{tfName:"seed",name:"seed",type:"number"},{tfName:"seed2",name:"seed2",type:"number"},{tfName:"T",name:"dtype",type:"dtype"},{tfName:"output_dtype",name:"output_dtype",type:"dtype"}]}]},E={__proto__:null,json:[{tfOpName:"NonMaxSuppressionV2",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"}]},{tfOpName:"NonMaxSuppressionV3",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"},{start:4,name:"scoreThreshold",type:"number"}]},{tfOpName:"NonMaxSuppressionV4",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"},{start:4,name:"scoreThreshold",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"T_threshold",name:"threshold",type:"dtype",notSupported:!0},{tfName:"pad_to_max_output_size",name:"padToMaxOutputSize",type:"bool"}]},{tfOpName:"NonMaxSuppressionV5",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"},{start:4,name:"scoreThreshold",type:"number"},{start:5,name:"softNmsSigma",type:"number"}]},{tfOpName:"Where",category:"dynamic",inputs:[{start:0,name:"condition",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ListDiff",category:"dynamic",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"y",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}]},I={__proto__:null,json:[{tfOpName:"LowerBound",category:"evaluation",inputs:[{start:0,name:"sortedSequence",type:"tensor"},{start:1,name:"values",type:"tensor"}]},{tfOpName:"TopKV2",category:"evaluation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"k",type:"number"}],attrs:[{tfName:"sorted",name:"sorted",type:"bool"}]},{tfOpName:"UpperBound",category:"evaluation",inputs:[{start:0,name:"sortedSequence",type:"tensor"},{start:1,name:"values",type:"tensor"}]},{tfOpName:"Unique",category:"evaluation",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"UniqueV2",category:"evaluation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]}]},O={__proto__:null,json:[{tfOpName:"PlaceholderWithDefault",category:"graph",inputs:[{start:0,name:"default",type:"tensor"}],attrs:[{tfName:"shape",name:"shape",type:"shape"},{tfName:"dtype",name:"dtype",type:"dtype"}]},{tfOpName:"Placeholder",category:"graph",attrs:[{tfName:"shape",name:"shape",type:"shape"},{tfName:"dtype",name:"dtype",type:"dtype"}]},{tfOpName:"Const",category:"graph"},{tfOpName:"Identity",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"IdentityN",category:"graph",inputs:[{start:0,end:0,name:"x",type:"tensors"}]},{tfOpName:"Snapshot",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"Rank",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"Size",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"Shape",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"ShapeN",category:"graph",inputs:[{start:0,end:0,name:"x",type:"tensors"}]},{tfOpName:"Print",category:"graph",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"data",type:"tensors"}],attrs:[{tfName:"message",name:"message",type:"string"},{tfName:"first_n",name:"firstN",type:"number",notSupported:!0},{tfName:"summarize",name:"summarize",type:"number",defaultValue:3}]},{tfOpName:"NoOp",category:"graph",inputs:[]},{tfOpName:"StopGradient",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"FakeQuantWithMinMaxVars",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"min",name:"min",type:"number"},{tfName:"max",name:"max",type:"number"}]}]},D={__proto__:null,json:[{tfOpName:"HashTable",category:"hash_table",inputs:[],attrs:[{tfName:"shared_name",name:"sharedName",type:"string"},{tfName:"use_node_name_sharing",name:"useNodeNameSharing",type:"bool"},{tfName:"key_dtype",name:"keyDType",type:"dtype"},{tfName:"value_dtype",name:"valueDType",type:"dtype"}]},{tfOpName:"HashTableV2",category:"hash_table",inputs:[],attrs:[{tfName:"shared_name",name:"sharedName",type:"string"},{tfName:"use_node_name_sharing",name:"useNodeNameSharing",type:"bool"},{tfName:"key_dtype",name:"keyDType",type:"dtype"},{tfName:"value_dtype",name:"valueDType",type:"dtype"}]},{tfOpName:"LookupTableImport",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"values",type:"tensor"}],attrs:[{tfName:"Tin",name:"tIn",type:"dtype",notSupported:!0},{tfName:"Tout",name:"tOut",type:"dtype",notSupported:!0}]},{tfOpName:"LookupTableImportV2",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"values",type:"tensor"}],attrs:[{tfName:"Tin",name:"tIn",type:"dtype",notSupported:!0},{tfName:"Tout",name:"tOut",type:"dtype",notSupported:!0}]},{tfOpName:"LookupTableFind",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"Tin",name:"tIn",type:"dtype",notSupported:!0},{tfName:"Tout",name:"tOut",type:"dtype",notSupported:!0}]},{tfOpName:"LookupTableFindV2",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"Tin",name:"tIn",type:"dtype",notSupported:!0},{tfName:"Tout",name:"tOut",type:"dtype",notSupported:!0}]},{tfOpName:"LookupTableSize",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"}]},{tfOpName:"LookupTableSizeV2",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"}]}]},A={__proto__:null,json:[{tfOpName:"ResizeBilinear",category:"image",inputs:[{start:0,name:"images",type:"tensor"},{start:1,name:"size",type:"number[]"}],attrs:[{tfName:"align_corners",name:"alignCorners",type:"bool"},{tfName:"half_pixel_centers",name:"halfPixelCenters",type:"bool"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ResizeNearestNeighbor",category:"image",inputs:[{start:0,name:"images",type:"tensor"},{start:1,name:"size",type:"number[]"}],attrs:[{tfName:"align_corners",name:"alignCorners",type:"bool"},{tfName:"half_pixel_centers",name:"halfPixelCenters",type:"bool"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"CropAndResize",category:"image",inputs:[{start:0,name:"image",type:"tensor"},{start:1,name:"boxes",type:"tensor"},{start:2,name:"boxInd",type:"tensor"},{start:3,name:"cropSize",type:"number[]"}],attrs:[{tfName:"method",name:"method",type:"string"},{tfName:"extrapolation_value",name:"extrapolationValue",type:"number"}]},{tfOpName:"ImageProjectiveTransformV3",category:"image",inputs:[{start:0,name:"images",type:"tensor"},{start:1,name:"transforms",type:"tensor"},{start:2,name:"outputShape",type:"number[]"},{start:3,name:"fillValue",type:"number"}],attrs:[{tfName:"interpolation",name:"interpolation",type:"string"},{tfName:"fill_mode",name:"fillMode",type:"string"}]}]},M={__proto__:null,json:[{tfOpName:"Equal",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"NotEqual",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Greater",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"GreaterEqual",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Less",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LessEqual",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LogicalAnd",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LogicalNot",category:"logical",inputs:[{start:0,name:"a",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LogicalOr",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Select",category:"logical",inputs:[{start:0,name:"condition",type:"tensor"},{start:1,name:"a",type:"tensor"},{start:2,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"SelectV2",category:"logical",inputs:[{start:0,name:"condition",type:"tensor"},{start:1,name:"a",type:"tensor"},{start:2,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}]},C={__proto__:null,json:[{tfOpName:"_FusedMatMul",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"},{start:2,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"num_args",name:"numArgs",type:"number"},{tfName:"fused_ops",name:"fusedOps",type:"string[]",defaultValue:[]},{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:1e-4},{tfName:"transpose_a",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"transpose_b",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"leakyrelu_alpha",name:"leakyreluAlpha",type:"number",defaultValue:.2},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MatMul",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"transpose_a",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"transpose_b",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"BatchMatMul",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"adj_x",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"adj_y",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"BatchMatMulV2",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"adj_x",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"adj_y",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Transpose",category:"matrices",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"perm",type:"number[]"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Einsum",category:"matrices",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}],attrs:[{tfName:"equation",name:"equation",type:"string"},{tfName:"N",name:"n",type:"number",defaultValue:2},{tfName:"T",name:"dtype",type:"dtype"}]}]},F={__proto__:null,json:[{tfOpName:"EuclideanNorm",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool",defaultValue:!1}]},{tfOpName:"FusedBatchNorm",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"scale",type:"tensor"},{start:2,name:"offset",type:"tensor"},{start:3,name:"mean",type:"tensor"},{start:4,name:"variance",type:"tensor"}],attrs:[{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:.001},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"FusedBatchNormV2",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"scale",type:"tensor"},{start:2,name:"offset",type:"tensor"},{start:3,name:"mean",type:"tensor"},{start:4,name:"variance",type:"tensor"}],attrs:[{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:.001},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"FusedBatchNormV3",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"scale",type:"tensor"},{start:2,name:"offset",type:"tensor"},{start:3,name:"mean",type:"tensor"},{start:4,name:"variance",type:"tensor"}],attrs:[{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:.001},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"LRN",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"depth_radius",name:"radius",type:"number",defaultValue:5},{tfName:"bias",name:"bias",type:"number",defaultValue:1},{tfName:"alpha",name:"alpha",type:"number",defaultValue:1},{tfName:"beta",name:"beta",type:"number",defaultValue:.5}]},{tfOpName:"Softmax",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"LogSoftmax",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"SparseToDense",category:"normalization",inputs:[{start:0,name:"sparseIndices",type:"tensor"},{start:1,name:"outputShape",type:"number[]"},{start:2,name:"sparseValues",type:"tensor"},{start:3,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"validate_indices",name:"validateIndices",type:"bool",defaultValue:!0,notSupported:!0}]}]},z={__proto__:null,json:[{tfOpName:"Bincount",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"size",type:"number"},{start:2,name:"weights",type:"tensor"}]},{tfOpName:"DenseBincount",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"size",type:"number"},{start:2,name:"weights",type:"tensor"}],attrs:[{tfName:"binary_output",name:"binaryOutput",type:"bool"}]},{tfOpName:"Max",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Mean",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Min",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Sum",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"All",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Any",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"ArgMax",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]},{tfOpName:"ArgMin",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]},{tfOpName:"Prod",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Cumprod",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}],attrs:[{tfName:"exclusive",name:"exclusive",type:"bool"},{tfName:"reverse",name:"reverse",type:"bool"}]},{tfOpName:"Cumsum",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}],attrs:[{tfName:"exclusive",name:"exclusive",type:"bool"},{tfName:"reverse",name:"reverse",type:"bool"}]}]},R={__proto__:null,json:[{tfOpName:"ConcatV2",category:"slice_join",inputs:[{start:0,end:-1,name:"tensors",type:"tensors"},{start:-1,name:"axis",type:"number"}],attrs:[{tfName:"N",name:"n",type:"number",defaultValue:2}]},{tfOpName:"Concat",category:"slice_join",inputs:[{start:1,end:0,name:"tensors",type:"tensors"},{start:0,name:"axis",type:"number"}],attrs:[{tfName:"N",name:"n",type:"number",defaultValue:2}]},{tfOpName:"GatherV2",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"indices",type:"tensor"},{start:2,name:"axis",type:"number",defaultValue:0}],attrs:[{tfName:"batch_dims",name:"batchDims",type:"number",defaultValue:0}]},{tfOpName:"Gather",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"indices",type:"tensor"}],attrs:[{tfName:"validate_indices",name:"validateIndices",type:"bool",notSupported:!0}]},{tfOpName:"Reverse",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"dims",type:"bool[]"}]},{tfOpName:"ReverseV2",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}]},{tfOpName:"Slice",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"begin",type:"number[]"},{start:2,name:"size",type:"number[]"}]},{tfOpName:"StridedSlice",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"begin",type:"number[]"},{start:2,name:"end",type:"number[]"},{start:3,name:"strides",type:"number[]"}],attrs:[{tfName:"begin_mask",name:"beginMask",type:"number",defaultValue:0},{tfName:"end_mask",name:"endMask",type:"number",defaultValue:0},{tfName:"new_axis_mask",name:"newAxisMask",type:"number",defaultValue:0},{tfName:"ellipsis_mask",name:"ellipsisMask",type:"number",defaultValue:0},{tfName:"shrink_axis_mask",name:"shrinkAxisMask",type:"number",defaultValue:0}]},{tfOpName:"Pack",category:"slice_join",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}],attrs:[{tfName:"axis",name:"axis",type:"number",defaultValue:0}]},{tfOpName:"Unpack",category:"slice_join",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"axis",name:"axis",type:"number",defaultValue:0},{tfName:"num",name:"num",type:"number",defaultValue:0,notSupported:!0}]},{tfOpName:"Tile",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"reps",type:"number[]"}]},{tfOpName:"Split",category:"slice_join",inputs:[{start:0,name:"axis",type:"number",defaultValue:0},{start:1,name:"x",type:"tensor"}],attrs:[{tfName:"num_split",name:"numOrSizeSplits",type:"number",defaultValue:1}]},{tfOpName:"SplitV",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"numOrSizeSplits",type:"number[]"},{start:2,name:"axis",type:"number",defaultValue:0}]},{tfOpName:"ScatterNd",category:"slice_join",inputs:[{start:0,name:"indices",type:"tensor"},{start:1,name:"values",type:"tensor"},{start:2,name:"shape",type:"number[]"}]},{tfOpName:"GatherNd",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"indices",type:"tensor"}]},{tfOpName:"SparseToDense",category:"slice_join",inputs:[{start:0,name:"sparseIndices",type:"tensor"},{start:1,name:"outputShape",type:"number[]"},{start:2,name:"sparseValues",type:"tensor"},{start:3,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"validate_indices",name:"validateIndices",type:"bool",defaultValue:!1,notSupported:!0}]}]},V={__proto__:null,json:[{tfOpName:"SparseFillEmptyRows",category:"sparse",inputs:[{start:0,name:"indices",type:"tensor"},{start:1,name:"values",type:"tensor"},{start:2,name:"denseShape",type:"tensor"},{start:3,name:"defaultValue",type:"tensor"}]},{tfOpName:"SparseReshape",category:"sparse",inputs:[{start:0,name:"inputIndices",type:"tensor"},{start:1,name:"inputShape",type:"tensor"},{start:2,name:"newShape",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"SparseSegmentMean",category:"sparse",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"indices",type:"tensor"},{start:2,name:"segmentIds",type:"tensor"}]},{tfOpName:"SparseSegmentSum",category:"sparse",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"indices",type:"tensor"},{start:2,name:"segmentIds",type:"tensor"}]}]},L={__proto__:null,json:[{tfOpName:"FFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"IFFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"RFFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"fft_length",type:"number",notSupported:!0}]},{tfOpName:"IRFFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"fft_length",type:"number",notSupported:!0}]}]},P={__proto__:null,json:[{tfOpName:"StringNGrams",category:"string",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"dataSplits",type:"tensor"}],attrs:[{tfName:"separator",name:"separator",type:"string"},{tfName:"ngram_widths",name:"nGramWidths",type:"number[]"},{tfName:"left_pad",name:"leftPad",type:"string"},{tfName:"right_pad",name:"rightPad",type:"string"},{tfName:"pad_width",name:"padWidth",type:"number"},{tfName:"preserve_short_sequences",name:"preserveShortSequences",type:"bool"}],outputs:["ngrams","ngrams_splits"]},{tfOpName:"StringSplit",category:"string",inputs:[{start:0,name:"input",type:"tensor"},{start:1,name:"delimiter",type:"tensor"}],attrs:[{tfName:"skip_empty",name:"skipEmpty",type:"bool"}],outputs:["indices","values","shape"]},{tfOpName:"StringToHashBucketFast",category:"string",inputs:[{start:0,name:"input",type:"tensor"}],attrs:[{tfName:"num_buckets",name:"numBuckets",type:"number"}]}]},B={__proto__:null,json:[{tfOpName:"Cast",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"SrcT",name:"sdtype",type:"dtype",notSupported:!0},{tfName:"DstT",name:"dtype",type:"dtype"}]},{tfOpName:"ExpandDims",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]},{tfOpName:"MirrorPad",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"padding",type:"number[]"}],attrs:[{tfName:"mode",name:"mode",type:"string"}]},{tfOpName:"Pad",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"padding",type:"number[]"}],attrs:[{tfName:"constant_value",name:"constantValue",type:"number",defaultValue:0}]},{tfOpName:"PadV2",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"padding",type:"number[]"},{start:2,name:"constantValue",type:"number",defaultValue:0}]},{tfOpName:"Reshape",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"shape",type:"number[]"}]},{tfOpName:"Squeeze",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"axis",tfDeprecatedName:"squeeze_dims",name:"axis",type:"number[]"}]},{tfOpName:"SpaceToBatchND",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"blockShape",type:"number[]"},{start:2,name:"paddings",type:"number[]"}]},{tfOpName:"BatchToSpaceND",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"blockShape",type:"number[]"},{start:2,name:"crops",type:"number[]"}]},{tfOpName:"DepthToSpace",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"block_size",name:"blockSize",type:"number"},{tfName:"data_format",name:"dataFormat",type:"string"}]},{tfOpName:"BroadcastTo",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"shape",type:"number[]"}],attrs:[]},{tfOpName:"BroadcastArgs",category:"transformation",inputs:[{start:0,name:"s0",type:"tensor"},{start:1,name:"s1",type:"tensor"}],attrs:[]}]},K=function(){function t(){var t=[w,k,T,_,S,E,I,O,D,A,M,C,F,z,R,V,L,P,B],e=[].concat.apply([],d([],l(t.map((function(t){return t.json}))),!1));this.opMappers=e.reduce((function(t,e){return t[e.tfOpName]=e,t}),{})}return Object.defineProperty(t,"Instance",{get:function(){return this._instance||(this._instance=new this)},enumerable:!1,configurable:!0}),t.prototype.transformGraph=function(t,e){var n=this;void 0===e&&(e={});var r=t.node,a=[],o=[],s=[],i=r.reduce((function(t,e){return t[e.name]=n.mapNode(e),e.op.startsWith("Placeholder")?a.push(t[e.name]):"Const"===e.op?o.push(t[e.name]):null!=e.input&&0!==e.input.length||s.push(t[e.name]),t}),{}),u=[],p=[],c={},d={};null!=e&&(c=this.mapSignatureEntries(e.inputs),d=this.mapSignatureEntries(e.outputs));var h=Object.keys(i);h.forEach((function(t){var e=i[t];e.inputNames.forEach((function(t,n){var r=l(g(t),3),a=r[0],o=r[2],s=i[a];if(null!=s.outputs){var u=s.outputs.indexOf(o);if(-1!==u){var p="".concat(a,":").concat(u);e.inputNames[n]=p}}e.inputs.push(s),s.children.push(e)}))})),0===Object.keys(d).length?h.forEach((function(t){var e=i[t];0===e.children.length&&p.push(e)})):Object.keys(d).forEach((function(t){var e=l(g(t),1)[0],n=i[e];null!=n&&(n.signatureKey=d[t],p.push(n))})),Object.keys(c).length>0?Object.keys(c).forEach((function(t){var e=l(g(t),1)[0],n=i[e];n&&(n.signatureKey=c[t],u.push(n))})):u=a;var f={};null!=t.library&&null!=t.library.function&&(f=t.library.function.reduce((function(t,e){return t[e.signature.name]=n.mapFunction(e),t}),{}));var m={nodes:i,inputs:u,outputs:p,weights:o,placeholders:a,signature:e,functions:f};return s.length>0&&(m.initNodes=s),m},t.prototype.mapSignatureEntries=function(t){return Object.keys(t||{}).reduce((function(e,n){return e[t[n].name]=n,e}),{})},t.prototype.mapNode=function(t){var e=f(t.op)||this.opMappers[t.op]||{};null==t.attr&&(t.attr={});var n={name:t.name,op:t.op,category:e.category,inputNames:(t.input||[]).map((function(t){return t.startsWith("^")?t.slice(1):t})),inputs:[],children:[],inputParams:{},attrParams:{},rawAttrs:t.attr,outputs:e.outputs};return null!=e.inputs&&(n.inputParams=e.inputs.reduce((function(t,e){return t[e.name]={type:e.type,inputIndexStart:e.start,inputIndexEnd:e.end},t}),{})),null!=e.attrs&&(n.attrParams=e.attrs.reduce((function(e,n){var r=n.type,a=void 0;switch(n.type){case"string":void 0===(a=q(t.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=q(t.attr,n.tfDeprecatedName,n.defaultValue));break;case"string[]":void 0===(a=$(t.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=$(t.attr,n.tfDeprecatedName,n.defaultValue));break;case"number":void 0===(a=W(t.attr,n.tfName,n.defaultValue||0))&&n.tfDeprecatedName&&(a=W(t.attr,n.tfDeprecatedName,n.defaultValue));break;case"number[]":void 0===(a=J(t.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=J(t.attr,n.tfDeprecatedName,n.defaultValue));break;case"bool":void 0===(a=U(t.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=U(t.attr,n.tfDeprecatedName,n.defaultValue));break;case"bool[]":void 0===(a=et(t.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=et(t.attr,n.tfDeprecatedName,n.defaultValue));break;case"shape":void 0===(a=X(t.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=X(t.attr,n.tfDeprecatedName,n.defaultValue));break;case"shape[]":void 0===(a=tt(t.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=tt(t.attr,n.tfDeprecatedName,n.defaultValue));break;case"dtype":void 0===(a=Z(t.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=Z(t.attr,n.tfDeprecatedName,n.defaultValue));break;case"dtype[]":void 0===(a=Q(t.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=Q(t.attr,n.tfDeprecatedName,n.defaultValue));break;case"func":void 0===(a=G(t.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=G(t.attr,n.tfDeprecatedName,n.defaultValue));break;case"tensor":case"tensors":break;default:throw new Error("Unsupported param type: ".concat(n.type," for op: ").concat(t.op))}return e[n.name]={value:a,type:r},e}),{})),n},t.prototype.mapFunction=function(t){var e=this,n=t.nodeDef,r=[],a={};null!=n&&(a=n.reduce((function(t,n){return t[n.name]=e.mapNode(n),"Const"===n.op&&r.push(t[n.name]),t}),{}));var o=[],s=[];t.signature.inputArg.forEach((function(t){var e=l(g(t.name),1)[0],n={name:e,op:"Placeholder",inputs:[],inputNames:[],category:"graph",inputParams:{},attrParams:{dtype:{value:H(t.type),type:"dtype"}},children:[]};n.signatureKey=t.name,o.push(n),a[e]=n})),Object.keys(a).forEach((function(t){var e=a[t];e.inputNames.forEach((function(t,n){var r=l(g(t),3),o=r[0],s=r[2],i=a[o];if(null!=i.outputs){var u=i.outputs.indexOf(s);if(-1!==u){var p="".concat(o,":").concat(u);e.inputNames[n]=p}}e.inputs.push(i),i.children.push(e)}))}));var i=t.ret;t.signature.outputArg.forEach((function(t){var e=l(g(i[t.name]),2),n=e[0],r=e[1],o=a[n];null!=o&&(o.defaultOutput=r,s.push(o))}));var u=this.mapArgsToSignature(t);return{nodes:a,inputs:o,outputs:s,weights:r,placeholders:[],signature:u}},t.prototype.mapArgsToSignature=function(t){var e=this;return{methodName:t.signature.name,inputs:t.signature.inputArg.reduce((function(t,n){return t[n.name]=e.mapArgToTensorInfo(n),t}),{}),outputs:t.signature.outputArg.reduce((function(n,r){return n[r.name]=e.mapArgToTensorInfo(r,t.ret),n}),{})}},t.prototype.mapArgToTensorInfo=function(t,e){var n=t.name;return null!=e&&(n=e[n]),{name:n,dtype:t.type}},t}();function j(t,n){var r=Array.isArray(t)?String.fromCharCode.apply(null,t):function(t){var n=e.env().global;if("undefined"!=typeof n.atob)return n.atob(t);if("undefined"!=typeof Buffer)return new Buffer(t,"base64").toString();throw new Error("Unable to decode base64 in this environment. Missing built-in atob() or Buffer()")}(t);return n?r:r.toLowerCase()}function q(t,e,n,r){void 0===r&&(r=!1);var a=t[e];return null!=a?j(a.s,r):n}function U(t,e,n){var r=t[e];return r?r.b:n}function W(t,e,n){var r=t[e]||{},a=null!=r.i?r.i:null!=r.f?r.f:n;return"number"==typeof a?a:parseInt(a,10)}function H(t){switch("string"==typeof t&&(t=o[t]),t){case o.DT_FLOAT:case o.DT_HALF:return"float32";case o.DT_INT32:case o.DT_INT64:case o.DT_INT8:case o.DT_UINT8:return"int32";case o.DT_BOOL:return"bool";case o.DT_DOUBLE:return"float32";case o.DT_STRING:return"string";default:return null}}function G(t,e,n){var r=t[e];return r&&r.func?r.func.name:n}function Z(t,e,n){var r=t[e];return r&&r.type?H(r.type):n}function Q(t,e,n){var r=t[e];return r&&r.list&&r.list.type?r.list.type.map((function(t){return H(t)})):n}function Y(t){if(!t.unknownRank)return null!=t.dim?t.dim.map((function(t){return"number"==typeof t.size?t.size:parseInt(t.size,10)})):[]}function X(t,e,n){var r=t[e];return r&&r.shape?Y(r.shape):n}function J(t,e,n){var r=t[e];return r?((r.list.f&&r.list.f.length?r.list.f:r.list.i)||[]).map((function(t){return"number"==typeof t?t:parseInt(t,10)})):n}function $(t,e,n,r){void 0===r&&(r=!1);var a=t[e];return a&&a.list&&a.list.s?a.list.s.map((function(t){return j(t,r)})):n}function tt(t,e,n){var r=t[e];return r&&r.list&&r.list.shape?r.list.shape.map((function(t){return Y(t)})):n}function et(t,e,n){var r=t[e];return r&&r.list&&r.list.b?r.list.b:n}var nt=function(){function t(t,e,n){var r=this;this.node=t,this.tensorMap=e,this.context=n,this.inputs=[],this.attrs={},this.inputs=t.inputNames.map((function(t){return r.getInput(t)})),null!=t.rawAttrs&&(this.attrs=Object.keys(t.rawAttrs).reduce((function(t,e){return t[e]=r.getAttr(e),t}),{}))}return t.prototype.getInput=function(t){return y(t,this.tensorMap,this.context)},t.prototype.getAttr=function(t,e){var n=this.node.rawAttrs[t];if(null!=n.tensor)return y(t,this.tensorMap,this.context);if(null!=n.i||null!=n.f)return W(this.node.rawAttrs,t,e);if(null!=n.s)return q(this.node.rawAttrs,t,e);if(null!=n.b)return U(this.node.rawAttrs,t,e);if(null!=n.shape)return X(this.node.rawAttrs,t,e);if(null!=n.type)return Z(this.node.rawAttrs,t,e);if(null!=n.list){if(null!=n.list.i||null!=n.list.f)return J(this.node.rawAttrs,t,e);if(null!=n.list.s)return $(this.node.rawAttrs,t,e);if(null!=n.list.shape)return tt(this.node.rawAttrs,t,e);if(null!=n.list.b)return et(this.node.rawAttrs,t,e);if(null!=n.list.type)return Q(this.node.rawAttrs,t,e)}return e},t}(),rt=function(){function t(){}return t.prototype.refCount=function(t){return at("refCount")},t.prototype.incRef=function(t){return at("incRef")},t.prototype.timerAvailable=function(){return!0},t.prototype.time=function(t){return at("time")},t.prototype.read=function(t){return at("read")},t.prototype.readSync=function(t){return at("readSync")},t.prototype.readToGPU=function(t,e){return at("readToGPU")},t.prototype.numDataIds=function(){return at("numDataIds")},t.prototype.disposeData=function(t,e){return at("disposeData")},t.prototype.write=function(t,e,n){return at("write")},t.prototype.move=function(t,e,n,r,a){return at("move")},t.prototype.createTensorFromTexture=function(t,e,n){return at("createTensorFromTexture")},t.prototype.memory=function(){return at("memory")},t.prototype.floatPrecision=function(){return at("floatPrecision")},t.prototype.epsilon=function(){return 32===this.floatPrecision()?1e-7:1e-4},t.prototype.dispose=function(){return at("dispose")},t}();function at(t){throw new Error("'".concat(t,"' not yet implemented or not found in the registry. ")+"This kernel may not be supported by the tfjs backend you have chosen")}function ot(t,e){if(!t)throw new Error("string"==typeof e?e:e())}function st(t,e,n){void 0===n&&(n=""),ot(ct(t,e),(function(){return n+" Shapes ".concat(t," and ").concat(e," must match")}))}function it(t){ot(null!=t,(function(){return"The input to the tensor constructor must be a non-null value."}))}function ut(t,e,n){if(void 0===e&&(e=[]),void 0===n&&(n=!1),null==e&&(e=[]),Array.isArray(t)||ft(t)&&!n)for(var r=0;r<t.length;++r)ut(t[r],e,n);else e.push(t);return e}function pt(t){if(0===t.length)return 1;for(var e=t[0],n=1;n<t.length;n++)e*=t[n];return e}function ct(t,e){if(t===e)return!0;if(null==t||null==e)return!1;if(t.length!==e.length)return!1;for(var n=0;n<t.length;n++)if(t[n]!==e[n])return!1;return!0}function lt(t){return t%1==0}function dt(t,e){return e<=t.length?t:t+" ".repeat(e-t.length)}function ht(t,e){var n=e.length;return ot((t=null==t?e.map((function(t,e){return e})):[].concat(t)).every((function(t){return t>=-n&&t<n})),(function(){return"All values in axis param must be in range [-".concat(n,", ").concat(n,") but ")+"got axis ".concat(t)})),ot(t.every((function(t){return lt(t)})),(function(){return"All values in axis param must be integers but "+"got axis ".concat(t)})),t.map((function(t){return t<0?n+t:t}))}function ft(t){return t instanceof Float32Array||t instanceof Int32Array||t instanceof Uint8Array||t instanceof Uint8ClampedArray}function mt(t){if("float32"===t||"int32"===t)return 4;if("complex64"===t)return 8;if("bool"===t)return 1;throw new Error("Unknown dtype ".concat(t))}function yt(t){return"string"==typeof t||t instanceof String}function gt(t){return Array.isArray(t)?gt(t[0]):t instanceof Float32Array?"float32":t instanceof Int32Array||t instanceof Uint8Array||t instanceof Uint8ClampedArray?"int32":"number"==typeof t?"float32":yt(t)?"string":function(t){return"boolean"==typeof t}(t)?"bool":"float32"}function vt(t){return!!(t&&t.constructor&&t.call&&t.apply)}function bt(t){var e=t.length;if(e<2)return[];var n=new Array(e-1);n[e-2]=t[e-1];for(var r=e-3;r>=0;--r)n[r]=n[r+1]*t[r+1];return n}function xt(t,e,n,r){void 0===r&&(r=!1);var a=new Array;if(1===e.length)for(var o=e[0]*(r?2:1),s=0;s<o;s++)a[s]=n[t+s];else{o=e[0];var i=e.slice(1),u=i.reduce((function(t,e){return t*e}))*(r?2:1);for(s=0;s<o;s++)a[s]=xt(t+s*u,i,n,r)}return a}function Nt(t,e,n){if(void 0===n&&(n=!1),0===t.length)return e[0];var r=t.reduce((function(t,e){return t*e}))*(n?2:1);if(0===r)return[];if(r!==e.length)throw new Error("[".concat(t,"] does not match the input size ").concat(e.length).concat(n?" for a complex tensor":"","."));return xt(0,t,e,n)}function wt(t,e){for(var n=kt(t,e),r=0;r<n.length;r++)n[r]=1;return n}function kt(t,e){if(null==e||"float32"===e||"complex64"===e)return new Float32Array(t);if("int32"===e)return new Int32Array(t);if("bool"===e)return new Uint8Array(t);throw new Error("Unknown data type ".concat(e))}function Tt(t){t.forEach((function(e){ot(Number.isInteger(e)&&e>=0,(function(){return"Tensor must have a shape comprised of positive integers but got "+"shape [".concat(t,"].")}))}))}function _t(t){return t&&t.then&&"function"==typeof t.then}var St="tfjsflags",Et=function(){function t(t){this.global=t,this.flags={},this.flagRegistry={},this.urlFlags={},this.getQueryParams=It,this.populateURLFlags()}return t.prototype.setPlatform=function(t,e){null!=this.platform&&(Dt().getBool("IS_TEST")||Dt().getBool("PROD")||console.warn("Platform ".concat(this.platformName," has already been set. ")+"Overwriting the platform with ".concat(t,"."))),this.platformName=t,this.platform=e},t.prototype.registerFlag=function(t,e,n){if(this.flagRegistry[t]={evaluationFn:e,setHook:n},null!=this.urlFlags[t]){var r=this.urlFlags[t];Dt().getBool("IS_TEST")||Dt().getBool("PROD")||console.warn("Setting feature override from URL ".concat(t,": ").concat(r,".")),this.set(t,r)}},t.prototype.getAsync=function(t){return u(this,void 0,void 0,(function(){var e,n;return p(this,(function(r){switch(r.label){case 0:return t in this.flags?[2,this.flags[t]]:(e=this.flags,n=t,[4,this.evaluateFlag(t)]);case 1:return e[n]=r.sent(),[2,this.flags[t]]}}))}))},t.prototype.get=function(t){if(t in this.flags)return this.flags[t];var e=this.evaluateFlag(t);if(_t(e))throw new Error("Flag ".concat(t," cannot be synchronously evaluated. ")+"Please use getAsync() instead.");return this.flags[t]=e,this.flags[t]},t.prototype.getNumber=function(t){return this.get(t)},t.prototype.getBool=function(t){return this.get(t)},t.prototype.getFlags=function(){return this.flags},Object.defineProperty(t.prototype,"features",{get:function(){return this.flags},enumerable:!1,configurable:!0}),t.prototype.set=function(t,e){if(null==this.flagRegistry[t])throw new Error("Cannot set flag ".concat(t," as it has not been registered."));this.flags[t]=e,null!=this.flagRegistry[t].setHook&&this.flagRegistry[t].setHook(e)},t.prototype.evaluateFlag=function(t){if(null==this.flagRegistry[t])throw new Error("Cannot evaluate flag '".concat(t,"': no evaluation function found."));return this.flagRegistry[t].evaluationFn()},t.prototype.setFlags=function(t){this.flags=Object.assign({},t)},t.prototype.reset=function(){this.flags={},this.urlFlags={},this.populateURLFlags()},t.prototype.populateURLFlags=function(){var t=this;if("undefined"!=typeof this.global&&"undefined"!=typeof this.global.location&&"undefined"!=typeof this.global.location.search){var e=this.getQueryParams(this.global.location.search);if(St in e)e.tfjsflags.split(",").forEach((function(e){var n=l(e.split(":"),2),r=n[0],a=n[1];t.urlFlags[r]=function(t,e){if("true"===(e=e.toLowerCase())||"false"===e)return"true"===e;if("".concat(+e)===e)return+e;throw new Error("Could not parse value flag value ".concat(e," for flag ").concat(t,"."))}(r,a)}))}},t}();function It(t){var e={};return t.replace(/[?&]([^=?&]+)(?:=([^&]*))?/g,(function(t){for(var n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];return Ot(e,n[0],n[1]),n.join("=")})),e}function Ot(t,e,n){t[decodeURIComponent(e)]=decodeURIComponent(n||"")}function Dt(){return Mt}var At,Mt=null;function Ct(){if(null==At){var t=void 0;if("undefined"!=typeof window)t=window;else if("undefined"!=typeof global)t=global;else if("undefined"!=typeof process)t=process;else{if("undefined"==typeof self)throw new Error("Could not find a global object");t=self}At=t}return At}function Ft(t,e){var n,r=(null==(n=Ct())._tfGlobals&&(n._tfGlobals=new Map),n._tfGlobals);if(r.has(t))return r.get(t);var a=e();return r.set(t,a),r.get(t)}var zt="Cast",Rt="Einsum",Vt="Identity",Lt="Tile",Pt="Transpose",Bt="_FusedMatMul",Kt="FusedConv2D",jt="FusedDepthwiseConv2D";function qt(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];Dt().getBool("IS_TEST")||Dt().getBool("PROD")||console.warn.apply(console,d([],l(t),!1))}var Ut=Ft("kernelRegistry",(function(){return new Map})),Wt=Ft("gradRegistry",(function(){return new Map}));function Ht(t,e){var n=function(t,e){return"".concat(e,"_").concat(t)}(t,e);return Ut.get(n)}function Gt(t){return Wt.get(t)}function Zt(t){for(var e=Ut.entries(),n=[];;){var r=e.next(),a=r.done,o=r.value;if(a)break;var s=l(o,2),i=s[0],u=s[1];l(i.split("_"),1)[0]===t&&n.push(u)}return n}var Qt=Xt,Yt=null;try{Yt=new WebAssembly.Instance(new WebAssembly.Module(new Uint8Array([0,97,115,109,1,0,0,0,1,13,2,96,0,1,127,96,4,127,127,127,127,1,127,3,7,6,0,1,1,1,1,1,6,6,1,127,1,65,0,11,7,50,6,3,109,117,108,0,1,5,100,105,118,95,115,0,2,5,100,105,118,95,117,0,3,5,114,101,109,95,115,0,4,5,114,101,109,95,117,0,5,8,103,101,116,95,104,105,103,104,0,0,10,191,1,6,4,0,35,0,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,126,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,127,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,128,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,129,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,130,34,4,66,32,135,167,36,0,32,4,167,11])),{}).exports}catch(t){}function Xt(t,e,n){this.low=0|t,this.high=0|e,this.unsigned=!!n}function Jt(t){return!0===(t&&t.__isLong__)}Xt.prototype.__isLong__,Object.defineProperty(Xt.prototype,"__isLong__",{value:!0}),Xt.isLong=Jt;var $t={},te={};function ee(t,e){var n,r,a;return e?(a=0<=(t>>>=0)&&t<256)&&(r=te[t])?r:(n=re(t,(0|t)<0?-1:0,!0),a&&(te[t]=n),n):(a=-128<=(t|=0)&&t<128)&&(r=$t[t])?r:(n=re(t,t<0?-1:0,!1),a&&($t[t]=n),n)}function ne(t,e){if(isNaN(t))return e?de:le;if(e){if(t<0)return de;if(t>=ue)return ge}else{if(t<=-pe)return ve;if(t+1>=pe)return ye}return t<0?ne(-t,e).neg():re(t%ie|0,t/ie|0,e)}function re(t,e,n){return new Xt(t,e,n)}Xt.fromInt=ee,Xt.fromNumber=ne,Xt.fromBits=re;var ae=Math.pow;function oe(t,e,n){if(0===t.length)throw Error("empty string");if("NaN"===t||"Infinity"===t||"+Infinity"===t||"-Infinity"===t)return le;if("number"==typeof e?(n=e,e=!1):e=!!e,(n=n||10)<2||36<n)throw RangeError("radix");var r;if((r=t.indexOf("-"))>0)throw Error("interior hyphen");if(0===r)return oe(t.substring(1),e,n).neg();for(var a=ne(ae(n,8)),o=le,s=0;s<t.length;s+=8){var i=Math.min(8,t.length-s),u=parseInt(t.substring(s,s+i),n);if(i<8){var p=ne(ae(n,i));o=o.mul(p).add(ne(u))}else o=(o=o.mul(a)).add(ne(u))}return o.unsigned=e,o}function se(t,e){return"number"==typeof t?ne(t,e):"string"==typeof t?oe(t,e):re(t.low,t.high,"boolean"==typeof e?e:t.unsigned)}Xt.fromString=oe,Xt.fromValue=se;var ie=4294967296,ue=ie*ie,pe=ue/2,ce=ee(1<<24),le=ee(0);Xt.ZERO=le;var de=ee(0,!0);Xt.UZERO=de;var he=ee(1);Xt.ONE=he;var fe=ee(1,!0);Xt.UONE=fe;var me=ee(-1);Xt.NEG_ONE=me;var ye=re(-1,2147483647,!1);Xt.MAX_VALUE=ye;var ge=re(-1,-1,!0);Xt.MAX_UNSIGNED_VALUE=ge;var ve=re(0,-2147483648,!1);Xt.MIN_VALUE=ve;var be=Xt.prototype;be.toInt=function(){return this.unsigned?this.low>>>0:this.low},be.toNumber=function(){return this.unsigned?(this.high>>>0)*ie+(this.low>>>0):this.high*ie+(this.low>>>0)},be.toString=function(t){if((t=t||10)<2||36<t)throw RangeError("radix");if(this.isZero())return"0";if(this.isNegative()){if(this.eq(ve)){var e=ne(t),n=this.div(e),r=n.mul(e).sub(this);return n.toString(t)+r.toInt().toString(t)}return"-"+this.neg().toString(t)}for(var a=ne(ae(t,6),this.unsigned),o=this,s="";;){var i=o.div(a),u=(o.sub(i.mul(a)).toInt()>>>0).toString(t);if((o=i).isZero())return u+s;for(;u.length<6;)u="0"+u;s=""+u+s}},be.getHighBits=function(){return this.high},be.getHighBitsUnsigned=function(){return this.high>>>0},be.getLowBits=function(){return this.low},be.getLowBitsUnsigned=function(){return this.low>>>0},be.getNumBitsAbs=function(){if(this.isNegative())return this.eq(ve)?64:this.neg().getNumBitsAbs();for(var t=0!=this.high?this.high:this.low,e=31;e>0&&0==(t&1<<e);e--);return 0!=this.high?e+33:e+1},be.isZero=function(){return 0===this.high&&0===this.low},be.eqz=be.isZero,be.isNegative=function(){return!this.unsigned&&this.high<0},be.isPositive=function(){return this.unsigned||this.high>=0},be.isOdd=function(){return 1==(1&this.low)},be.isEven=function(){return 0==(1&this.low)},be.equals=function(t){return Jt(t)||(t=se(t)),(this.unsigned===t.unsigned||this.high>>>31!=1||t.high>>>31!=1)&&(this.high===t.high&&this.low===t.low)},be.eq=be.equals,be.notEquals=function(t){return!this.eq(t)},be.neq=be.notEquals,be.ne=be.notEquals,be.lessThan=function(t){return this.comp(t)<0},be.lt=be.lessThan,be.lessThanOrEqual=function(t){return this.comp(t)<=0},be.lte=be.lessThanOrEqual,be.le=be.lessThanOrEqual,be.greaterThan=function(t){return this.comp(t)>0},be.gt=be.greaterThan,be.greaterThanOrEqual=function(t){return this.comp(t)>=0},be.gte=be.greaterThanOrEqual,be.ge=be.greaterThanOrEqual,be.compare=function(t){if(Jt(t)||(t=se(t)),this.eq(t))return 0;var e=this.isNegative(),n=t.isNegative();return e&&!n?-1:!e&&n?1:this.unsigned?t.high>>>0>this.high>>>0||t.high===this.high&&t.low>>>0>this.low>>>0?-1:1:this.sub(t).isNegative()?-1:1},be.comp=be.compare,be.negate=function(){return!this.unsigned&&this.eq(ve)?ve:this.not().add(he)},be.neg=be.negate,be.add=function(t){Jt(t)||(t=se(t));var e=this.high>>>16,n=65535&this.high,r=this.low>>>16,a=65535&this.low,o=t.high>>>16,s=65535&t.high,i=t.low>>>16,u=0,p=0,c=0,l=0;return c+=(l+=a+(65535&t.low))>>>16,p+=(c+=r+i)>>>16,u+=(p+=n+s)>>>16,u+=e+o,re((c&=65535)<<16|(l&=65535),(u&=65535)<<16|(p&=65535),this.unsigned)},be.subtract=function(t){return Jt(t)||(t=se(t)),this.add(t.neg())},be.sub=be.subtract,be.multiply=function(t){if(this.isZero())return le;if(Jt(t)||(t=se(t)),Yt)return re(Yt.mul(this.low,this.high,t.low,t.high),Yt.get_high(),this.unsigned);if(t.isZero())return le;if(this.eq(ve))return t.isOdd()?ve:le;if(t.eq(ve))return this.isOdd()?ve:le;if(this.isNegative())return t.isNegative()?this.neg().mul(t.neg()):this.neg().mul(t).neg();if(t.isNegative())return this.mul(t.neg()).neg();if(this.lt(ce)&&t.lt(ce))return ne(this.toNumber()*t.toNumber(),this.unsigned);var e=this.high>>>16,n=65535&this.high,r=this.low>>>16,a=65535&this.low,o=t.high>>>16,s=65535&t.high,i=t.low>>>16,u=65535&t.low,p=0,c=0,l=0,d=0;return l+=(d+=a*u)>>>16,c+=(l+=r*u)>>>16,l&=65535,c+=(l+=a*i)>>>16,p+=(c+=n*u)>>>16,c&=65535,p+=(c+=r*i)>>>16,c&=65535,p+=(c+=a*s)>>>16,p+=e*u+n*i+r*s+a*o,re((l&=65535)<<16|(d&=65535),(p&=65535)<<16|(c&=65535),this.unsigned)},be.mul=be.multiply,be.divide=function(t){if(Jt(t)||(t=se(t)),t.isZero())throw Error("division by zero");var e,n,r;if(Yt)return this.unsigned||-2147483648!==this.high||-1!==t.low||-1!==t.high?re((this.unsigned?Yt.div_u:Yt.div_s)(this.low,this.high,t.low,t.high),Yt.get_high(),this.unsigned):this;if(this.isZero())return this.unsigned?de:le;if(this.unsigned){if(t.unsigned||(t=t.toUnsigned()),t.gt(this))return de;if(t.gt(this.shru(1)))return fe;r=de}else{if(this.eq(ve))return t.eq(he)||t.eq(me)?ve:t.eq(ve)?he:(e=this.shr(1).div(t).shl(1)).eq(le)?t.isNegative()?he:me:(n=this.sub(t.mul(e)),r=e.add(n.div(t)));if(t.eq(ve))return this.unsigned?de:le;if(this.isNegative())return t.isNegative()?this.neg().div(t.neg()):this.neg().div(t).neg();if(t.isNegative())return this.div(t.neg()).neg();r=le}for(n=this;n.gte(t);){e=Math.max(1,Math.floor(n.toNumber()/t.toNumber()));for(var a=Math.ceil(Math.log(e)/Math.LN2),o=a<=48?1:ae(2,a-48),s=ne(e),i=s.mul(t);i.isNegative()||i.gt(n);)i=(s=ne(e-=o,this.unsigned)).mul(t);s.isZero()&&(s=he),r=r.add(s),n=n.sub(i)}return r},be.div=be.divide,be.modulo=function(t){return Jt(t)||(t=se(t)),Yt?re((this.unsigned?Yt.rem_u:Yt.rem_s)(this.low,this.high,t.low,t.high),Yt.get_high(),this.unsigned):this.sub(this.div(t).mul(t))},be.mod=be.modulo,be.rem=be.modulo,be.not=function(){return re(~this.low,~this.high,this.unsigned)},be.and=function(t){return Jt(t)||(t=se(t)),re(this.low&t.low,this.high&t.high,this.unsigned)},be.or=function(t){return Jt(t)||(t=se(t)),re(this.low|t.low,this.high|t.high,this.unsigned)},be.xor=function(t){return Jt(t)||(t=se(t)),re(this.low^t.low,this.high^t.high,this.unsigned)},be.shiftLeft=function(t){return Jt(t)&&(t=t.toInt()),0==(t&=63)?this:t<32?re(this.low<<t,this.high<<t|this.low>>>32-t,this.unsigned):re(0,this.low<<t-32,this.unsigned)},be.shl=be.shiftLeft,be.shiftRight=function(t){return Jt(t)&&(t=t.toInt()),0==(t&=63)?this:t<32?re(this.low>>>t|this.high<<32-t,this.high>>t,this.unsigned):re(this.high>>t-32,this.high>=0?0:-1,this.unsigned)},be.shr=be.shiftRight,be.shiftRightUnsigned=function(t){if(Jt(t)&&(t=t.toInt()),0===(t&=63))return this;var e=this.high;return t<32?re(this.low>>>t|e<<32-t,e>>>t,this.unsigned):re(32===t?e:e>>>t-32,0,this.unsigned)},be.shru=be.shiftRightUnsigned,be.shr_u=be.shiftRightUnsigned,be.toSigned=function(){return this.unsigned?re(this.low,this.high,!1):this},be.toUnsigned=function(){return this.unsigned?this:re(this.low,this.high,!0)},be.toBytes=function(t){return t?this.toBytesLE():this.toBytesBE()},be.toBytesLE=function(){var t=this.high,e=this.low;return[255&e,e>>>8&255,e>>>16&255,e>>>24,255&t,t>>>8&255,t>>>16&255,t>>>24]},be.toBytesBE=function(){var t=this.high,e=this.low;return[t>>>24,t>>>16&255,t>>>8&255,255&t,e>>>24,e>>>16&255,e>>>8&255,255&e]},Xt.fromBytes=function(t,e,n){return n?Xt.fromBytesLE(t,e):Xt.fromBytesBE(t,e)},Xt.fromBytesLE=function(t,e){return new Xt(t[0]|t[1]<<8|t[2]<<16|t[3]<<24,t[4]|t[5]<<8|t[6]<<16|t[7]<<24,e)},Xt.fromBytesBE=function(t,e){return new Xt(t[4]<<24|t[5]<<16|t[6]<<8|t[7],t[0]<<24|t[1]<<16|t[2]<<8|t[3],e)};var xe=Qt||r({__proto__:null,default:Qt},[Qt]);function Ne(t){return xe.fromString(t,!0,16)}function we(t,e){if("string"===e)throw new Error("Cannot convert a string[] to a TypedArray");if(Array.isArray(t)&&(t=ut(t)),Dt().getBool("DEBUG")&&function(t,e){for(var n=0;n<t.length;n++){var r=t[n];if(isNaN(r)||!isFinite(r))throw Error("A tensor of type ".concat(e," being uploaded contains ").concat(r,"."))}}(t,e),function(t,e){return t instanceof Float32Array&&"float32"===e||t instanceof Int32Array&&"int32"===e||t instanceof Uint8Array&&"bool"===e}(t,e))return t;if(null==e||"float32"===e||"complex64"===e)return new Float32Array(t);if("int32"===e)return new Int32Array(t);if("bool"===e){for(var n=new Uint8Array(t.length),r=0;r<n.length;++r)0!==Math.round(t[r])&&(n[r]=1);return n}throw new Error("Unknown data type ".concat(e))}function ke(){return Dt().platform.now()}function Te(t,e){return void 0===e&&(e="utf-8"),e=e||"utf-8",Dt().platform.decode(t,e)}Ne("c3a5c85c97cb3127"),Ne("b492b66fbe98f273"),Ne("9ae16a3b2f90404f");var _e=function(){function t(t,e){this.backendTimer=t,this.logger=e,null==e&&(this.logger=new Se)}return t.prototype.profileKernel=function(t,e,n){var r,a,o,s,i=function(){o=n()},u=ke();if(this.backendTimer.timerAvailable())s=this.backendTimer.time(i);else{i();try{for(var p=c(o),l=p.next();!l.done;l=p.next()){l.value.dataSync()}}catch(t){r={error:t}}finally{try{l&&!l.done&&(a=p.return)&&a.call(p)}finally{if(r)throw r.error}}s=Promise.resolve({kernelMs:ke()-u})}if(Dt().getBool("CHECK_COMPUTATION_FOR_ERRORS"))for(var d=function(e){var n=o[e];n.data().then((function(e){!function(t,e,n){if("float32"!==e)return!1;for(var r=0;r<t.length;r++){var a=t[r];if(isNaN(a)||!isFinite(a))return console.warn("Found ".concat(a," in the result of '").concat(n,"'")),!0}}(e,n.dtype,t)}))},h=0;h<o.length;h++)d(h);return{kernelName:t,outputs:o,inputs:e,timeMs:s.then((function(t){return t.kernelMs})),extraInfo:s.then((function(t){return null!=t.getExtraProfileInfo?t.getExtraProfileInfo():""}))}},t.prototype.logKernelProfile=function(t){var e=this,n=t.kernelName,r=t.outputs,a=t.timeMs,o=t.inputs,s=t.extraInfo;r.forEach((function(t){Promise.all([t.data(),a,s]).then((function(r){e.logger.logKernelProfile(n,t,r[0],r[1],o,r[2])}))}))},t}();var Se=function(){function t(){}return t.prototype.logKernelProfile=function(t,e,n,r,a,o){var s="number"==typeof r?dt("".concat(r,"ms"),9):r.error,i=dt(t,25),u=e.rank,p=e.size,c=dt(e.shape.toString(),14),l="";for(var d in a){var h=a[d];if(null!=h){var f=h.shape||e.shape,m=f.length;l+="".concat(d,": ").concat(m,"D ").concat(m>0?f:""," ")}}console.log("%c".concat(i,"\t%c").concat(s,"\t%c").concat(u,"D ").concat(c,"\t%c").concat(p,"\t%c").concat(l,"\t%c").concat(o),"font-weight:bold","color:red","color:blue","color: orange","color: green","color: steelblue")},t}();function Ee(t,e,n,r){var a=bt(e),o=function(t,e,n,r){var a=pt(e),o=r[r.length-1],s=new Array(o).fill(0),i=e.length,u="complex64"===n?Ae(t):t;if(i>1)for(var p=0;p<a/o;p++)for(var c=p*o,l=0;l<o;l++)s[l]=Math.max(s[l],Ie(u[c+l],0,n).length);return s}(t,e,n,a),s=e.length,i=De(t,e,n,a,o),u=["Tensor"];return r&&(u.push("  dtype: ".concat(n)),u.push("  rank: ".concat(s)),u.push("  shape: [".concat(e,"]")),u.push("  values:")),u.push(i.map((function(t){return"    "+t})).join("\n")),u.join("\n")}function Ie(t,e,n){return dt(Array.isArray(t)?"".concat(parseFloat(t[0].toFixed(7))," + ")+"".concat(parseFloat(t[1].toFixed(7)),"j"):yt(t)?"'".concat(t,"'"):"bool"===n?Oe(t):parseFloat(t.toFixed(7)).toString(),e)}function Oe(t){return 0===t?"false":"true"}function De(t,e,n,r,a,o){void 0===o&&(o=!0);var s="complex64"===n?2:1,i=e[0],u=e.length;if(0===u)return"complex64"===n?[Ie(Ae(t)[0],0,n)]:"bool"===n?[Oe(t[0])]:[t[0].toString()];if(1===u){if(i>20){var p=3*s,c=Array.from(t.slice(0,p)),h=Array.from(t.slice((i-3)*s,i*s));return"complex64"===n&&(c=Ae(c),h=Ae(h)),["["+c.map((function(t,e){return Ie(t,a[e],n)})).join(", ")+", ..., "+h.map((function(t,e){return Ie(t,a[i-3+e],n)})).join(", ")+"]"]}return["["+("complex64"===n?Ae(t):Array.from(t)).map((function(t,e){return Ie(t,a[e],n)})).join(", ")+"]"]}var f=e.slice(1),m=r.slice(1),y=r[0]*s,g=[];if(i>20){for(var v=0;v<3;v++){var b=(x=v*y)+y;g.push.apply(g,d([],l(De(t.slice(x,b),f,n,m,a,!1)),!1))}g.push("...");for(v=i-3;v<i;v++){b=(x=v*y)+y;g.push.apply(g,d([],l(De(t.slice(x,b),f,n,m,a,v===i-1)),!1))}}else for(v=0;v<i;v++){var x;b=(x=v*y)+y;g.push.apply(g,d([],l(De(t.slice(x,b),f,n,m,a,v===i-1)),!1))}var N=2===u?",":"";g[0]="["+g[0]+N;for(v=1;v<g.length-1;v++)g[v]=" "+g[v]+N;var w=",\n";for(v=2;v<u;v++)w+="\n";return g[g.length-1]=" "+g[g.length-1]+"]"+(o?"":w),g}function Ae(t){for(var e=[],n=0;n<t.length;n+=2)e.push([t[n],t[n+1]]);return e}var Me=function(){function t(t,e,n){var r=this;if(this.dtype=e,this.shape=t.slice(),this.size=pt(t),null!=n){var a=n.length;ot(a===this.size,(function(){return"Length of values '".concat(a,"' does not match the size ")+"inferred by the shape '".concat(r.size,"'.")}))}if("complex64"===e)throw new Error("complex64 dtype TensorBuffers are not supported. Please create a TensorBuffer for the real and imaginary parts separately and call tf.complex(real, imag).");this.values=n||function(t,e){var n=null;if(null==t||"float32"===t)n=new Float32Array(e);else if("int32"===t)n=new Int32Array(e);else if("bool"===t)n=new Uint8Array(e);else{if("string"!==t)throw new Error("Unknown data type ".concat(t));n=new Array(e)}return n}(e,this.size),this.strides=bt(t)}return t.prototype.set=function(t){for(var e=this,n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];0===n.length&&(n=[0]),ot(n.length===this.rank,(function(){return"The number of provided coordinates (".concat(n.length,") must ")+"match the rank (".concat(e.rank,")")}));var a=this.locToIndex(n);this.values[a]=t},t.prototype.get=function(){for(var t,e,n=[],r=0;r<arguments.length;r++)n[r]=arguments[r];0===n.length&&(n=[0]);var a=0;try{for(var o=c(n),s=o.next();!s.done;s=o.next()){var i=s.value;if(i<0||i>=this.shape[a]){var u="Requested out of range element at ".concat(n,". ")+"  Buffer shape=".concat(this.shape);throw new Error(u)}a++}}catch(e){t={error:e}}finally{try{s&&!s.done&&(e=o.return)&&e.call(o)}finally{if(t)throw t.error}}for(var p=n[n.length-1],l=0;l<n.length-1;++l)p+=this.strides[l]*n[l];return this.values[p]},t.prototype.locToIndex=function(t){if(0===this.rank)return 0;if(1===this.rank)return t[0];for(var e=t[t.length-1],n=0;n<t.length-1;++n)e+=this.strides[n]*t[n];return e},t.prototype.indexToLoc=function(t){if(0===this.rank)return[];if(1===this.rank)return[t];for(var e=new Array(this.shape.length),n=0;n<e.length-1;++n)e[n]=Math.floor(t/this.strides[n]),t-=e[n]*this.strides[n];return e[e.length-1]=t,e},Object.defineProperty(t.prototype,"rank",{get:function(){return this.shape.length},enumerable:!1,configurable:!0}),t.prototype.toTensor=function(){return Ce().makeTensor(this.values,this.shape,this.dtype)},t}(),Ce=null,Fe=null;var ze=function(){function t(t,e,n,r){this.kept=!1,this.isDisposedInternal=!1,this.shape=t.slice(),this.dtype=e||"float32",this.size=pt(t),this.strides=bt(t),this.dataId=n,this.id=r,this.rankType=this.rank<5?this.rank.toString():"higher"}return Object.defineProperty(t.prototype,"rank",{get:function(){return this.shape.length},enumerable:!1,configurable:!0}),t.prototype.buffer=function(){return u(this,void 0,void 0,(function(){var t;return p(this,(function(e){switch(e.label){case 0:return[4,this.data()];case 1:return t=e.sent(),[2,Fe.buffer(this.shape,this.dtype,t)]}}))}))},t.prototype.bufferSync=function(){return Fe.buffer(this.shape,this.dtype,this.dataSync())},t.prototype.array=function(){return u(this,void 0,void 0,(function(){var t;return p(this,(function(e){switch(e.label){case 0:return[4,this.data()];case 1:return t=e.sent(),[2,Nt(this.shape,t,"complex64"===this.dtype)]}}))}))},t.prototype.arraySync=function(){return Nt(this.shape,this.dataSync(),"complex64"===this.dtype)},t.prototype.data=function(){return u(this,void 0,void 0,(function(){var t,e;return p(this,(function(n){switch(n.label){case 0:return this.throwIfDisposed(),t=Ce().read(this.dataId),"string"!==this.dtype?[3,2]:[4,t];case 1:e=n.sent();try{return[2,e.map((function(t){return Te(t)}))]}catch(t){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}n.label=2;case 2:return[2,t]}}))}))},t.prototype.dataToGPU=function(t){return this.throwIfDisposed(),Ce().readToGPU(this.dataId,t)},t.prototype.dataSync=function(){this.throwIfDisposed();var t=Ce().readSync(this.dataId);if("string"===this.dtype)try{return t.map((function(t){return Te(t)}))}catch(t){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}return t},t.prototype.bytes=function(){return u(this,void 0,void 0,(function(){var t;return p(this,(function(e){switch(e.label){case 0:return this.throwIfDisposed(),[4,Ce().read(this.dataId)];case 1:return t=e.sent(),"string"===this.dtype?[2,t]:[2,new Uint8Array(t.buffer)]}}))}))},t.prototype.dispose=function(){this.isDisposed||(Ce().disposeTensor(this),this.isDisposedInternal=!0)},Object.defineProperty(t.prototype,"isDisposed",{get:function(){return this.isDisposedInternal},enumerable:!1,configurable:!0}),t.prototype.throwIfDisposed=function(){if(this.isDisposed)throw new Error("Tensor is disposed.")},t.prototype.print=function(t){return void 0===t&&(t=!1),Fe.print(this,t)},t.prototype.clone=function(){return this.throwIfDisposed(),Fe.clone(this)},t.prototype.toString=function(t){return void 0===t&&(t=!1),Ee(this.dataSync(),this.shape,this.dtype,t)},t.prototype.cast=function(t){return this.throwIfDisposed(),Fe.cast(this,t)},t.prototype.variable=function(t,e,n){return void 0===t&&(t=!0),this.throwIfDisposed(),Ce().makeVariable(this,t,e,n)},t}();Object.defineProperty(ze,Symbol.hasInstance,{value:function(t){return!!t&&null!=t.data&&null!=t.dataSync&&null!=t.throwIfDisposed}}),Ft("Tensor",(function(){return ze}));var Re,Ve,Le,Pe,Be,Ke=function(t){function e(e,n,r,a){var o=t.call(this,e.shape,e.dtype,e.dataId,a)||this;return o.trainable=n,o.name=r,o}return function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Class extends value "+String(e)+" is not a constructor or null");function n(){this.constructor=t}i(t,e),t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)}(e,t),e.prototype.assign=function(t){if(t.dtype!==this.dtype)throw new Error("dtype of the new value (".concat(t.dtype,") and ")+"previous value (".concat(this.dtype,") must match"));if(!ct(t.shape,this.shape))throw new Error("shape of the new value (".concat(t.shape,") and ")+"previous value (".concat(this.shape,") must match"));Ce().disposeTensor(this),this.dataId=t.dataId,Ce().incRef(this,null)},e.prototype.dispose=function(){Ce().disposeVariable(this),this.isDisposedInternal=!0},e}(ze);Object.defineProperty(Ke,Symbol.hasInstance,{value:function(t){return t instanceof ze&&null!=t.assign&&t.assign instanceof Function}}),function(t){t.R0="R0",t.R1="R1",t.R2="R2",t.R3="R3",t.R4="R4",t.R5="R5",t.R6="R6"}(Re||(Re={})),function(t){t.float32="float32",t.int32="int32",t.bool="int32",t.complex64="complex64"}(Ve||(Ve={})),function(t){t.float32="float32",t.int32="int32",t.bool="bool",t.complex64="complex64"}(Le||(Le={})),function(t){t.float32="float32",t.int32="float32",t.bool="float32",t.complex64="complex64"}(Pe||(Pe={})),function(t){t.float32="complex64",t.int32="complex64",t.bool="complex64",t.complex64="complex64"}(Be||(Be={}));var je={float32:Pe,int32:Ve,bool:Le,complex64:Be};function qe(t,e){if(t.dtype===e.dtype)return[t,e];var n=function(t,e){if("string"===t||"string"===e){if("string"===t&&"string"===e)return"string";throw new Error("Can not upcast ".concat(t," with ").concat(e))}return je[t][e]}(t.dtype,e.dtype);return[t.cast(n),e.cast(n)]}function Ue(t){var e=[];return We(t,e,new Set),e}function We(t,e,n){if(null!=t)if(t instanceof ze)e.push(t);else if(r=t,Array.isArray(r)||"object"==typeof r){var r,a=t;for(var o in a){var s=a[o];n.has(s)||(n.add(s),We(s,e,n))}}}function He(t){return null!=t.kernelName}var Ge=function(){function t(){this.registeredVariables={},this.nextTapeNodeId=0,this.numBytes=0,this.numTensors=0,this.numStringTensors=0,this.numDataBuffers=0,this.gradientDepth=0,this.kernelDepth=0,this.scopeStack=[],this.numDataMovesStack=[],this.nextScopeId=0,this.tensorInfo=new WeakMap,this.profiling=!1,this.activeProfile={newBytes:0,newTensors:0,peakBytes:0,kernels:[],result:null,get kernelNames(){return Array.from(new Set(this.kernels.map((function(t){return t.name}))))}}}return t.prototype.dispose=function(){for(var t in this.registeredVariables)this.registeredVariables[t].dispose()},t}(),Ze=function(){function t(t){this.ENV=t,this.registry={},this.registryFactory={},this.pendingBackendInitId=0,this.state=new Ge}return t.prototype.ready=function(){return u(this,void 0,void 0,(function(){var t,e,n;return p(this,(function(r){switch(r.label){case 0:if(null!=this.pendingBackendInit)return[2,this.pendingBackendInit.then((function(){}))];if(null!=this.backendInstance)return[2];t=this.getSortedBackends(),e=0,r.label=1;case 1:return e<t.length?(n=t[e],[4,this.initializeBackend(n).success]):[3,5];case 2:return r.sent()?[4,this.setBackend(n)]:[3,4];case 3:return r.sent(),[2];case 4:return e++,[3,1];case 5:throw new Error("Could not initialize any backends, all backend initializations failed.")}}))}))},Object.defineProperty(t.prototype,"backend",{get:function(){if(null!=this.pendingBackendInit)throw new Error("Backend '".concat(this.backendName,"' has not yet been initialized. Make ")+"sure to await tf.ready() or await tf.setBackend() before calling other methods");if(null==this.backendInstance){var t=this.initializeBackendsAndReturnBest(),e=t.name;if(t.asyncInit)throw new Error("The highest priority backend '".concat(e,"' has not yet been ")+"initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods");this.setBackend(e)}return this.backendInstance},enumerable:!1,configurable:!0}),t.prototype.backendNames=function(){return Object.keys(this.registryFactory)},t.prototype.findBackend=function(t){if(!(t in this.registry)){if(!(t in this.registryFactory))return null;if(this.initializeBackend(t).asyncInit)return null}return this.registry[t]},t.prototype.findBackendFactory=function(t){return t in this.registryFactory?this.registryFactory[t].factory:null},t.prototype.registerBackend=function(t,e,n){return void 0===n&&(n=1),t in this.registryFactory?(qt("".concat(t," backend was already registered. ")+"Reusing existing backend factory."),!1):(this.registryFactory[t]={factory:e,priority:n},!0)},t.prototype.setBackend=function(t){return u(this,void 0,void 0,(function(){var e,n,r;return p(this,(function(a){switch(a.label){case 0:if(null==this.registryFactory[t])throw new Error("Backend name '".concat(t,"' not found in registry"));return this.backendName=t,null!=this.registry[t]?[3,4]:(this.backendInstance=null,e=this.initializeBackend(t),n=e.success,e.asyncInit?[4,n]:[3,2]);case 1:return r=a.sent(),[3,3];case 2:r=n,a.label=3;case 3:if(!r)return[2,!1];a.label=4;case 4:return this.backendInstance=this.registry[t],this.setupRegisteredKernels(),this.profiler=new _e(this.backendInstance),[2,!0]}}))}))},t.prototype.setupRegisteredKernels=function(){var t=this;Zt(this.backendName).forEach((function(e){null!=e.setupFunc&&e.setupFunc(t.backendInstance)}))},t.prototype.disposeRegisteredKernels=function(t){var e=this;Zt(t).forEach((function(n){null!=n.disposeFunc&&n.disposeFunc(e.registry[t])}))},t.prototype.initializeBackend=function(t){var e=this,n=this.registryFactory[t];if(null==n)throw new Error("Cannot initialize backend ".concat(t,", no registration found."));try{var r=n.factory();if(!r||r instanceof rt||"function"!=typeof r.then)return this.registry[t]=r,{success:!0,asyncInit:!1};var a=++this.pendingBackendInitId,o=r.then((function(n){return!(a<e.pendingBackendInitId)&&(e.registry[t]=n,e.pendingBackendInit=null,!0)})).catch((function(n){return a<e.pendingBackendInitId||(e.pendingBackendInit=null,qt("Initialization of backend ".concat(t," failed")),qt(n.stack||n.message)),!1}));return this.pendingBackendInit=o,{success:o,asyncInit:!0}}catch(e){return qt("Initialization of backend ".concat(t," failed")),qt(e.stack||e.message),{success:!1,asyncInit:!1}}},t.prototype.removeBackend=function(t){if(!(t in this.registryFactory))throw new Error("".concat(t," backend not found in registry"));this.backendName===t&&null!=this.pendingBackendInit&&this.pendingBackendInitId++,t in this.registry&&(this.disposeRegisteredKernels(t),this.registry[t].dispose(),delete this.registry[t]),delete this.registryFactory[t],this.backendName===t&&(this.pendingBackendInit=null,this.backendName=null,this.backendInstance=null)},t.prototype.getSortedBackends=function(){var t=this;if(0===Object.keys(this.registryFactory).length)throw new Error("No backend found in registry.");return Object.keys(this.registryFactory).sort((function(e,n){return t.registryFactory[n].priority-t.registryFactory[e].priority}))},t.prototype.initializeBackendsAndReturnBest=function(){for(var t=this.getSortedBackends(),e=0;e<t.length;e++){var n=t[e],r=this.initializeBackend(n),a=r.success,o=r.asyncInit;if(o||a)return{name:n,asyncInit:o}}throw new Error("Could not initialize any backends, all backend initializations failed.")},t.prototype.moveData=function(t,e){var n=this.state.tensorInfo.get(e),r=n.backend,a=this.readSync(e),o=r.refCount(e);r.disposeData(e,!0),n.backend=t,t.move(e,a,n.shape,n.dtype,o),this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack[this.state.numDataMovesStack.length-1]++},t.prototype.tidy=function(t,e){var n,r=this,a=null;if(null==e){if("function"!=typeof t)throw new Error("Please provide a function to tidy()");e=t}else{if("string"!=typeof t&&!(t instanceof String))throw new Error("When calling with two arguments, the first argument to tidy() must be a string");if("function"!=typeof e)throw new Error("When calling with two arguments, the 2nd argument to tidy() must be a function");a=t}return this.scopedRun((function(){return r.startScope(a)}),(function(){return r.endScope(n)}),(function(){return(n=e())instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),n}))},t.prototype.scopedRun=function(t,e,n){t();try{var r=n();return e(),r}catch(t){throw e(),t}},t.prototype.nextTensorId=function(){return t.nextTensorId++},t.prototype.nextVariableId=function(){return t.nextVariableId++},t.prototype.clone=function(t){var e=Qe.runKernel(Vt,{x:t}),n={x:t};return this.addTapeNode(this.state.activeScope.name,n,[e],(function(t){return{x:function(){var e={x:t},n={dtype:"float32"};return Qe.runKernel(zt,e,n)}}}),[],{}),e},t.prototype.runKernel=function(t,e,n){if(null==this.backendName&&this.backend,!(null!=Ht(t,this.backendName)))throw new Error("Kernel '".concat(t,"' not registered for backend '").concat(this.backendName,"'"));return this.runKernelFunc({kernelName:t,inputs:e,attrs:n})},t.prototype.shouldCheckForMemLeaks=function(){return this.ENV.getBool("IS_TEST")},t.prototype.checkKernelForMemLeak=function(t,e,n){var r=this.backend.numDataIds(),a=0;n.forEach((function(t){a+="complex64"===t.dtype?3:1}));var o=this.state.numDataMovesStack[this.state.numDataMovesStack.length-1],s=r-e-a-o;if(s>0)throw new Error("Backend '".concat(this.backendName,"' has an internal memory leak ")+"(".concat(s," data ids) after running '").concat(t,"'"))},t.prototype.runKernelFunc=function(t){var e,n,r,a=this,o=[],s=this.isTapeOn(),i=this.state.numBytes,u=this.state.numTensors;this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack.push(0),null==this.backendName&&this.backend;var p=He(t)?t.kernelName:null!=this.state.activeScope?this.state.activeScope.name:"";if(He(t)){var c=t.kernelName,l=t.inputs,d=t.attrs;null==this.backendName&&this.backend;var h=Ht(c,this.backendName);ot(null!=h,(function(){return"Cannot find registered kernel '".concat(c,"' for backend '").concat(a.backendName,"'")})),n=function(){var t=a.backend.numDataIds();r=h.kernelFunc({inputs:l,attrs:d,backend:a.backend});var e=Array.isArray(r)?r:[r];a.shouldCheckForMemLeaks()&&a.checkKernelForMemLeak(c,t,e);var n=e.map((function(t){return null!=t.rank?t:a.makeTensorFromTensorInfo(t)}));if(s){var i=a.getTensorsForGradient(c,l,n);o=a.saveTensorsForBackwardMode(i)}return n}}else{var f=t.forwardFunc,m=function(t){s&&(o=t.map((function(t){return a.keep(a.clone(t))})))};n=function(){var t=a.backend.numDataIds();r=a.tidy((function(){return f(a.backend,m)}));var e=Array.isArray(r)?r:[r];return a.shouldCheckForMemLeaks()&&a.checkKernelForMemLeak(p,t,e),e}}var y,g=t.inputs,v=t.attrs,b=He(t)?null:t.backwardsFunc;return this.scopedRun((function(){return a.state.kernelDepth++}),(function(){return a.state.kernelDepth--}),(function(){a.ENV.getBool("DEBUG")||a.state.profiling?(y=a.profiler.profileKernel(p,g,(function(){return n()})),a.ENV.getBool("DEBUG")&&a.profiler.logKernelProfile(y),e=y.outputs):e=n()})),s&&this.addTapeNode(p,g,e,b,o,v),this.state.profiling&&this.state.activeProfile.kernels.push({name:p,bytesAdded:this.state.numBytes-i,totalBytesSnapshot:this.state.numBytes,tensorsAdded:this.state.numTensors-u,totalTensorsSnapshot:this.state.numTensors,inputShapes:Object.keys(g).map((function(t){return null!=g[t]?g[t].shape:null})),outputShapes:e.map((function(t){return t.shape})),kernelTimeMs:y.timeMs,extraInfo:y.extraInfo}),Array.isArray(r)?e:e[0]},t.prototype.saveTensorsForBackwardMode=function(t){var e=this,n=t.map((function(t){return e.keep(e.clone(t))}));return n},t.prototype.getTensorsForGradient=function(t,e,n){var r=Gt(t);if(null!=r){var a=r.inputsToSave||[],o=r.outputsToSave||[],s=void 0;r.saveAllInputs?(ot(Array.isArray(e),(function(){return"saveAllInputs is true, expected inputs to be an array."})),s=Object.keys(e).map((function(t){return e[t]}))):s=a.map((function(t){return e[t]}));var i=n.filter((function(t,e){return o[e]}));return s.concat(i)}return[]},t.prototype.makeTensor=function(t,e,n,r){if(null==t)throw new Error("Values passed to engine.makeTensor() are null");n=n||"float32",r=r||this.backend;var a=t;"string"===n&&yt(t[0])&&(a=t.map((function(t){return e=t,void 0===n&&(n="utf-8"),n=n||"utf-8",Dt().platform.encode(e,n);var e,n})));var o=r.write(a,e,n),s=new ze(e,n,o,this.nextTensorId());if(this.trackTensor(s,r),"string"===n){var i=this.state.tensorInfo.get(o),u=function(t){if(null==t)return 0;var e=0;return t.forEach((function(t){return e+=t.length})),e}(a);this.state.numBytes+=u-i.bytes,i.bytes=u}return s},t.prototype.makeTensorFromDataId=function(t,e,n,r){var a={dataId:t,shape:e,dtype:n=n||"float32"};return this.makeTensorFromTensorInfo(a,r)},t.prototype.makeTensorFromTensorInfo=function(t,e){var n=t.dataId,r=t.shape,a=t.dtype,o=new ze(r,a,n,this.nextTensorId());return this.trackTensor(o,e),o},t.prototype.makeVariable=function(t,e,n,r){void 0===e&&(e=!0),n=n||this.nextVariableId().toString(),null!=r&&r!==t.dtype&&(t=t.cast(r));var a=new Ke(t,e,n,this.nextTensorId());if(null!=this.state.registeredVariables[a.name])throw new Error("Variable with name ".concat(a.name," was already registered"));return this.state.registeredVariables[a.name]=a,this.incRef(a,this.backend),a},t.prototype.trackTensor=function(t,e){this.state.numTensors++,"string"===t.dtype&&this.state.numStringTensors++;var n=0;"complex64"!==t.dtype&&"string"!==t.dtype&&(n=t.size*mt(t.dtype)),this.state.numBytes+=n,this.state.tensorInfo.has(t.dataId)||(this.state.numDataBuffers++,this.state.tensorInfo.set(t.dataId,{backend:e||this.backend,dtype:t.dtype,shape:t.shape,bytes:n})),t instanceof Ke||this.track(t)},t.prototype.incRef=function(t,e){this.trackTensor(t,e),this.backend.incRef(t.dataId)},t.prototype.removeDataId=function(t,e){this.state.tensorInfo.has(t)&&this.state.tensorInfo.get(t).backend===e&&(this.state.tensorInfo.delete(t),this.state.numDataBuffers--)},t.prototype.disposeTensor=function(t){if(this.state.tensorInfo.has(t.dataId)){var e=this.state.tensorInfo.get(t.dataId);if(this.state.numTensors--,"string"===t.dtype&&(this.state.numStringTensors--,this.state.numBytes-=e.bytes),"complex64"!==t.dtype&&"string"!==t.dtype){var n=t.size*mt(t.dtype);this.state.numBytes-=n}e.backend.disposeData(t.dataId)&&this.removeDataId(t.dataId,e.backend)}},t.prototype.disposeVariables=function(){for(var t in this.state.registeredVariables){var e=this.state.registeredVariables[t];this.disposeVariable(e)}},t.prototype.disposeVariable=function(t){this.disposeTensor(t),null!=this.state.registeredVariables[t.name]&&delete this.state.registeredVariables[t.name]},t.prototype.memory=function(){var t=this.backend.memory();return t.numTensors=this.state.numTensors,t.numDataBuffers=this.state.numDataBuffers,t.numBytes=this.state.numBytes,this.state.numStringTensors>0&&(t.unreliable=!0,null==t.reasons&&(t.reasons=[]),t.reasons.push("Memory usage by string tensors is approximate (2 bytes per character)")),t},t.prototype.profile=function(t){return u(this,void 0,void 0,(function(){var e,n,r,a,o,s,i,u,h,f,m;return p(this,(function(p){switch(p.label){case 0:return this.state.profiling=!0,e=this.state.numBytes,n=this.state.numTensors,this.state.activeProfile.kernels=[],r=this.state.activeProfile,[4,t()];case 1:r.result=p.sent(),this.state.profiling=!1,this.state.activeProfile.peakBytes=Math.max.apply(Math,d([],l(this.state.activeProfile.kernels.map((function(t){return t.totalBytesSnapshot}))),!1)),this.state.activeProfile.newBytes=this.state.numBytes-e,this.state.activeProfile.newTensors=this.state.numTensors-n,p.label=2;case 2:p.trys.push([2,8,9,10]),a=c(this.state.activeProfile.kernels),o=a.next(),p.label=3;case 3:return o.done?[3,7]:(s=o.value,i=s,[4,s.kernelTimeMs]);case 4:return i.kernelTimeMs=p.sent(),u=s,[4,s.extraInfo];case 5:u.extraInfo=p.sent(),p.label=6;case 6:return o=a.next(),[3,3];case 7:return[3,10];case 8:return h=p.sent(),f={error:h},[3,10];case 9:try{o&&!o.done&&(m=a.return)&&m.call(a)}finally{if(f)throw f.error}return[7];case 10:return[2,this.state.activeProfile]}}))}))},t.prototype.isTapeOn=function(){return this.state.gradientDepth>0&&0===this.state.kernelDepth},t.prototype.addTapeNode=function(t,e,n,r,a,o){var s=this,i={id:this.state.nextTapeNodeId++,kernelName:t,inputs:e,outputs:n,saved:a},u=Gt(t);null!=u&&(r=u.gradFunc),null!=r&&(i.gradient=function(t){return t=t.map((function(t,e){if(null==t){var r=n[e],a=kt(r.size,r.dtype);return s.makeTensor(a,r.shape,r.dtype)}return t})),r(t.length>1?t:t[0],a,o)}),this.state.activeTape.push(i)},t.prototype.keep=function(t){return t.kept=!0,t},t.prototype.startTape=function(){0===this.state.gradientDepth&&(this.state.activeTape=[]),this.state.gradientDepth++},t.prototype.endTape=function(){this.state.gradientDepth--},t.prototype.startScope=function(t){var e={track:[],name:"unnamed scope",id:this.state.nextScopeId++};t&&(e.name=t),this.state.scopeStack.push(e),this.state.activeScope=e},t.prototype.endScope=function(t){for(var e=this,n=Ue(t),r=new Set(n.map((function(t){return t.id}))),a=0;a<this.state.activeScope.track.length;a++){var o=this.state.activeScope.track[a];o.kept||r.has(o.id)||o.dispose()}var s=this.state.scopeStack.pop();this.state.activeScope=0===this.state.scopeStack.length?null:this.state.scopeStack[this.state.scopeStack.length-1],n.forEach((function(t){t.kept||t.scopeId!==s.id||e.track(t)}))},t.prototype.gradients=function(t,e,n,r){var a=this;if(void 0===r&&(r=!1),ot(e.length>0,(function(){return"gradients() received an empty list of xs."})),null!=n&&"float32"!==n.dtype)throw new Error("dy must have 'float32' dtype, but has '".concat(n.dtype,"'"));var o=this.scopedRun((function(){return a.startTape()}),(function(){return a.endTape()}),(function(){return a.tidy("forward",t)}));ot(o instanceof ze,(function(){return"The result y returned by f() must be a tensor."}));var s=function(t,e,n){for(var r={},a={},o=0;o<e.length;o++)r[e[o].id]=!0;for(o=0;o<t.length;o++){var s=(f=t[o]).inputs;for(var i in s){for(var u=s[i],p=!1,c=0;c<e.length;c++)if(r[u.id]){f.outputs.forEach((function(t){return r[t.id]=!0})),p=!0,a[f.id]=!0;break}if(p)break}}var l={};l[n.id]=!0;var d={};for(o=t.length-1;o>=0;o--)for(s=(f=t[o]).inputs,c=0;c<f.outputs.length;c++)if(l[f.outputs[c].id]){for(var i in s)l[s[i].id]=!0,d[f.id]=!0;break}var h=[];for(o=0;o<t.length;o++){var f;if(a[(f=t[o]).id]&&d[f.id]){var m={};for(var i in f.inputs){var y=f.inputs[i];r[y.id]&&(m[i]=y)}var g=Object.assign({},f);g.inputs=m,g.outputs=f.outputs,h.push(g)}}return h}(this.state.activeTape,e,o);if(!r&&0===s.length&&e.length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that the f you passed encloses all operations that lead from x to y.");return this.tidy("backward",(function(){var t,r,i={};i[o.id]=null==n?(t=o.shape,r=wt(pt(t),"float32"),Qe.makeTensor(r,t,"float32")):n,function(t,e,n,r){for(var a=function(a){var o=e[a],s=[];if(o.outputs.forEach((function(e){var n=t[e.id];null!=n?s.push(n):s.push(null)})),null==o.gradient)throw new Error("Cannot compute gradient: gradient function not found "+"for ".concat(o.kernelName,"."));var i=o.gradient(s),u=function(e){if(!(e in i))throw new Error("Cannot backprop through input ".concat(e,". ")+"Available gradients found: ".concat(Object.keys(i),"."));var a=n((function(){return i[e]()}));if("float32"!==a.dtype)throw new Error("Error in gradient for op ".concat(o.kernelName,". The gradient of input ")+"".concat(e," must have 'float32' dtype, but has '").concat(a.dtype,"'"));var s=o.inputs[e];if(!ct(a.shape,s.shape))throw new Error("Error in gradient for op ".concat(o.kernelName,". The gradient of input ")+"'".concat(e,"' has shape '").concat(a.shape,"', which does not match ")+"the shape of the input '".concat(s.shape,"'"));if(null==t[s.id])t[s.id]=a;else{var u=t[s.id];t[s.id]=r(u,a),u.dispose()}};for(var p in o.inputs)u(p)},o=e.length-1;o>=0;o--)a(o)}(i,s,(function(t){return a.tidy(t)}),Ye);var u=e.map((function(t){return i[t.id]}));return 0===a.state.gradientDepth&&(a.state.activeTape.forEach((function(t){var e,n;try{for(var r=c(t.saved),a=r.next();!a.done;a=r.next()){a.value.dispose()}}catch(t){e={error:t}}finally{try{a&&!a.done&&(n=r.return)&&n.call(r)}finally{if(e)throw e.error}}})),a.state.activeTape=null),{value:o,grads:u}}))},t.prototype.customGrad=function(t){var e=this;return ot(vt(t),(function(){return"The f passed in customGrad(f) must be a function."})),function(){for(var n,r=[],a=0;a<arguments.length;a++)r[a]=arguments[a];ot(r.every((function(t){return t instanceof ze})),(function(){return"The args passed in customGrad(f)(x1, x2,...) must all be tensors"}));var o={};r.forEach((function(t,e){o[e]=t}));var s=function(e,a){return ot((n=t.apply(void 0,d([],l(d(d([],l(r),!1),[a],!1)),!1))).value instanceof ze,(function(){return"The function f passed in customGrad(f) must return an object where `obj.value` is a tensor"})),ot(vt(n.gradFunc),(function(){return"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function."})),n.value},i=function(t,e){var a=n.gradFunc(t,e),o=Array.isArray(a)?a:[a];ot(o.length===r.length,(function(){return"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns the same number of tensors as inputs passed to f(...)."})),ot(o.every((function(t){return t instanceof ze})),(function(){return"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns a list of only tensors."}));var s={};return o.forEach((function(t,e){s[e]=function(){return t}})),s};return e.runKernelFunc({forwardFunc:s,backwardsFunc:i,inputs:o})}},t.prototype.readSync=function(t){return this.state.tensorInfo.get(t).backend.readSync(t)},t.prototype.read=function(t){return this.state.tensorInfo.get(t).backend.read(t)},t.prototype.readToGPU=function(t,e){return this.state.tensorInfo.get(t).backend.readToGPU(t,e)},t.prototype.time=function(t){return u(this,void 0,void 0,(function(){var e,n;return p(this,(function(r){switch(r.label){case 0:return e=ke(),[4,this.backend.time(t)];case 1:return(n=r.sent()).wallMs=ke()-e,[2,n]}}))}))},t.prototype.track=function(t){return null!=this.state.activeScope&&(t.scopeId=this.state.activeScope.id,this.state.activeScope.track.push(t)),t},Object.defineProperty(t.prototype,"registeredVariables",{get:function(){return this.state.registeredVariables},enumerable:!1,configurable:!0}),t.prototype.reset=function(){for(var t in this.pendingBackendInitId++,this.state.dispose(),this.ENV.reset(),this.state=new Ge,this.registry)this.disposeRegisteredKernels(t),this.registry[t].dispose(),delete this.registry[t];this.backendName=null,this.backendInstance=null,this.pendingBackendInit=null},t}();Ze.nextTensorId=0,Ze.nextVariableId=0;var Qe=function(){var t=Ct();if(null==t._tfengine){var e=new Et(t);t._tfengine=new Ze(e)}return function(t){Mt=t}(t._tfengine.ENV),Ce=function(){return t._tfengine},t._tfengine}();function Ye(t,e){var n={a:t,b:e};return Qe.runKernel("Add",n)}function Xe(t,e){var n=t;if(ft(t))return"string"===e?[]:[t.length];if("object"==typeof t&&"texture"in t){var r=t.channels||"RGBA";return[t.height,t.width*r.length]}if(!Array.isArray(t))return[];for(var a=[];Array.isArray(n)||ft(n)&&"string"!==e;)a.push(n.length),n=n[0];return Array.isArray(t)&&Dt().getBool("TENSORLIKE_CHECK_SHAPE_CONSISTENCY")&&Je(t,a,[]),a}function Je(t,e,n){if(n=n||[],Array.isArray(t)||ft(t)){ot(e.length>0,(function(){return"Element arr[".concat(n.join("]["),"] should be a primitive, ")+"but is an array of ".concat(t.length," elements")})),ot(t.length===e[0],(function(){return"Element arr[".concat(n.join("]["),"] should have ").concat(e[0]," ")+"elements, but has ".concat(t.length," elements")}));for(var r=e.slice(1),a=0;a<t.length;++a)Je(t[a],r,n.concat(a))}else ot(0===e.length,(function(){return"Element arr[".concat(n.join("]["),"] is a primitive, ")+"but should be an array/TypedArray of ".concat(e[0]," elements")}))}function $e(t,e,n,r){if("string_or_numeric"!==t){if(null==t)throw new Error("Expected dtype cannot be null.");if("numeric"!==t&&t!==e||"numeric"===t&&"string"===e)throw new Error("Argument '".concat(n,"' passed to '").concat(r,"' must ")+"be ".concat(t," tensor, but got ").concat(e," tensor"))}}function tn(t,e,n,r){if(void 0===r&&(r="numeric"),t instanceof ze)return $e(r,t.dtype,e,n),t;var a=gt(t);if("string"!==a&&["bool","int32","float32"].indexOf(r)>=0&&(a=r),$e(r,a,e,n),null==t||!ft(t)&&!Array.isArray(t)&&"number"!=typeof t&&"boolean"!=typeof t&&"string"!=typeof t){var o=null==t?"null":t.constructor.name;throw new Error("Argument '".concat(e,"' passed to '").concat(n,"' must be a ")+"Tensor or TensorLike, but got '".concat(o,"'"))}var s=Xe(t,a);ft(t)||Array.isArray(t)||(t=[t]);var i="string"!==a?we(t,a):ut(t,[],!0);return Qe.makeTensor(i,s,a)}function en(t,e,n,r){if(void 0===r&&(r="numeric"),!Array.isArray(t))throw new Error("Argument ".concat(e," passed to ").concat(n," must be a ")+"`Tensor[]` or `TensorLike[]`");return t.map((function(t,a){return tn(t,"".concat(e,"[").concat(a,"]"),n,r)}))}var nn="__op";function rn(t){var e=Object.keys(t);if(1!==e.length)throw new Error("Please provide an object with a single key (operation name) mapping to a function. Got an object with "+"".concat(e.length," keys."));var n=e[0],r=t[n];n.endsWith("_")&&(n=n.substring(0,n.length-1)),n+=nn;var a=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];Qe.startScope(n);try{var a=r.apply(void 0,d([],l(t),!1));return _t(a)&&console.error("Cannot return a Promise inside of tidy."),Qe.endScope(a),a}catch(t){throw Qe.endScope(null),t}};return Object.defineProperty(a,"name",{value:n,configurable:!0}),a}var an=rn({abs_:function(t){var e=tn(t,"x","abs");if("complex64"===e.dtype){var n={x:e};return Qe.runKernel("ComplexAbs",n)}return n={x:e},Qe.runKernel("Abs",n)}});var on=rn({acos_:function(t){var e={x:tn(t,"x","acos")};return Qe.runKernel("Acos",e)}});var sn=rn({acosh_:function(t){var e={x:tn(t,"x","acosh")};return Qe.runKernel("Acosh",e)}});var un=rn({add_:function(t,e){var n,r=tn(t,"a","add"),a=tn(e,"b","add"),o={a:r=(n=l(qe(r,a),2))[0],b:a=n[1]};return Qe.runKernel("Add",o)}});var pn=rn({addN_:function(t){ot(Array.isArray(t),(function(){return"The argument passed to tf.addN() must be a list of tensors"})),ot(t.length>=1,(function(){return"Must pass at least one tensor to tf.addN(), but got "+"".concat(t.length)}));var e=t.map((function(t,e){return tn(t,"tensors".concat(e),"addN")})),n=e[0];e.forEach((function(t){if(t.dtype!==n.dtype)throw new Error("All tensors passed to tf.addN() must have the same dtype")})),e.forEach((function(t){if(!ct(t.shape,n.shape))throw new Error("All tensors passed to tf.addN() must have the same shape")}));var r=e;return Qe.runKernel("AddN",r)}});var cn=rn({all_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r={x:tn(t,"x","all","bool")},a={axis:e,keepDims:n};return Qe.runKernel("All",r,a)}});var ln=rn({any_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r={x:tn(t,"x","any","bool")},a={axis:e,keepDims:n};return Qe.runKernel("Any",r,a)}});var dn=rn({argMax_:function(t,e){void 0===e&&(e=0);var n={x:tn(t,"x","argMax")},r={axis:e};return Qe.runKernel("ArgMax",n,r)}});var hn=rn({argMin_:function(t,e){void 0===e&&(e=0);var n={x:tn(t,"x","argMin")},r={axis:e};return Qe.runKernel("ArgMin",n,r)}});var fn=rn({asin_:function(t){var e={x:tn(t,"x","asin")};return Qe.runKernel("Asin",e)}});var mn=rn({asinh_:function(t){var e={x:tn(t,"x","asinh")};return Qe.runKernel("Asinh",e)}});var yn=rn({atan_:function(t){var e={x:tn(t,"x","atan")};return Qe.runKernel("Atan",e)}});var gn=rn({atan2_:function(t,e){var n,r=tn(t,"a","atan2"),a=tn(e,"b","atan2"),o={a:r=(n=l(qe(r,a),2))[0],b:a=n[1]};return Qe.runKernel("Atan2",o)}});var vn=rn({atanh_:function(t){var e={x:tn(t,"x","atanh")};return Qe.runKernel("Atanh",e)}});var bn=rn({cast_:function(t,e){var n=tn(t,"x","cast");if(!function(t){return"bool"===t||"complex64"===t||"float32"===t||"int32"===t||"string"===t}(e))throw new Error("Failed to cast to unknown dtype ".concat(e));if("string"===e&&"string"!==n.dtype||"string"!==e&&"string"===n.dtype)throw new Error("Only strings can be casted to strings");var r={x:n},a={dtype:e};return Qe.runKernel(zt,r,a)}});function xn(t,e,n,r,a,o,s,i){var u,p;void 0===s&&(s=!1),void 0===i&&(i="channelsLast");var c=l([-1,-1,-1,-1],4),d=c[0],h=c[1],f=c[2],m=c[3];if("channelsLast"===i)d=(u=l(t,4))[0],h=u[1],f=u[2],m=u[3];else{if("channelsFirst"!==i)throw new Error("Unknown dataFormat ".concat(i));d=(p=l(t,4))[0],m=p[1],h=p[2],f=p[3]}var y,g=l(e,4),v=g[0],b=g[1],x=g[3],N=l(Nn(n),2),w=N[0],k=N[1],T=l(Nn(r),2),_=T[0],S=T[1],E=wn(v,_),I=wn(b,S),O=function(t,e,n,r,a,o,s,i,u){var p,c,l;if("number"==typeof t){p={top:t,bottom:t,left:t,right:t,type:0===t?"VALID":"NUMBER"};var d=function(t,e,n,r,a){null==r&&(r=function(t,e,n,r){void 0===r&&(r=1);var a=wn(e,r);return Math.floor((t[0]*(n-1)-n+a)/2)}(t,e,n));var o=t[0],s=t[1],i=kn((o-e+2*r)/n+1,a),u=kn((s-e+2*r)/n+1,a);return[i,u]}([e,n],o,r,t,i);c=d[0],l=d[1]}else if("same"===t){c=Math.ceil(e/r),l=Math.ceil(n/a);var h=Math.max(0,(c-1)*r+o-e),f=Math.max(0,(l-1)*a+s-n);p={top:m=Math.floor(h/2),bottom:y=h-m,left:g=Math.floor(f/2),right:v=f-g,type:"SAME"}}else if("valid"===t)p={top:0,bottom:0,left:0,right:0,type:"VALID"},c=Math.ceil((e-o+1)/r),l=Math.ceil((n-s+1)/a);else{if("object"!=typeof t)throw Error("Unknown padding parameter: ".concat(t));var m,y,g,v;p={top:m="channelsLast"===u?t[1][0]:t[2][0],bottom:y="channelsLast"===u?t[1][1]:t[2][1],left:g="channelsLast"===u?t[2][0]:t[3][0],right:v="channelsLast"===u?t[2][1]:t[3][1],type:0===m&&0===y&&0===g&&0===v?"VALID":"EXPLICIT"},c=kn((e-o+m+y)/r+1,i),l=kn((n-s+g+v)/a+1,i)}return{padInfo:p,outHeight:c,outWidth:l}}(a,h,f,w,k,E,I,o,i),D=O.padInfo,A=O.outHeight,M=O.outWidth,C=s?x*m:x;return"channelsFirst"===i?y=[d,C,A,M]:"channelsLast"===i&&(y=[d,A,M,C]),{batchSize:d,dataFormat:i,inHeight:h,inWidth:f,inChannels:m,outHeight:A,outWidth:M,outChannels:C,padInfo:D,strideHeight:w,strideWidth:k,filterHeight:v,filterWidth:b,effectiveFilterHeight:E,effectiveFilterWidth:I,dilationHeight:_,dilationWidth:S,inShape:t,outShape:y,filterShape:e}}function Nn(t){return"number"==typeof t?[t,t,t]:2===t.length?[t[0],t[1],1]:t}function wn(t,e){return e<=1?t:t+(t-1)*(e-1)}function kn(t,e){if(!e)return Math.trunc(t);switch(e){case"round":return Math.round(t);case"ceil":return Math.ceil(t);case"floor":return Math.floor(t);default:throw new Error("Unknown roundingMode ".concat(e))}}function Tn(t){var e=l(Nn(t),3),n=e[0],r=e[1],a=e[2];return 1===n&&1===r&&1===a}function _n(t,e){return Tn(t)||Tn(e)}function Sn(t,e,n){if(null!=n){if("string"==typeof e)throw Error("Error in ".concat(t,": pad must be an integer when using ")+"dimRoundingMode ".concat(n," but got pad ").concat(e,"."));if("number"==typeof e)ot(lt(e),(function(){return"Error in ".concat(t,": pad must be an integer when using ")+"dimRoundingMode ".concat(n," but got pad ").concat(e,".")}));else{if("object"!=typeof e)throw Error("Error in ".concat(t,": Unknown padding parameter: ").concat(e));e.forEach((function(e){e.forEach((function(e){ot(lt(e),(function(){return"Error in ".concat(t,": pad must be an integer when using ")+"dimRoundingMode ".concat(n," but got pad ").concat(e,".")}))}))}))}}}var En=rn({reshape_:function(t,e){var n={x:tn(t,"x","reshape","string_or_numeric")},r={shape:e};return Qe.runKernel("Reshape",n,r)}});var In=rn({avgPool_:function(t,e,n,r,a){var o=tn(t,"x","avgPool","float32");ot(_n(n,1),(function(){return"Error in avgPool: Either strides or dilations must be 1. "+"Got strides ".concat(n," and dilations '").concat(1,"'")}));var s=o,i=!1;3===o.rank&&(i=!0,s=En(o,[1,o.shape[0],o.shape[1],o.shape[2]])),ot(4===s.rank,(function(){return"Error in avgPool: x must be rank 4 but got rank ".concat(s.rank,".")})),Sn("avgPool",r,a);var u={x:s},p={filterSize:e,strides:n,pad:r,dimRoundingMode:a},c=Qe.runKernel("AvgPool",u,p);return c=bn(c,o.dtype),i?En(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});var On=rn({avgPool3d_:function(t,e,n,r,a,o){void 0===o&&(o="NDHWC");var s=tn(t,"x","avgPool3d","float32"),i=s,u=!1;4===s.rank&&(u=!0,i=En(s,[1,s.shape[0],s.shape[1],s.shape[2],s.shape[3]])),ot(5===i.rank,(function(){return"Error in avgPool3d: x must be rank 5 but got rank ".concat(i.rank,".")})),ot("NDHWC"===o,(function(){return"Error in avgPool3d: Only NDHWC is currently supported, "+"but got dataFormat of ".concat(o)})),Sn("avgPool3d",r,a);var p={x:i},c={filterSize:e,strides:n,pad:r,dimRoundingMode:a,dataFormat:o},l=Qe.runKernel("AvgPool3D",p,c);return l=bn(l,i.dtype),u?En(l,[l.shape[1],l.shape[2],l.shape[3],l.shape[4]]):l}});var Dn=rn({clone_:function(t){var e={x:tn(t,"x","clone","string_or_numeric")};return Qe.runKernel(Vt,e)}});var An=rn({concat_:function(t,e){void 0===e&&(e=0),ot(t.length>=1,(function(){return"Pass at least one tensor to concat"}));var n=en(t,"tensors","concat","string_or_numeric");if("complex64"===n[0].dtype&&n.forEach((function(t){if("complex64"!==t.dtype)throw new Error("Cannot concatenate complex64 tensors with a tensor\n          with dtype ".concat(t.dtype,". "))})),1===n.length)return Dn(n[0]);var r=n,a={axis:e};return Qe.runKernel("Concat",r,a)}});var Mn=rn({matMul_:function(t,e,n,r){var a;void 0===n&&(n=!1),void 0===r&&(r=!1);var o=tn(t,"a","matMul"),s=tn(e,"b","matMul"),i={a:o=(a=l(qe(o,s),2))[0],b:s=a[1]},u={transposeA:n,transposeB:r};return Qe.runKernel("BatchMatMul",i,u)}});var Cn=rn({mul_:function(t,e){var n,r=tn(t,"a","mul"),a=tn(e,"b","mul"),o={a:r=(n=l(qe(r,a),2))[0],b:a=n[1]};return Qe.runKernel("Multiply",o)}});var Fn=rn({sigmoid_:function(t){var e={x:tn(t,"x","sigmoid","float32")};return Qe.runKernel("Sigmoid",e)}});var zn=rn({slice_:function(t,e,n){var r=tn(t,"x","slice","string_or_numeric");if(0===r.rank)throw new Error("Slicing scalar is not possible");var a={x:r},o={begin:e,size:n};return Qe.runKernel("Slice",a,o)}});var Rn=rn({tanh_:function(t){var e={x:tn(t,"x","tanh","float32")};return Qe.runKernel("Tanh",e)}});var Vn=rn({basicLSTMCell_:function(t,e,n,r,a,o){var s=tn(t,"forgetBias","basicLSTMCell"),i=tn(e,"lstmKernel","basicLSTMCell"),u=tn(n,"lstmBias","basicLSTMCell"),p=tn(r,"data","basicLSTMCell"),c=tn(a,"c","basicLSTMCell"),l=tn(o,"h","basicLSTMCell"),d=An([p,l],1),h=Mn(d,i),f=un(h,u),m=f.shape[0],y=f.shape[1]/4,g=[m,y],v=zn(f,[0,0],g),b=zn(f,[0,y],g),x=zn(f,[0,2*y],g),N=zn(f,[0,3*y],g),w=un(Cn(Fn(v),Rn(b)),Cn(c,Fn(un(s,x))));return[w,Cn(Rn(w),Fn(N))]}});var Ln=rn({batchToSpaceND_:function(t,e,n){var r=tn(t,"x","batchToSpaceND"),a=e.reduce((function(t,e){return t*e}));ot(r.rank>=1+e.length,(function(){return"input rank is ".concat(r.rank," but should be > than blockShape.length ").concat(e.length)})),ot(n.length===e.length,(function(){return"crops.length is ".concat(n.length," but should be equal to blockShape.length  ").concat(e.length)})),ot(r.shape[0]%a==0,(function(){return"input tensor batch is ".concat(r.shape[0]," but is not divisible by the product of ")+"the elements of blockShape ".concat(e.join(" * ")," === ").concat(a)}));var o={x:r},s={blockShape:e,crops:n};return Qe.runKernel("BatchToSpaceND",o,s)}});var Pn=rn({batchNorm_:function(t,e,n,r,a,o){null==o&&(o=.001);var s,i,u=tn(t,"x","batchNorm"),p=tn(e,"mean","batchNorm"),c=tn(n,"variance","batchNorm");null!=a&&(s=tn(a,"scale","batchNorm")),null!=r&&(i=tn(r,"offset","batchNorm")),ot(p.rank===c.rank,(function(){return"Batch normalization gradient requires mean and variance to have equal ranks."})),ot(null==i||p.rank===i.rank,(function(){return"Batch normalization gradient requires mean and offset to have equal ranks."})),ot(null==s||p.rank===s.rank,(function(){return"Batch normalization gradient requires mean and scale to have equal ranks."}));var l=function(t){return 0===t.rank||1===t.rank?En(t,[1,1,1,t.size]):2===t.rank?En(t,[1,1,t.shape[0],t.shape[1]]):3===t.rank?En(t,[1,t.shape[0],t.shape[1],t.shape[2]]):t}(u),d={x:l,scale:s,offset:i,mean:p,variance:c},h={varianceEpsilon:o},f=Qe.runKernel("FusedBatchNorm",d,h);return En(f,u.shape)}});var Bn=rn({batchNorm2d_:function(t,e,n,r,a,o){var s,i,u=tn(t,"x","batchNorm"),p=tn(e,"mean","batchNorm"),c=tn(n,"variance","batchNorm");return null!=a&&(s=tn(a,"scale","batchNorm")),null!=r&&(i=tn(r,"offset","batchNorm")),ot(2===u.rank,(function(){return"Error in batchNorm2D: x must be rank 2 but got rank "+"".concat(u.rank,".")})),ot(2===p.rank||1===p.rank,(function(){return"Error in batchNorm2D: mean must be rank 2 or rank 1 but "+"got rank ".concat(p.rank,".")})),ot(2===c.rank||1===c.rank,(function(){return"Error in batchNorm2D: variance must be rank 2 or rank 1 "+"but got rank ".concat(c.rank,".")})),null!=s&&ot(2===s.rank||1===s.rank,(function(){return"Error in batchNorm2D: scale must be rank 2 or rank 1 "+"but got rank ".concat(s.rank,".")})),null!=i&&ot(2===i.rank||1===i.rank,(function(){return"Error in batchNorm2D: offset must be rank 2 or rank 1 "+"but got rank ".concat(i.rank,".")})),Pn(u,p,c,i,s,o)}});var Kn=rn({batchNorm3d_:function(t,e,n,r,a,o){var s,i,u=tn(t,"x","batchNorm"),p=tn(e,"mean","batchNorm"),c=tn(n,"variance","batchNorm");return null!=a&&(s=tn(a,"scale","batchNorm")),null!=r&&(i=tn(r,"offset","batchNorm")),ot(3===u.rank,(function(){return"Error in batchNorm3D: x must be rank 3 but got rank "+"".concat(u.rank,".")})),ot(3===p.rank||1===p.rank,(function(){return"Error in batchNorm3D: mean must be rank 3 or rank 1 but "+"got rank ".concat(p.rank,".")})),ot(3===c.rank||1===c.rank,(function(){return"Error in batchNorm3D: variance must be rank 3 or rank 1 "+"but got rank ".concat(c.rank,".")})),null!=s&&ot(3===s.rank||1===s.rank,(function(){return"Error in batchNorm3D: scale must be rank 3 or rank 1 "+"but got rank ".concat(s.rank,".")})),null!=i&&ot(3===i.rank||1===i.rank,(function(){return"Error in batchNorm3D: offset must be rank 3 or rank 1 "+"but got rank ".concat(i.rank,".")})),Pn(u,p,c,i,s,o)}});var jn=rn({batchNorm4d_:function(t,e,n,r,a,o){var s,i,u=tn(t,"x","batchNorm"),p=tn(e,"mean","batchNorm"),c=tn(n,"variance","batchNorm");return null!=a&&(s=tn(a,"scale","batchNorm")),null!=r&&(i=tn(r,"offset","batchNorm")),ot(4===u.rank,(function(){return"Error in batchNorm4D: x must be rank 4 but got rank "+"".concat(u.rank,".")})),ot(4===p.rank||1===p.rank,(function(){return"Error in batchNorm4D: mean must be rank 4 or rank 1 but "+"got rank ".concat(p.rank,".")})),ot(4===c.rank||1===c.rank,(function(){return"Error in batchNorm4D: variance must be rank 4 or rank 1 "+"but got rank ".concat(c.rank,".")})),null!=s&&ot(4===s.rank||1===s.rank,(function(){return"Error in batchNorm4D: scale must be rank 4 or rank 1 "+"but got rank ".concat(s.rank,".")})),null!=i&&ot(4===i.rank||1===i.rank,(function(){return"Error in batchNorm4D: offset must be rank 4 or rank 1 "+"but got rank ".concat(i.rank,".")})),Pn(u,p,c,i,s,o)}});var qn=rn({bincount_:function(t,e,n){var r=tn(t,"x","bincount"),a=tn(e,"weights","bincount");ot("int32"===r.dtype,(function(){return"Error in bincount: input "+"dtype must be int32, but got ".concat(r.dtype)})),ot(n>=0,(function(){return"size must be non-negative, but got ".concat(n,".")})),ot(a.size===r.size||0===a.size,(function(){return"Error in bincount: weights must have the same size as input or"+"0-length, but got input shape: ".concat(r.shape,", weights shape: ")+"".concat(a.shape,".")}));var o={x:r,weights:a},s={size:n};return Qe.runKernel("Bincount",o,s)}});var Un=rn({broadcastArgs_:function(t,e){var n=tn(t,"s0","broadcastArgs","int32"),r=tn(e,"s1","broadcastArgs","int32");if(1!==n.rank)throw new Error("broadcastArgs(): first input must be a vector (rank=1). "+"Has rank ".concat(n.rank));if(1!==r.rank)throw new Error("broadcastArgs(): second input must be a vector (rank=1). "+"Has rank ".concat(r.rank));var a={s0:n,s1:r};return Qe.runKernel("BroadcastArgs",a)}});var Wn=rn({broadcastTo_:function(t,e){var n=tn(t,"broadcastTo","x"),r=n.shape;if(e.some((function(t){return!(t>0)||t%1!=0})))throw new Error("broadcastTo(): Invalid broadcast shape [".concat(e,"]."));if(e.length<n.rank)throw new Error("broadcastTo(): shape.length=".concat(e.length," < input.rank=").concat(n.rank,"."));if(e.length>n.rank){for(var a=n.shape.slice();a.length<e.length;)a.unshift(1);n=En(n,a)}for(var o=n.shape,s=Array.from(e),i=e.length-1;i>=0;i--)if(o[i]===e[i])s[i]=1;else if(1!==n.shape[i])throw new Error("broadcastTo(): [".concat(r,"] cannot be broadcast to [").concat(e,"]."));var u=s.map((function(t,e){return t>1?e:-1})).filter((function(t){return t>=0}));if(0===u.length)return Dn(n);var p={x:n},c={reps:s};return Qe.runKernel(Lt,p,c)}});function Hn(t,e,n){return void 0===e&&(e="float32"),e=e||"float32",Tt(t),new Me(t,e,n)}var Gn=rn({ceil_:function(t){var e={x:tn(t,"x","ceil","float32")};return Qe.runKernel("Ceil",e)}});function Zn(t,e,n){var r={shape:t,value:e,dtype:n};return Qe.runKernel("Fill",{},r)}var Qn=rn({clipByValue_:function(t,e,n){var r=tn(t,"x","clipByValue");if(ot(e<=n,(function(){return"Error in clip: min (".concat(e,") must be ")+"less than or equal to max (".concat(n,").")})),e===n)return Zn(r.shape,e,r.dtype);var a={x:r},o={clipValueMin:e,clipValueMax:n};return Qe.runKernel("ClipByValue",a,o)}});var Yn=rn({complex_:function(t,e){var n=tn(t,"real","complex"),r=tn(e,"imag","complex");st(n.shape,r.shape,"real and imag shapes, ".concat(n.shape," and ").concat(r.shape,", ")+"must match in call to tf.complex().");var a={real:n,imag:r};return Qe.runKernel("Complex",a)}});var Xn=rn({concat1d_:function(t){return An(t,0)}});var Jn=rn({concat2d_:function(t,e){return An(t,e)}});var $n=rn({concat3d_:function(t,e){return An(t,e)}});var tr=rn({concat4d_:function(t,e){return An(t,e)}});var er=rn({conv2d_:function(t,e,n,r,a,o,s){void 0===a&&(a="NHWC"),void 0===o&&(o=[1,1]);var i=tn(t,"x","conv2d","float32"),u=tn(e,"filter","conv2d","float32"),p=i,c=!1;3===i.rank&&(c=!0,p=En(i,[1,i.shape[0],i.shape[1],i.shape[2]])),ot(4===p.rank,(function(){return"Error in conv2d: input must be rank 4, but got rank ".concat(p.rank,".")})),ot(4===u.rank,(function(){return"Error in conv2d: filter must be rank 4, but got rank "+"".concat(u.rank,".")})),Sn("conv2d",r,s);var l="NHWC"===a?p.shape[3]:p.shape[1];ot(l===u.shape[2],(function(){return"Error in conv2d: depth of input (".concat(l,") must match ")+"input depth for filter ".concat(u.shape[2],".")})),ot(_n(n,o),(function(){return"Error in conv2D: Either strides or dilations must be 1. "+"Got strides ".concat(n," and dilations '").concat(o,"'")}));var d={x:p,filter:u},h={strides:n,pad:r,dataFormat:a,dilations:o,dimRoundingMode:s},f=Qe.runKernel("Conv2D",d,h);return c?En(f,[f.shape[1],f.shape[2],f.shape[3]]):f}});var nr=rn({conv1d_:function(t,e,n,r,a,o,s){void 0===a&&(a="NWC"),void 0===o&&(o=1);var i=tn(t,"x","conv1d"),u=tn(e,"filter","conv1d"),p=i,c=!1;2===i.rank&&(c=!0,p=En(i,[1,i.shape[0],i.shape[1]])),ot(3===p.rank,(function(){return"Error in conv1d: input must be rank 3, but got rank ".concat(p.rank,".")})),ot(3===u.rank,(function(){return"Error in conv1d: filter must be rank 3, but got rank "+"".concat(u.rank,".")})),Sn("conv1d",r,s),ot(p.shape[2]===u.shape[1],(function(){return"Error in conv1d: depth of input (".concat(p.shape[2],") must match ")+"input depth for filter ".concat(u.shape[1],".")})),ot(_n(n,o),(function(){return"Error in conv1D: Either stride or dilation must be 1. "+"Got stride ".concat(n," and dilation '").concat(o,"'")})),ot("NWC"===a,(function(){return"Error in conv1d: got dataFormat of ".concat(a," but only NWC is currently supported.")}));var l=En(u,[1,u.shape[0],u.shape[1],u.shape[2]]),d=En(p,[p.shape[0],1,p.shape[1],p.shape[2]]),h=er(d,l,[1,n],r,"NHWC",[1,o],s);return En(h,c?[h.shape[2],h.shape[3]]:[h.shape[0],h.shape[2],h.shape[3]])}});var rr=rn({conv2DBackpropInput_:function(t,e,n,r,a,o,s){void 0===o&&(o="NHWC"),ot(t.length===e.rank,(function(){return"Length of inShape "+"(".concat(t.length,") and rank of dy (").concat(e.rank,") must match")}));var i=t,u=e,p=!1;3===e.rank&&(p=!0,u=En(e,[1,e.shape[0],e.shape[1],e.shape[2]]),i=[1,t[0],t[1],t[2]]),ot(4===i.length,(function(){return"Error in conv2dDerInput: inShape must be length 4, but got length "+"".concat(i.length,".")})),ot(4===u.rank,(function(){return"Error in conv2dDerInput: dy must be rank 4, but got "+"rank ".concat(u.rank)})),ot(4===n.rank,(function(){return"Error in conv2dDerInput: filter must be rank 4, but got "+"rank ".concat(n.rank)}));var c="NHWC"===o?i[3]:i[1],l="NHWC"===o?u.shape[3]:u.shape[1];ot(c===n.shape[2],(function(){return"Error in conv2dDerInput: depth of input (".concat(c,") must ")+"match input depth for filter ".concat(n.shape[2],".")})),ot(l===n.shape[3],(function(){return"Error in conv2dDerInput: depth of output (".concat(l,") must ")+"match output depth for filter ".concat(n.shape[3],".")})),Sn("conv2dDerInput",a,s);var d={dy:u,filter:n},h={strides:r,pad:a,dataFormat:o,dimRoundingMode:s,inputShape:i},f=Qe.runKernel("Conv2DBackpropInput",d,h);return p?En(f,[f.shape[1],f.shape[2],f.shape[3]]):f}});var ar=rn({conv2dTranspose_:function(t,e,n,r,a,o){var s=tn(t,"x","conv2dTranspose"),i=tn(e,"filter","conv2dTranspose");return rr(n,s,i,r,a,"NHWC",o)}});var or=rn({conv3d_:function(t,e,n,r,a,o){void 0===a&&(a="NDHWC"),void 0===o&&(o=[1,1,1]);var s=tn(t,"x","conv3d"),i=tn(e,"filter","conv3d"),u=s,p=!1;4===s.rank&&(p=!0,u=En(s,[1,s.shape[0],s.shape[1],s.shape[2],s.shape[3]])),ot(5===u.rank,(function(){return"Error in conv3d: input must be rank 5, but got rank ".concat(u.rank,".")})),ot(5===i.rank,(function(){return"Error in conv3d: filter must be rank 5, but got rank "+"".concat(i.rank,".")})),ot(u.shape[4]===i.shape[3],(function(){return"Error in conv3d: depth of input (".concat(u.shape[4],") must match ")+"input depth for filter ".concat(i.shape[3],".")})),ot(_n(n,o),(function(){return"Error in conv3D: Either strides or dilations must be 1. "+"Got strides ".concat(n," and dilations '").concat(o,"'")})),ot("NDHWC"===a,(function(){return"Error in conv3d: got dataFormat of ".concat(a," but only NDHWC is currently supported.")}));var c={x:u,filter:i},l={strides:n,pad:r,dataFormat:a,dilations:o},d=Qe.runKernel("Conv3D",c,l);return p?En(d,[d.shape[1],d.shape[2],d.shape[3],d.shape[4]]):d}});var sr=rn({conv3DBackpropInput_:function(t,e,n,r,a){ot(t.length===e.rank,(function(){return"Length of inShape "+"(".concat(t.length,") and rank of dy (").concat(e.rank,") must match")}));var o=t,s=e,i=!1;4===e.rank&&(i=!0,s=En(e,[1,e.shape[0],e.shape[1],e.shape[2],e.shape[3]]),o=[1,t[0],t[1],t[2],t[3]]);var u=o[4],p=s.shape[4];ot(5===o.length,(function(){return"Error in conv3dDerInput: inShape must be length 5, but got length "+"".concat(o.length,".")})),ot(5===s.rank,(function(){return"Error in conv3dDerInput: dy must be rank 5, but got "+"rank ".concat(s.rank)})),ot(5===n.rank,(function(){return"Error in conv3dDerInput: filter must be rank 5, but got "+"rank ".concat(n.rank)})),ot(u===n.shape[3],(function(){return"Error in conv3dDerInput: depth of input (".concat(u,") must ")+"match input depth for filter ".concat(n.shape[3],".")})),ot(p===n.shape[4],(function(){return"Error in conv3dDerInput: depth of output (".concat(p,") must ")+"match output depth for filter ".concat(n.shape[4],".")}));var c={dy:s,filter:n},l={pad:a,strides:r,inputShape:o},d=Qe.runKernel("Conv3DBackpropInputV2",c,l);return i?En(d,[d.shape[1],d.shape[2],d.shape[3],d.shape[4]]):d}});var ir=rn({conv3dTranspose_:function(t,e,n,r,a){var o=tn(t,"x","conv3dTranspose"),s=tn(e,"filter","conv3dTranspose");return sr(n,o,s,r,a)}});var ur=rn({cos_:function(t){var e={x:tn(t,"x","cos","float32")};return Qe.runKernel("Cos",e)}});var pr=rn({cosh_:function(t){var e={x:tn(t,"x","cosh","float32")};return Qe.runKernel("Cosh",e)}});var cr=rn({cumprod_:function(t,e,n,r){void 0===e&&(e=0),void 0===n&&(n=!1),void 0===r&&(r=!1);var a={x:tn(t,"x","cumprod")},o={axis:e,exclusive:n,reverse:r};return Qe.runKernel("Cumprod",a,o)}});var lr=rn({cumsum_:function(t,e,n,r){void 0===e&&(e=0),void 0===n&&(n=!1),void 0===r&&(r=!1);var a={x:tn(t,"x","cumsum")},o={axis:e,exclusive:n,reverse:r};return Qe.runKernel("Cumsum",a,o)}});var dr=rn({denseBincount_:function(t,e,n,r){void 0===r&&(r=!1);var a=tn(t,"x","denseBincount"),o=tn(e,"weights","denseBincount");ot("int32"===a.dtype,(function(){return"Error in denseBincount: input "+"dtype must be int32, but got ".concat(a.dtype)})),ot(a.rank<=2,(function(){return"Error in denseBincount: input must be at most rank 2, but got "+"rank ".concat(a.rank,".")})),ot(n>=0,(function(){return"size must be non-negative, but got ".concat(n,".")})),ot(o.size===a.size||0===o.size,(function(){return"Error in denseBincount: weights must have the same shape as x or "+"0-length, but got x shape: ".concat(a.shape,", weights shape: ")+"".concat(o.shape,".")}));var s={x:a,weights:o},i={size:n,binaryOutput:r};return Qe.runKernel("DenseBincount",s,i)}});var hr=rn({depthToSpace_:function(t,e,n){void 0===n&&(n="NHWC");var r=tn(t,"x","depthToSpace","float32"),a="NHWC"===n?r.shape[1]:r.shape[2],o="NHWC"===n?r.shape[2]:r.shape[3],s="NHWC"===n?r.shape[3]:r.shape[1];ot(e>1,(function(){return"blockSize should be > 1 for depthToSpace, but was: ".concat(e)})),ot(a*e>=0,(function(){return"Negative dimension size caused by overflow when multiplying\n    ".concat(a," and ").concat(e,"  for depthToSpace with input shape\n    ").concat(r.shape)})),ot(o*e>=0,(function(){return"Negative dimension size caused by overflow when multiplying\n    ".concat(o," and ").concat(e," for depthToSpace with input shape\n        ").concat(r.shape)})),ot(s%(e*e)==0,(function(){return"Dimension size must be evenly divisible by ".concat(e*e," but is ").concat(s," for depthToSpace with input shape ").concat(r.shape)}));var i={x:r},u={blockSize:e,dataFormat:n};return Qe.runKernel("DepthToSpace",i,u)}});var fr=rn({depthwiseConv2d_:function(t,e,n,r,a,o,s){void 0===a&&(a="NHWC"),void 0===o&&(o=[1,1]);var i=tn(t,"x","depthwiseConv2d","float32"),u=tn(e,"filter","depthwiseConv2d","float32"),p=i,c=!1;3===i.rank&&(c=!0,p=En(i,[1,i.shape[0],i.shape[1],i.shape[2]])),ot(4===p.rank,(function(){return"Error in depthwiseConv2d: input must be rank 4, but got "+"rank ".concat(p.rank,".")})),ot(4===u.rank,(function(){return"Error in depthwiseConv2d: filter must be rank 4, but got rank "+"".concat(u.rank,".")}));var l="NHWC"===a?p.shape[3]:p.shape[1];ot(l===u.shape[2],(function(){return"Error in depthwiseConv2d: number of input channels "+"(".concat(l,") must match the inChannels dimension in ")+"filter ".concat(u.shape[2],".")})),Sn("depthwiseConv2d",r,s);var d={x:p,filter:u},h={strides:n,pad:r,dataFormat:a,dilations:o,dimRoundingMode:s},f=Qe.runKernel("DepthwiseConv2dNative",d,h);return c?En(f,[f.shape[1],f.shape[2],f.shape[3]]):f}});var mr=rn({diag_:function(t){var e={x:tn(t,"x","diag")};return Qe.runKernel("Diag",e)}});var yr=rn({dilation2d_:function(t,e,n,r,a,o){void 0===a&&(a=[1,1]),void 0===o&&(o="NHWC");var s=tn(t,"x","dilation2d"),i=tn(e,"filter","dilation2d");ot(3===s.rank||4===s.rank,(function(){return"Error in dilation2d: input must be rank 3 or 4, but got rank "+"".concat(s.rank,".")})),ot(3===i.rank,(function(){return"Error in dilation2d: filter must be rank 3, but got rank "+"".concat(i.rank,".")})),ot("NHWC"===o,(function(){return"Error in dilation2d: Only NHWC is currently supported, "+"but got dataFormat of ".concat(o)}));var u=s,p=!1;3===s.rank&&(u=En(s,[1,s.shape[0],s.shape[1],s.shape[2]]),p=!0);var c={x:u,filter:i},l={strides:n,pad:r,dilations:a},d=Qe.runKernel("Dilation2D",c,l);return p?En(d,[d.shape[1],d.shape[2],d.shape[3]]):d}});var gr=rn({floorDiv_:function(t,e){var n,r=tn(t,"a","floorDiv"),a=tn(e,"b","floorDiv"),o={a:r=(n=l(qe(r,a),2))[0],b:a=n[1]};return Qe.runKernel("FloorDiv",o)}});var vr=rn({div_:function(t,e){var n,r=tn(t,"a","div"),a=tn(e,"b","div");if(r=(n=l(qe(r,a),2))[0],a=n[1],"int32"===r.dtype&&"int32"===a.dtype)return gr(r,a);var o={a:r,b:a};return Qe.runKernel("RealDiv",o,{})}});function br(t,e){for(var n=[],r=Math.max(t.length,e.length),a=0;a<r;a++){var o=t[t.length-a-1];null==o&&(o=1);var s=e[e.length-a-1];if(null==s&&(s=1),1===o)n.unshift(s);else if(1===s)n.unshift(o);else{if(o!==s){var i="Operands could not be broadcast together with shapes "+"".concat(t," and ").concat(e,".");throw Error(i)}n.unshift(o)}}return n}var xr=rn({equal_:function(t,e){var n,r=tn(t,"a","equal","string_or_numeric"),a=tn(e,"b","equal","string_or_numeric");r=(n=l(qe(r,a),2))[0],a=n[1],br(r.shape,a.shape);var o={a:r,b:a};return Qe.runKernel("Equal",o)}});var Nr=rn({where_:function(t,e,n){var r=tn(e,"a","where"),a=tn(n,"b","where"),o=tn(t,"condition","where","bool"),s=br(br(o.shape,r.shape),a.shape),i={condition:Wn(o,s),t:Wn(r,s),e:Wn(a,s)};return Qe.runKernel("Select",i)}});var wr=rn({zerosLike_:function(t){var e={x:tn(t,"x","zerosLike")};return Qe.runKernel("ZerosLike",e)}});var kr=rn({divNoNan_:function(t,e){var n,r=tn(t,"a","div"),a=tn(e,"b","div");r=(n=l(qe(r,a),2))[0],a=n[1];var o=vr(r,a),s=wr(o),i=xr(a,s);return Nr(i,s,o)}});var Tr=rn({dot_:function(t,e){var n=tn(t,"t1","dot"),r=tn(e,"t2","dot");ot(!(1!==n.rank&&2!==n.rank||1!==r.rank&&2!==r.rank),(function(){return"Error in dot: inputs must all be rank 1 or 2, but got ranks "+"".concat(n.rank," and ").concat(r.rank,".")}));var a=1===n.rank?n.size:n.shape[1],o=1===r.rank?r.size:r.shape[0];if(ot(a===o,(function(){return"Error in dot: inner dimensions of inputs must match, but got "+"".concat(a," and ").concat(o,".")})),1===n.rank&&1===r.rank){var s=En(n,[1,-1]),i=En(r,[-1,1]),u=Mn(s,i);return En(u,[])}if(1===n.rank&&2===r.rank){s=En(n,[1,-1]),i=En(r,[r.shape[0],r.shape[1]]),u=Mn(s,i);return En(u,[u.size])}if(2===n.rank&&1===r.rank){i=En(r,[-1,1]),u=Mn(n,i);return En(u,[u.size])}return i=En(r,[r.shape[0],r.shape[1]]),u=Mn(n,i)}});var _r=rn({einsum_:function(t){for(var e=[],n=1;n<arguments.length;n++)e[n-1]=arguments[n];var r=e.map((function(t,e){return tn(t,"tensors".concat(e),"einsum")})),a={equation:t};return Qe.runKernel(Rt,r,a)}});var Sr=rn({elu_:function(t){var e={x:tn(t,"x","elu","float32")};return Qe.runKernel("Elu",e)}});var Er=rn({erf_:function(t){var e=tn(t,"x","erf");ot("int32"===e.dtype||"float32"===e.dtype,(function(){return"Input dtype must be `int32` or `float32`."})),"int32"===e.dtype&&(e=bn(e,"float32"));var n={x:e};return Qe.runKernel("Erf",n)}});function Ir(t,e){return function(t,e,n){for(var r=t.length+e.length,a=[],o=0,s=0,i=0;i<r;i++)-1===n.indexOf(i)?a.push(t[o++]):a.push(e[s++]);return a}(t,e.map((function(t){return 1})),e)}var Or=rn({max_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r={x:tn(t,"x","max")},a={reductionIndices:e,keepDims:n};return Qe.runKernel("Max",r,a)}});var Dr=rn({min_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r={x:tn(t,"x","min")},a={axis:e,keepDims:n};return Qe.runKernel("Min",r,a)}});var Ar=rn({pow_:function(t,e){var n,r=tn(t,"base","pow"),a=tn(e,"exp","pow"),o={a:r=(n=l(qe(r,a),2))[0],b:a=n[1]};return Qe.runKernel("Pow",o)}});function Mr(t,e,n,r){if(null==r&&(r=gt(t)),"complex64"===r)throw new Error("Cannot construct a complex64 tensor directly. Please use tf.complex(real, imag).");if("object"==typeof t&&"texture"in t){if("float32"!==r&&"int32"!==r)throw new Error("Creating tensor from texture only supports "+"'float32'|'int32' dtype, while the dtype is ".concat(r,"."));return t.channels=t.channels||"RGBA",Qe.backend.createTensorFromTexture(t,e||n,r)}if(!ft(t)&&!Array.isArray(t)&&"number"!=typeof t&&"boolean"!=typeof t&&"string"!=typeof t)throw new Error("values passed to tensor(values) must be a number/boolean/string or an array of numbers/booleans/strings, or a TypedArray");if(null!=e){Tt(e);var a=pt(e),o=pt(n);ot(a===o,(function(){return"Based on the provided shape, [".concat(e,"], the tensor should have ")+"".concat(a," values but has ").concat(o)}));for(var s=0;s<n.length;++s){var i=n[s],u=s!==n.length-1||i!==pt(e.slice(s));ot(n[s]===e[s]||!u,(function(){return"Error creating a new Tensor. Inferred shape "+"(".concat(n,") does not match the provided ")+"shape (".concat(e,"). ")}))}}return ft(t)||Array.isArray(t)||(t=[t]),e=e||n,t="string"!==r?we(t,r):ut(t,[],!0),Qe.makeTensor(t,e,r)}function Cr(t,e){if((ft(t)&&"string"!==e||Array.isArray(t))&&"complex64"!==e)throw new Error("Error creating a new Scalar: value must be a primitive (number|boolean|string)");if("string"===e&&ft(t)&&!(t instanceof Uint8Array))throw new Error("When making a scalar from encoded string, the value must be `Uint8Array`.");return Mr(t,[],[],e)}var Fr=rn({sqrt_:function(t){var e={x:tn(t,"x","sqrt","float32")};return Qe.runKernel("Sqrt",e)}});var zr=rn({square_:function(t){var e=tn(t,"x","square");return Qe.runKernel("Square",{x:e},{})}});var Rr=rn({sum_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=tn(t,"x","sum");"bool"===r.dtype&&(r=bn(r,"int32"));var a={x:r},o={axis:e,keepDims:n};return Qe.runKernel("Sum",a,o)}});function Vr(t,e,n){if(void 0===n&&(n=null),0===t.rank)return an(t);if(1!==t.rank&&null===n)return Vr(En(t,[-1]),e,n);if(1===t.rank||"number"==typeof n||Array.isArray(n)&&1===n.length){if(1===e)return Rr(an(t),n);if(e===1/0)return Or(an(t),n);if(e===-1/0)return Dr(an(t),n);if("euclidean"===e||2===e)return Fr(Rr(Ar(an(t),Cr(2,"int32")),n));throw new Error("Error in norm: invalid ord value: ".concat(e))}if(Array.isArray(n)&&2===n.length){if(1===e)return Or(Rr(an(t),n[0]),n[1]-1);if(e===1/0)return Or(Rr(an(t),n[1]),n[0]);if(e===-1/0)return Dr(Rr(an(t),n[1]),n[0]);if("fro"===e||"euclidean"===e)return Fr(Rr(zr(t),n));throw new Error("Error in norm: invalid ord value: ".concat(e))}throw new Error("Error in norm: invalid axis: ".concat(n))}var Lr=rn({norm_:function(t,e,n,r){void 0===e&&(e="euclidean"),void 0===n&&(n=null),void 0===r&&(r=!1);var a=Vr(t=tn(t,"x","norm"),e,n),o=a.shape;if(r){var s=ht(n,t.shape);o=Ir(a.shape,s)}return En(a,o)}});var Pr=rn({euclideanNorm_:function(t,e,n){return void 0===e&&(e=null),void 0===n&&(n=!1),Lr(t,"euclidean",e,n)}});var Br=rn({exp_:function(t){var e={x:tn(t,"x","exp")};return Qe.runKernel("Exp",e)}});var Kr=rn({expandDims_:function(t,e){void 0===e&&(e=0);var n=tn(t,"x","expandDims","string_or_numeric");ot(e<=n.rank,(function(){return"Axis must be <= rank of the tensor"}));var r={input:n},a={dim:e};return Qe.runKernel("ExpandDims",r,a)}});var jr=rn({expm1_:function(t){var e={x:tn(t,"x","expm1")};return Qe.runKernel("Expm1",e)}});var qr=rn({tile_:function(t,e){var n=tn(t,"x","tile","string_or_numeric");ot(n.rank===e.length,(function(){return"Error in transpose: rank of input ".concat(n.rank," ")+"must match length of reps ".concat(e,".")}));var r={x:n},a={reps:e};return Qe.runKernel(Lt,r,a)}});var Ur=rn({eye_:function(t,e,n,r){void 0===r&&(r="float32"),null==e&&(e=t);for(var a=Hn([t,e],r),o=t<=e?t:e,s=0;s<o;++s)a.set(1,s,s);var i=En(a.toTensor(),[t,e]);if(null==n)return i;if(1===n.length)return qr(Kr(i,0),[n[0],1,1]);if(2===n.length)return qr(Kr(Kr(i,0),0),[n[0],n[1],1,1]);if(3===n.length)return qr(Kr(Kr(Kr(i,0),0),0),[n[0],n[1],n[2],1,1]);throw new Error("eye() currently supports only 1D and 2D "+"batchShapes, but received ".concat(n.length,"D."))}});var Wr=rn({floor_:function(t){var e={x:tn(t,"x","floor","float32")};return Qe.runKernel("Floor",e)}});var Hr=rn({gather_:function(t,e,n,r){void 0===n&&(n=0),void 0===r&&(r=0);var a={x:tn(t,"x","gather"),indices:tn(e,"indices","gather","int32")},o={axis:n,batchDims:r};return Qe.runKernel("GatherV2",a,o)}});var Gr=rn({greater_:function(t,e){var n,r=tn(t,"a","greater","string_or_numeric"),a=tn(e,"b","greater","string_or_numeric");r=(n=l(qe(r,a),2))[0],a=n[1],br(r.shape,a.shape);var o={a:r,b:a};return Qe.runKernel("Greater",o)}});var Zr=rn({greaterEqual_:function(t,e){var n,r=tn(t,"a","greaterEqual","string_or_numeric"),a=tn(e,"b","greaterEqual","string_or_numeric");r=(n=l(qe(r,a),2))[0],a=n[1],br(r.shape,a.shape);var o={a:r,b:a};return Qe.runKernel("GreaterEqual",o)}});var Qr=rn({imag_:function(t){var e={input:tn(t,"input","imag")};return Qe.runKernel("Imag",e)}});var Yr=rn({isFinite_:function(t){var e={x:tn(t,"x","isFinite")};return Qe.runKernel("IsFinite",e)}});var Xr=rn({isInf_:function(t){var e={x:tn(t,"x","isInf")};return Qe.runKernel("IsInf",e)}});var Jr=rn({isNaN_:function(t){var e={x:tn(t,"x","isNaN")};return Qe.runKernel("IsNan",e)}});var $r=rn({leakyRelu_:function(t,e){void 0===e&&(e=.2);var n={x:tn(t,"x","leakyRelu")},r={alpha:e};return Qe.runKernel("LeakyRelu",n,r)}});var ta=rn({less_:function(t,e){var n,r=tn(t,"a","less","string_or_numeric"),a=tn(e,"b","less","string_or_numeric");r=(n=l(qe(r,a),2))[0],a=n[1],br(r.shape,a.shape);var o={a:r,b:a};return Qe.runKernel("Less",o)}});var ea=rn({lessEqual_:function(t,e){var n,r=tn(t,"a","lessEqual","string_or_numeric"),a=tn(e,"b","lessEqual","string_or_numeric");r=(n=l(qe(r,a),2))[0],a=n[1],br(r.shape,a.shape);var o={a:r,b:a};return Qe.runKernel("LessEqual",o)}});var na=rn({localResponseNormalization_:function(t,e,n,r,a){void 0===e&&(e=5),void 0===n&&(n=1),void 0===r&&(r=1),void 0===a&&(a=.5);var o=tn(t,"x","localResponseNormalization");ot(4===o.rank||3===o.rank,(function(){return"Error in localResponseNormalization: x must be rank 3 or 4 but got\n               rank ".concat(o.rank,".")})),ot(lt(e),(function(){return"Error in localResponseNormalization: depthRadius must be an "+"integer but got depthRadius ".concat(e,".")}));var s=o,i=!1;3===o.rank&&(i=!0,s=En(o,[1,o.shape[0],o.shape[1],o.shape[2]]));var u={x:s},p={depthRadius:e,bias:n,alpha:r,beta:a},c=Qe.runKernel("LRN",u,p);return i?En(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});var ra=rn({log_:function(t){var e={x:tn(t,"x","log","float32")};return Qe.runKernel("Log",e)}});var aa=rn({log1p_:function(t){var e={x:tn(t,"x","log1p")};return Qe.runKernel("Log1p",e)}});function oa(t){return Qe.customGrad(t)}var sa=rn({neg_:function(t){var e={x:tn(t,"x","neg")};return Qe.runKernel("Neg",e)}});var ia=rn({softplus_:function(t){var e={x:tn(t,"x","softplus")};return Qe.runKernel("Softplus",e)}});var ua=rn({logSigmoid_:function(t){var e=tn(t,"x","logSigmoid"),n=oa((function(t){return{value:sa(ia(sa(t))),gradFunc:function(e){return Cn(e,Fn(sa(t)))}}}));return n(e)}});var pa=rn({sub_:function(t,e){var n,r=tn(t,"a","sub"),a=tn(e,"b","sub"),o={a:r=(n=l(qe(r,a),2))[0],b:a=n[1]};return Qe.runKernel("Sub",o)}});var ca=rn({logSoftmax_:function(t,e){void 0===e&&(e=-1);var n=tn(t,"logits","logSoftmax");if(-1===e&&(e=n.rank-1),e!==n.rank-1)throw Error("Log Softmax along a non-last dimension is not yet supported. "+"Logits was rank ".concat(n.rank," and axis was ").concat(e));var r=oa((function(t,n){var r=Or(t,e,!0),a=pa(t,r),o=pa(bn(a,"float32"),ra(Rr(Br(a),e,!0)));n([o]);return{value:o,gradFunc:function(t,n){var r=l(n,1)[0],a=Br(r);return pa(t,Cn(Rr(t,e,!0),a))}}}));return r(n)}});var la=rn({logSumExp_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=tn(t,"x","logSumExp"),a=ht(e,r.shape),o=Or(r,a,!0),s=pa(r,o),i=Br(s),u=Rr(i,a),p=ra(u),c=un(En(o,p.shape),p);if(n){var l=Ir(c.shape,a);return En(c,l)}return c}});var da=rn({logicalAnd_:function(t,e){var n=tn(t,"a","logicalAnd","bool"),r=tn(e,"b","logicalAnd","bool");br(n.shape,r.shape);var a={a:n,b:r};return Qe.runKernel("LogicalAnd",a)}});var ha=rn({logicalNot_:function(t){var e={x:tn(t,"x","logicalNot","bool")};return Qe.runKernel("LogicalNot",e)}});var fa=rn({logicalOr_:function(t,e){var n=tn(t,"a","logicalOr","bool"),r=tn(e,"b","logicalOr","bool");br(n.shape,r.shape);var a={a:n,b:r};return Qe.runKernel("LogicalOr",a)}});var ma=rn({logicalXor_:function(t,e){var n=tn(t,"a","logicalXor","bool"),r=tn(e,"b","logicalXor","bool");return br(n.shape,r.shape),da(fa(t,e),ha(da(t,e)))}}),ya=2147483648;var ga=rn({searchSorted_:function(t,e,n){void 0===n&&(n="left");var r=tn(t,"sortedSequence","searchSorted"),a=tn(e,"values","searchSorted"),o=r.shape[r.shape.length-1],s=a.shape[a.shape.length-1],i=En(r,[-1,o]),u=En(a,[-1,s]);if(i.rank<2)throw new Error("Sorted input argument must be at least 2-dimensional");if(i.shape[0]!==u.shape[0])throw new Error("Leading dimension of 'sortedSequence' and 'values' must match.");if(pt(u.shape)>=ya)throw new Error("values tensor size must less than ".concat(ya));if(i.shape[1]>=ya)throw new Error("trailing dim_size must less than ".concat(ya," for int32 output type, was ").concat(i.shape[1]));var p={sortedSequence:i,values:u},c={side:n};return Qe.runKernel("SearchSorted",p,c)}});var va=rn({maxPool_:function(t,e,n,r,a){var o=tn(t,"x","maxPool"),s=o,i=!1;3===o.rank&&(i=!0,s=En(o,[1,o.shape[0],o.shape[1],o.shape[2]])),ot(4===s.rank,(function(){return"Error in maxPool: input must be rank 4 but got rank ".concat(s.rank,".")})),ot(_n(n,1),(function(){return"Error in maxPool: Either strides or dilations must be 1. "+"Got strides ".concat(n," and dilations '").concat(1,"'")})),Sn("maxPool",r,a);var u={x:s},p={filterSize:e,strides:n,pad:r,dimRoundingMode:a},c=Qe.runKernel("MaxPool",u,p);return i?En(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});var ba=rn({maxPool3d_:function(t,e,n,r,a,o){void 0===e&&(e=[1,1,1]),void 0===o&&(o="NDHWC");var s=tn(t,"x","maxPool3d"),i=s,u=!1;4===s.rank&&(u=!0,i=En(s,[1,s.shape[0],s.shape[1],s.shape[2],s.shape[3]])),ot(5===i.rank,(function(){return"Error in maxPool3d: x must be rank 5 but got rank ".concat(i.rank,".")})),ot("NDHWC"===o,(function(){return"Error in maxPool3d: Only NDHWC is currently supported, "+"but got dataFormat of ".concat(o)})),Sn("maxPool3d",r,a);var p={x:i},c={filterSize:e,strides:n,pad:r,dimRoundingMode:a,dataFormat:o},l=Qe.runKernel("MaxPool3D",p,c);return u?En(l,[l.shape[1],l.shape[2],l.shape[3],l.shape[4]]):l}});var xa=rn({maxPoolWithArgmax_:function(t,e,n,r,a){void 0===a&&(a=!1);var o={x:tn(t,"x","maxPoolWithArgmax")},s={filterSize:e,strides:n,pad:r,includeBatchInIndex:a},i=Qe.runKernel("MaxPoolWithArgmax",o,s);return{result:i[0],indexes:i[1]}}});var Na=rn({maximum_:function(t,e){var n,r=tn(t,"a","maximum"),a=tn(e,"b","maximum");r=(n=l(qe(r,a),2))[0],a=n[1],"bool"===r.dtype&&(r=bn(r,"int32"),a=bn(a,"int32")),br(r.shape,a.shape);var o={a:r,b:a};return Qe.runKernel("Maximum",o)}});var wa=rn({mean_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r={x:tn(t,"x","mean")},a={axis:e,keepDims:n};return Qe.runKernel("Mean",r,a)}});function ka(t,e){if(void 0===e&&(e="float32"),"complex64"===e){var n=ka(t,"float32"),r=ka(t,"float32");return Yn(n,r)}var a=kt(pt(t),e);return Qe.makeTensor(a,t,e)}function Ta(t,e){if(void 0===e&&(e="float32"),"complex64"===e){var n=Ta(t,"float32"),r=ka(t,"float32");return Yn(n,r)}var a=wt(pt(t),e);return Qe.makeTensor(a,t,e)}var _a=rn({minimum_:function(t,e){var n,r=tn(t,"a","minimum"),a=tn(e,"b","minimum");r=(n=l(qe(r,a),2))[0],a=n[1],"bool"===r.dtype&&(r=bn(r,"int32"),a=bn(a,"int32")),br(r.shape,a.shape);var o={a:r,b:a};return Qe.runKernel("Minimum",o)}});var Sa=rn({mirrorPad_:function(t,e,n){ot("reflect"===n||"symmetric"===n,(function(){return"Invalid mode. Mode must be either reflect or symmetric. "+"Got ".concat(n,".")}));var r=tn(t,"x","mirrorPad");if(0===r.rank)throw new Error("mirrorPad(scalar) is not defined. Pass non-scalar to mirrorPad");ot(e.length===r.rank,(function(){return"Padding doesn't match input. Must be ".concat(r.rank,". ")+"Got ".concat(e.length,".")}));for(var a="reflect"===n?1:0,o=function(t){ot(2===e[t].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),ot(e[t][0]>=0&&e[t][0]<=r.shape[t]-a&&e[t][1]>=0&&e[t][1]<=r.shape[t]-a,(function(){return"Padding in dimension ".concat(t," cannot be greater than or equal ")+"to ".concat(r.shape[t]-a," or less than 0 for input of ")+"shape ".concat(r.shape)}))},s=0;s<r.rank;s++)o(s);var i={paddings:e,mode:n},u={x:r};return Qe.runKernel("MirrorPad",u,i)}});var Ea=rn({mod_:function(t,e){var n,r=tn(t,"a","mod"),a=tn(e,"b","mod"),o={a:r=(n=l(qe(r,a),2))[0],b:a=n[1]};return Qe.runKernel("Mod",o)}});var Ia=rn({moments_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=ht(e,(t=tn(t,"x","moments")).shape),a=wa(t,r,n),o=a.shape;n||(o=Ir(a.shape,r));var s=zr(pa(bn(t,"float32"),En(a,o)));return{mean:a,variance:wa(s,r,n)}}});var Oa=rn({multiRNNCell_:function(t,e,n,r){for(var a=tn(e,"data","multiRNNCell"),o=en(n,"c","multiRNNCell"),s=en(r,"h","multiRNNCell"),i=a,u=[],p=0;p<t.length;p++){var c=t[p](i,o[p],s[p]);u.push(c[0]),u.push(c[1]),i=c[1]}var l=[],d=[];for(p=0;p<u.length;p+=2)l.push(u[p]),d.push(u[p+1]);return[l,d]}});var Da=rn({multinomial_:function(t,e,n,r){void 0===r&&(r=!1);var a=tn(t,"logits","multinomial"),o=a.size,s=a.rank;if(o<2)throw new Error("Error in multinomial: you need at least 2 outcomes, but got "+"".concat(o,"."));if(s>2)throw new Error("Rank of probabilities must be 1 or 2, but is ".concat(s));n=n||Math.random();var i={logits:1===s?En(a,[1,-1]):a},u={numSamples:e,seed:n,normalized:r},p=Qe.runKernel("Multinomial",i,u);return 1===s?En(p,[p.size]):p}});var Aa=rn({notEqual_:function(t,e){var n,r=tn(t,"a","notEqual","string_or_numeric"),a=tn(e,"b","notEqual","string_or_numeric");r=(n=l(qe(r,a),2))[0],a=n[1],br(r.shape,a.shape);var o={a:r,b:a};return Qe.runKernel("NotEqual",o)}});var Ma=rn({oneHot_:function(t,e,n,r,a){if(void 0===n&&(n=1),void 0===r&&(r=0),void 0===a&&(a="int32"),e<2)throw new Error("Error in oneHot: depth must be >=2, but it is ".concat(e));var o={indices:tn(t,"indices","oneHot","int32")},s={dtype:a,depth:e,onValue:n,offValue:r};return Qe.runKernel("OneHot",o,s)}});var Ca=rn({onesLike_:function(t){var e={x:tn(t,"x","onesLike")};return Qe.runKernel("OnesLike",e)}});var Fa=rn({outerProduct_:function(t,e){var n=tn(t,"v1","outerProduct"),r=tn(e,"v2","outerProduct");ot(1===n.rank&&1===r.rank,(function(){return"Error in outerProduct: inputs must be rank 1, but got ranks "+"".concat(n.rank," and ").concat(r.rank,".")}));var a=En(n,[-1,1]),o=En(r,[1,-1]);return Mn(a,o)}});var za=rn({pad_:function(t,e,n){void 0===n&&(n=0);var r=tn(t,"x","pad");if(0===r.rank)throw new Error("pad(scalar) is not defined. Pass non-scalar to pad");var a={paddings:e,constantValue:n},o={x:r};return Qe.runKernel("PadV2",o,a)}});var Ra=rn({pad1d_:function(t,e,n){return void 0===n&&(n=0),ot(2===e.length,(function(){return"Invalid number of paddings. Must be length of 2."})),za(t,[e],n)}});var Va=rn({pad2d_:function(t,e,n){return void 0===n&&(n=0),ot(2===e.length&&2===e[0].length&&2===e[1].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),za(t,e,n)}});var La=rn({pad3d_:function(t,e,n){return void 0===n&&(n=0),ot(3===e.length&&2===e[0].length&&2===e[1].length&&2===e[2].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),za(t,e,n)}});var Pa=rn({pad4d_:function(t,e,n){return void 0===n&&(n=0),ot(4===e.length&&2===e[0].length&&2===e[1].length&&2===e[2].length&&2===e[3].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),za(t,e,n)}});var Ba=rn({spaceToBatchND_:function(t,e,n){var r=tn(t,"x","spaceToBatchND");ot(r.rank>=1+e.length,(function(){return"input rank ".concat(r.rank," should be > than [blockShape] ").concat(e.length)})),ot(n.length===e.length,(function(){return"paddings.shape[0] ".concat(n.length," must be equal to [blockShape] ").concat(e.length)})),ot(r.shape.reduce((function(t,r,a){return a>0&&a<=e.length?t&&(r+n[a-1][0]+n[a-1][1])%e[a-1]==0:t}),!0),(function(){return"input spatial dimensions ".concat(r.shape.slice(1)," with paddings ").concat(n.toString()," must be divisible by blockShapes ").concat(e.toString())}));var a={x:r},o={blockShape:e,paddings:n};return Qe.runKernel("SpaceToBatchND",a,o)}});var Ka=rn({pool_:function(t,e,n,r,a,o,s){null==a&&(a=[1,1]),null==o&&(o=1),0===r&&(r="valid");var i=tn(t,"x","maxPool"),u=i,p=!1;3===i.rank&&(p=!0,u=En(i,[1,i.shape[0],i.shape[1],i.shape[2]])),ot(_n(o,a),(function(){return"Error in pool: Either strides or dilations must be 1. "+"Got strides ".concat(o," and dilations '").concat(a,"'")}));var c,d=function(t,e,n,r,a,o,s){void 0===s&&(s="channelsLast");var i,u=l(Nn(e),2),p=u[0],c=u[1];if("channelsLast"===s)i=[p,c,t[3],t[3]];else{if("channelsFirst"!==s)throw new Error("Unknown dataFormat ".concat(s));i=[p,c,t[1],t[1]]}return xn(t,i,n,r,a,o,!1,s)}(u.shape,e,o,a,r),h=[d.dilationHeight,d.dilationWidth];c="same"===r?function(t,e){var n=t.map((function(t,n){return t+(t-1)*(e[n]-1)})).map((function(t){return t-1})),r=n.map((function(t){return Math.floor(t/2)})),a=n.map((function(t,e){return t-r[e]}));return n.map((function(t,e){return[r[e],a[e]]}))}([d.filterHeight,d.filterWidth],h):[[0,0],[0,0]];var f=1===h[0]&&1===h[1],m=l(function(t,e,n){var r=n.map((function(t){return t[0]})),a=n.map((function(t){return t[1]})),o=t.concat(r,a),s=e.map((function(t,e){return(t-o[e]%t)%t})),i=a.map((function(t,e){return t+s[e]})),u=e.map((function(t,e){return[r[e],i[e]]})),p=e.map((function(t,e){return[0,s[e]]}));return[u,p]}([d.inHeight,d.inWidth],h,c),2),y=m[0],g=m[1],v=f?r:"valid",b=f?u:Ba(u,h,y),x=("avg"===n?function(){return In(b,e,o,v,s)}:function(){return va(b,e,o,v,s)})(),N=f?x:Ln(x,h,g);return p?En(N,[N.shape[1],N.shape[2],N.shape[3]]):N}});var ja=rn({prelu_:function(t,e){var n={x:tn(t,"x","prelu"),alpha:tn(e,"alpha","prelu")};return Qe.runKernel("Prelu",n)}});var qa=rn({prod_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=tn(t,"x","prod");"bool"===r.dtype&&(r=bn(r,"int32"));var a={x:r},o={axis:e,keepDims:n};return Qe.runKernel("Prod",a,o)}});var Ua=rn({raggedGather_:function(t,e,n,r){var a={paramsNestedSplits:t.map((function(t,e){return tn(t,"tensors".concat(e),"raggedGather","int32")})),paramsDenseValues:tn(e,"paramsDenseValues","raggedGather"),indices:tn(n,"indices","raggedGather","int32")},o={outputRaggedRank:r},s=Qe.runKernel("RaggedGather",a,o);return{outputNestedSplits:s.slice(0,s.length-1),outputDenseValues:s[s.length-1]}}});var Wa=rn({raggedRange_:function(t,e,n){var r=tn(t,"starts","raggedRange"),a={starts:r,limits:tn(e,"limits","raggedRange",r.dtype),deltas:tn(n,"deltas","raggedRange",r.dtype)},o=Qe.runKernel("RaggedRange",a);return{rtNestedSplits:o[0],rtDenseValues:o[1]}}});var Ha=rn({raggedTensorToTensor_:function(t,e,n,r,a){var o=tn(t,"shape","raggedTensorToTensor","int32"),s=tn(e,"values","raggedTensorToTensor"),i={shape:o,values:s,defaultValue:tn(n,"defaultValue","raggedTensorToTensor",s.dtype),rowPartitionTensors:r.map((function(t,e){return tn(t,"tensors".concat(e),"raggedTensorToTensor","int32")}))},u={rowPartitionTypes:a};return Qe.runKernel("RaggedTensorToTensor",i,u)}});var Ga=rn({rand_:function(t,e,n){var r=pt(t),a=null;if(null==n||"float32"===n)a=new Float32Array(r);else if("int32"===n)a=new Int32Array(r);else{if("bool"!==n)throw new Error("Unknown data type ".concat(n));a=new Uint8Array(r)}for(var o=0;o<r;o++)a[o]=e();return Qe.makeTensor(a,t,n)}}),Za="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function Qa(t){if(t.__esModule)return t;var e=Object.defineProperty({},"__esModule",{value:!0});return Object.keys(t).forEach((function(n){var r=Object.getOwnPropertyDescriptor(t,n);Object.defineProperty(e,n,r.get?r:{enumerable:!0,get:function(){return t[n]}})})),e}function Ya(t){var e={exports:{}};return t(e,e.exports),e.exports}var Xa=Ya((function(t){!function(t,e,n){function r(t){var e,n=this,r=(e=4022871197,function(t){t=String(t);for(var n=0;n<t.length;n++){var r=.02519603282416938*(e+=t.charCodeAt(n));r-=e=r>>>0,e=(r*=e)>>>0,e+=4294967296*(r-=e)}return 2.3283064365386963e-10*(e>>>0)});n.next=function(){var t=2091639*n.s0+2.3283064365386963e-10*n.c;return n.s0=n.s1,n.s1=n.s2,n.s2=t-(n.c=0|t)},n.c=1,n.s0=r(" "),n.s1=r(" "),n.s2=r(" "),n.s0-=r(t),n.s0<0&&(n.s0+=1),n.s1-=r(t),n.s1<0&&(n.s1+=1),n.s2-=r(t),n.s2<0&&(n.s2+=1),r=null}function a(t,e){return e.c=t.c,e.s0=t.s0,e.s1=t.s1,e.s2=t.s2,e}function o(t,e){var n=new r(t),o=e&&e.state,s=n.next;return s.int32=function(){return 4294967296*n.next()|0},s.double=function(){return s()+11102230246251565e-32*(2097152*s()|0)},s.quick=s,o&&("object"==typeof o&&a(o,n),s.state=function(){return a(n,{})}),s}e&&e.exports?e.exports=o:n&&n.amd?n((function(){return o})):this.alea=o}(0,t,!1)})),Ja=Ya((function(t){!function(t,e,n){function r(t){var e=this,n="";e.x=0,e.y=0,e.z=0,e.w=0,e.next=function(){var t=e.x^e.x<<11;return e.x=e.y,e.y=e.z,e.z=e.w,e.w^=e.w>>>19^t^t>>>8},t===(0|t)?e.x=t:n+=t;for(var r=0;r<n.length+64;r++)e.x^=0|n.charCodeAt(r),e.next()}function a(t,e){return e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e}function o(t,e){var n=new r(t),o=e&&e.state,s=function(){return(n.next()>>>0)/4294967296};return s.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},s.int32=n.next,s.quick=s,o&&("object"==typeof o&&a(o,n),s.state=function(){return a(n,{})}),s}e&&e.exports?e.exports=o:n&&n.amd?n((function(){return o})):this.xor128=o}(0,t,!1)})),$a=Ya((function(t){!function(t,e,n){function r(t){var e=this,n="";e.next=function(){var t=e.x^e.x>>>2;return e.x=e.y,e.y=e.z,e.z=e.w,e.w=e.v,(e.d=e.d+362437|0)+(e.v=e.v^e.v<<4^t^t<<1)|0},e.x=0,e.y=0,e.z=0,e.w=0,e.v=0,t===(0|t)?e.x=t:n+=t;for(var r=0;r<n.length+64;r++)e.x^=0|n.charCodeAt(r),r==n.length&&(e.d=e.x<<10^e.x>>>4),e.next()}function a(t,e){return e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e.v=t.v,e.d=t.d,e}function o(t,e){var n=new r(t),o=e&&e.state,s=function(){return(n.next()>>>0)/4294967296};return s.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},s.int32=n.next,s.quick=s,o&&("object"==typeof o&&a(o,n),s.state=function(){return a(n,{})}),s}e&&e.exports?e.exports=o:n&&n.amd?n((function(){return o})):this.xorwow=o}(0,t,!1)})),to=Ya((function(t){!function(t,e,n){function r(t){var e=this;e.next=function(){var t,n,r=e.x,a=e.i;return t=r[a],n=(t^=t>>>7)^t<<24,n^=(t=r[a+1&7])^t>>>10,n^=(t=r[a+3&7])^t>>>3,n^=(t=r[a+4&7])^t<<7,t=r[a+7&7],n^=(t^=t<<13)^t<<9,r[a]=n,e.i=a+1&7,n},function(t,e){var n,r=[];if(e===(0|e))r[0]=e;else for(e=""+e,n=0;n<e.length;++n)r[7&n]=r[7&n]<<15^e.charCodeAt(n)+r[n+1&7]<<13;for(;r.length<8;)r.push(0);for(n=0;n<8&&0===r[n];++n);for(8==n&&(r[7]=-1),t.x=r,t.i=0,n=256;n>0;--n)t.next()}(e,t)}function a(t,e){return e.x=t.x.slice(),e.i=t.i,e}function o(t,e){null==t&&(t=+new Date);var n=new r(t),o=e&&e.state,s=function(){return(n.next()>>>0)/4294967296};return s.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},s.int32=n.next,s.quick=s,o&&(o.x&&a(o,n),s.state=function(){return a(n,{})}),s}e&&e.exports?e.exports=o:n&&n.amd?n((function(){return o})):this.xorshift7=o}(0,t,!1)})),eo=Ya((function(t){!function(t,e,n){function r(t){var e=this;e.next=function(){var t,n,r=e.w,a=e.X,o=e.i;return e.w=r=r+1640531527|0,n=a[o+34&127],t=a[o=o+1&127],n^=n<<13,t^=t<<17,n^=n>>>15,t^=t>>>12,n=a[o]=n^t,e.i=o,n+(r^r>>>16)|0},function(t,e){var n,r,a,o,s,i=[],u=128;for(e===(0|e)?(r=e,e=null):(e+="\0",r=0,u=Math.max(u,e.length)),a=0,o=-32;o<u;++o)e&&(r^=e.charCodeAt((o+32)%e.length)),0===o&&(s=r),r^=r<<10,r^=r>>>15,r^=r<<4,r^=r>>>13,o>=0&&(s=s+1640531527|0,a=0==(n=i[127&o]^=r+s)?a+1:0);for(a>=128&&(i[127&(e&&e.length||0)]=-1),a=127,o=512;o>0;--o)r=i[a+34&127],n=i[a=a+1&127],r^=r<<13,n^=n<<17,r^=r>>>15,n^=n>>>12,i[a]=r^n;t.w=s,t.X=i,t.i=a}(e,t)}function a(t,e){return e.i=t.i,e.w=t.w,e.X=t.X.slice(),e}function o(t,e){null==t&&(t=+new Date);var n=new r(t),o=e&&e.state,s=function(){return(n.next()>>>0)/4294967296};return s.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},s.int32=n.next,s.quick=s,o&&(o.X&&a(o,n),s.state=function(){return a(n,{})}),s}e&&e.exports?e.exports=o:n&&n.amd?n((function(){return o})):this.xor4096=o}(0,t,!1)})),no=Ya((function(t){!function(t,e,n){function r(t){var e=this,n="";e.next=function(){var t=e.b,n=e.c,r=e.d,a=e.a;return t=t<<25^t>>>7^n,n=n-r|0,r=r<<24^r>>>8^a,a=a-t|0,e.b=t=t<<20^t>>>12^n,e.c=n=n-r|0,e.d=r<<16^n>>>16^a,e.a=a-t|0},e.a=0,e.b=0,e.c=-1640531527,e.d=1367130551,t===Math.floor(t)?(e.a=t/4294967296|0,e.b=0|t):n+=t;for(var r=0;r<n.length+20;r++)e.b^=0|n.charCodeAt(r),e.next()}function a(t,e){return e.a=t.a,e.b=t.b,e.c=t.c,e.d=t.d,e}function o(t,e){var n=new r(t),o=e&&e.state,s=function(){return(n.next()>>>0)/4294967296};return s.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},s.int32=n.next,s.quick=s,o&&("object"==typeof o&&a(o,n),s.state=function(){return a(n,{})}),s}e&&e.exports?e.exports=o:n&&n.amd?n((function(){return o})):this.tychei=o}(0,t,!1)})),ro=Qa({__proto__:null,default:{}}),ao=Ya((function(t){!function(e,n,r){var a,o=256,s=r.pow(o,6),i=r.pow(2,52),u=2*i,p=255;function c(t,p,c){var y=[],g=f(h((p=1==p?{entropy:!0}:p||{}).entropy?[t,m(n)]:null==t?function(){try{var t;return a&&(t=a.randomBytes)?t=t(o):(t=new Uint8Array(o),(e.crypto||e.msCrypto).getRandomValues(t)),m(t)}catch(t){var r=e.navigator,s=r&&r.plugins;return[+new Date,e,s,e.screen,m(n)]}}():t,3),y),v=new l(y),b=function(){for(var t=v.g(6),e=s,n=0;t<i;)t=(t+n)*o,e*=o,n=v.g(1);for(;t>=u;)t/=2,e/=2,n>>>=1;return(t+n)/e};return b.int32=function(){return 0|v.g(4)},b.quick=function(){return v.g(4)/4294967296},b.double=b,f(m(v.S),n),(p.pass||c||function(t,e,n,a){return a&&(a.S&&d(a,v),t.state=function(){return d(v,{})}),n?(r.random=t,e):t})(b,g,"global"in p?p.global:this==r,p.state)}function l(t){var e,n=t.length,r=this,a=0,s=r.i=r.j=0,i=r.S=[];for(n||(t=[n++]);a<o;)i[a]=a++;for(a=0;a<o;a++)i[a]=i[s=p&s+t[a%n]+(e=i[a])],i[s]=e;(r.g=function(t){for(var e,n=0,a=r.i,s=r.j,i=r.S;t--;)e=i[a=p&a+1],n=n*o+i[p&(i[a]=i[s=p&s+e])+(i[s]=e)];return r.i=a,r.j=s,n})(o)}function d(t,e){return e.i=t.i,e.j=t.j,e.S=t.S.slice(),e}function h(t,e){var n,r=[],a=typeof t;if(e&&"object"==a)for(n in t)try{r.push(h(t[n],e-1))}catch(t){}return r.length?r:"string"==a?t:t+"\0"}function f(t,e){for(var n,r=t+"",a=0;a<r.length;)e[p&a]=p&(n^=19*e[p&a])+r.charCodeAt(a++);return m(e)}function m(t){return String.fromCharCode.apply(0,t)}if(f(r.random(),n),t.exports){t.exports=c;try{a=ro}catch(t){}}else r.seedrandom=c}("undefined"!=typeof self?self:Za,[],Math)}));ao.alea=Xa,ao.xor128=Ja,ao.xorwow=$a,ao.xorshift7=to,ao.xor4096=eo,ao.tychei=no;var oo=ao,so=function(){function t(t,e,n,r,a){this.mean=t,this.stdDev=e,this.dtype=n,this.nextVal=NaN,this.truncated=r,this.truncated&&(this.upper=this.mean+2*this.stdDev,this.lower=this.mean-2*this.stdDev);var o=a||Math.random();this.random=oo.alea(o.toString())}return t.prototype.nextValue=function(){if(!isNaN(this.nextVal)){var t=this.nextVal;return this.nextVal=NaN,t}for(var e,n,r=!1;!r;){var a=void 0,o=void 0,s=void 0;do{s=(a=2*this.random()-1)*a+(o=2*this.random()-1)*o}while(s>=1||0===s);var i=Math.sqrt(-2*Math.log(s)/s);e=this.mean+this.stdDev*a*i,n=this.mean+this.stdDev*o*i,this.truncated&&!this.isValidTruncated(e)||(r=!0)}return this.truncated&&!this.isValidTruncated(n)||(this.nextVal=this.convertValue(n)),this.convertValue(e)},t.prototype.convertValue=function(t){return null==this.dtype||"float32"===this.dtype?t:Math.round(t)},t.prototype.isValidTruncated=function(t){return t<=this.upper&&t>=this.lower},t}(),io=function(){function t(t,e,n,r){this.alpha=t,this.beta=1/e,this.dtype=n;var a=r||Math.random();this.randu=oo.alea(a.toString()),this.randn=new so(0,1,n,!1,this.randu()),this.d=t<1?t+2/3:t-1/3,this.c=1/Math.sqrt(9*this.d)}return t.prototype.nextValue=function(){for(var t,e,n,r,a,o;;){do{r=this.randn.nextValue(),o=1+this.c*r}while(o<=0);if(o*=o*o,e=1-.331*(t=r*r)*t,n=.5*t+this.d*(1-o+Math.log(o)),(a=this.randu())<e||Math.log(a)<n)break}return o=1/this.beta*this.d*o,this.alpha<1&&(o*=Math.pow(this.randu(),1/this.alpha)),this.convertValue(o)},t.prototype.convertValue=function(t){return"float32"===this.dtype?t:Math.round(t)},t}(),uo=function(){function t(t,e,n,r){void 0===t&&(t=0),void 0===e&&(e=1);var a=this;if(this.canReturnFloat=function(){return null==a.dtype||"float32"===a.dtype},this.min=t,this.range=e-t,this.dtype=n,null==r&&(r=Math.random()),"number"==typeof r&&(r=r.toString()),!this.canReturnFloat()&&this.range<=1)throw new Error("The difference between ".concat(t," - ").concat(e," <= 1 and dtype is not float"));this.random=oo.alea(r)}return t.prototype.convertValue=function(t){return this.canReturnFloat()?t:Math.round(t)},t.prototype.nextValue=function(){return this.convertValue(this.min+this.range*this.random())},t}();var po=rn({randomGamma_:function(t,e,n,r,a){if(void 0===n&&(n=1),void 0===r&&(r="float32"),null==n&&(n=1),null==r&&(r="float32"),"float32"!==r&&"int32"!==r)throw new Error("Unsupported data type ".concat(r));for(var o=new io(e,n,r,a),s=Hn(t,r),i=0;i<s.values.length;i++)s.values[i]=o.nextValue();return s.toTensor()}});var co=rn({randomNormal_:function(t,e,n,r,a){if(void 0===e&&(e=0),void 0===n&&(n=1),null!=r&&"bool"===r)throw new Error("Unsupported data type ".concat(r));for(var o=new so(e,n,r,!1,a),s=Hn(t,r),i=0;i<s.values.length;i++)s.values[i]=o.nextValue();return s.toTensor()}});var lo=rn({randomStandardNormal_:function(t,e,n){if(null!=e&&"bool"===e)throw new Error("Unsupported data type ".concat(e));return co(t,0,1,e,n)}});var ho=rn({randomUniform_:function(t,e,n,r,a){void 0===e&&(e=0),void 0===n&&(n=1),void 0===r&&(r="float32");for(var o=Hn(t,r),s=new uo(e,n,null,a),i=0;i<o.values.length;i++)o.values[i]=s.nextValue();return o.toTensor()}});function fo(t,e,n,r){if(void 0===n&&(n=1),void 0===r&&(r="float32"),0===n)throw new Error("Cannot have a step of zero");var a={start:t,stop:e,step:n,dtype:r};return Qe.runKernel("Range",{},a)}var mo=rn({real_:function(t){var e={input:tn(t,"input","real")};return Qe.runKernel("Real",e)}});var yo=rn({reciprocal_:function(t){var e={x:tn(t,"x","reciprocal")};return Qe.runKernel("Reciprocal",e)}});var go=rn({relu_:function(t){var e={x:tn(t,"x","relu")};return Qe.runKernel("Relu",e)}});var vo=rn({relu6_:function(t){var e={x:tn(t,"x","relu6")};return Qe.runKernel("Relu6",e)}});var bo=rn({reverse_:function(t,e){var n={x:tn(t,"x","reverse")},r={dims:e};return Qe.runKernel("Reverse",n,r)}});var xo=rn({reverse1d_:function(t){var e=tn(t,"x","reverse");return ot(1===e.rank,(function(){return"Error in reverse1D: x must be rank 1 but got rank ".concat(e.rank,".")})),bo(e,0)}});var No=rn({reverse2d_:function(t,e){var n=tn(t,"x","reverse");return ot(2===n.rank,(function(){return"Error in reverse2D: x must be rank 2 but got rank ".concat(n.rank,".")})),bo(n,e)}});var wo=rn({reverse3d_:function(t,e){var n=tn(t,"x","reverse");return ot(3===n.rank,(function(){return"Error in reverse3D: x must be rank 3 but got rank ".concat(n.rank,".")})),bo(n,e)}});var ko=rn({reverse4d_:function(t,e){var n=tn(t,"x","reverse");return ot(4===n.rank,(function(){return"Error in reverse4D: x must be rank 4 but got rank ".concat(n.rank,".")})),bo(n,e)}});var To=rn({round_:function(t){var e={x:tn(t,"x","round")};return Qe.runKernel("Round",e)}});var _o=rn({rsqrt_:function(t){var e={x:tn(t,"x","rsqrt","float32")};return Qe.runKernel("Rsqrt",e)}});var So=rn({selu_:function(t){var e={x:tn(t,"x","selu")};return Qe.runKernel("Selu",e)}});var Eo=rn({separableConv2d_:function(t,e,n,r,a,o,s){void 0===o&&(o=[1,1]),void 0===s&&(s="NHWC");var i=tn(t,"x","separableConv2d"),u=tn(e,"depthwiseFilter","separableConv2d"),p=tn(n,"pointwiseFilter","separableConv2d"),c=i,l=!1;if(3===i.rank&&(l=!0,c=En(i,[1,i.shape[0],i.shape[1],i.shape[2]])),"NCHW"===s)throw new Error("separableConv2d currently does not support dataFormat NCHW; only NHWC is supported");ot(4===c.rank,(function(){return"Error in separableConv2d: input must be rank 4, but got "+"rank ".concat(c.rank,".")})),ot(4===u.rank,(function(){return"Error in separableConv2d: depthwise filter must be rank 4, but "+"got rank ".concat(u.rank,".")})),ot(4===p.rank,(function(){return"Error in separableConv2d: pointwise filter must be rank 4, but "+"got rank ".concat(u.rank,".")})),ot(1===p.shape[0],(function(){return"Error in separableConv2d: the first dimension of pointwise filter "+" must be 1, but got ".concat(p.shape[0],".")})),ot(1===p.shape[1],(function(){return"Error in separableConv2d: the second dimension of pointwise "+"filter must be 1, but got ".concat(p.shape[1],".")}));var d=u.shape[2],h=u.shape[3];ot(p.shape[2]===d*h,(function(){return"Error in separableConv2d: the third dimension of pointwise filter "+"must be ".concat(d*h,", ")+"but got ".concat(p.shape[2],".")}));var f=fr(c,u,r,a,s,o),m=er(f,p,1,"valid",s);return l?En(m,[m.shape[1],m.shape[2],m.shape[3]]):m}});var Io=function(t,e){return u(this,void 0,void 0,(function(){var n,r,a,o,s,i,u,c,l,d;return p(this,(function(p){switch(p.label){case 0:return n=tn(t,"x","setdiff1d"),r=tn(e,"y","setdiff1d"),ot(n.dtype===r.dtype,(function(){return"x and y should have the same dtype, but got x (".concat(n.dtype,") and y (").concat(r.dtype,").")})),ot(1===n.rank,(function(){return"x should be 1D tensor, but got x (".concat(n.shape,").")})),ot(1===r.rank,(function(){return"y should be 1D tensor, but got y (".concat(r.shape,").")})),[4,n.data()];case 1:return a=p.sent(),[4,r.data()];case 2:for(o=p.sent(),s=new Set(o),i=0,l=0;l<a.length;l++)s.has(a[l])||i++;for(u=new Me([i],n.dtype),c=new Me([i],"int32"),l=0,d=0;l<a.length;l++)s.has(a[l])||(u.values[d]=a[l],c.values[d]=l,d++);return[2,[u.toTensor(),c.toTensor()]]}}))}))};var Oo=rn({sign_:function(t){var e={x:tn(t,"x","sign")};return Qe.runKernel("Sign",e)}});var Do=rn({sin_:function(t){var e={x:tn(t,"x","sin","float32")};return Qe.runKernel("Sin",e)}});var Ao=rn({sinh_:function(t){var e={x:tn(t,"x","sinh")};return Qe.runKernel("Sinh",e)}});var Mo=rn({slice1d_:function(t,e,n){var r=tn(t,"x","slice1d");return ot(1===r.rank,(function(){return"slice1d expects a rank-1 tensor, but got a rank-".concat(r.rank," tensor")})),zn(r,[e],[n])}});var Co=rn({slice2d_:function(t,e,n){var r=tn(t,"x","slice2d");return ot(2===r.rank,(function(){return"slice2d expects a rank-2 tensor, but got a rank-".concat(r.rank," tensor")})),zn(r,e,n)}});var Fo=rn({slice3d_:function(t,e,n){var r=tn(t,"x","slice3d");return ot(3===r.rank,(function(){return"slice3d expects a rank-3 tensor, but got a rank-".concat(r.rank," tensor")})),zn(r,e,n)}});var zo=rn({slice4d_:function(t,e,n){var r=tn(t,"x","slice4d");return ot(4===r.rank,(function(){return"slice4d expects a rank-4 tensor, but got a rank-".concat(r.rank," tensor")})),zn(r,e,n)}});var Ro=rn({softmax_:function(t,e){void 0===e&&(e=-1);var n=tn(t,"logits","softmax","float32");if(-1===e&&(e=n.rank-1),e!==n.rank-1)throw Error("Softmax along a non-last dimension is not yet supported. "+"Logits was rank ".concat(n.rank," and dim was ").concat(e));var r={logits:n},a={dim:e};return Qe.runKernel("Softmax",r,a)}});var Vo=rn({fft_:function(t){ot("complex64"===t.dtype,(function(){return"The dtype for tf.spectral.fft() must be complex64 "+"but got ".concat(t.dtype,".")}));var e={input:t};return Qe.runKernel("FFT",e)}});var Lo=rn({ifft_:function(t){ot("complex64"===t.dtype,(function(){return"The dtype for tf.spectral.ifft() must be complex64 "+"but got ".concat(t.dtype,".")}));var e={input:t};return Qe.runKernel("IFFT",e)}});var Po=rn({irfft_:function(t){var e,n=t.shape[t.shape.length-1],r=t.size/n;if(n<=2){var a=En(t,[r,n]);e=Lo(a)}else{var o=[r,2*(n-1)],s=En(mo(t),[r,n]),i=En(Qr(t),[r,n]),u=bo(zn(s,[0,1],[r,n-2]),1),p=Cn(bo(zn(i,[0,1],[r,n-2]),1),Cr(-1)),c=An([s,u],1),l=An([i,p],1);a=En(Yn(c,l),[o[0],o[1]]);e=Lo(a)}if(e=mo(e),3===t.rank&&0!==t.shape[0]){var d=e,h=t.shape[0];e=En(e,[h,e.shape[0]/h,e.shape[1]]),d.dispose()}return e}});var Bo=rn({split_:function(t,e,n){void 0===n&&(n=0);var r={x:tn(t,"x","split")},a={numOrSizeSplits:e,axis:n};return Qe.runKernel("SplitV",r,a)}});var Ko=rn({rfft_:function(t,e){ot("float32"===t.dtype,(function(){return"The dtype for rfft() must be real value but got ".concat(t.dtype)}));var n,r=t.shape[t.shape.length-1],a=t.size/r;if(null!=e&&e<r){var o=t.shape.map((function(t){return 0})),s=t.shape.map((function(t){return t}));s[t.shape.length-1]=e,n=zn(t,o,s),r=e}else if(null!=e&&e>r){var i=t.shape.map((function(t){return t}));i[t.shape.length-1]=e-r,n=An([t,ka(i)],t.shape.length-1),r=e}else n=t;var u=wr(n),p=En(Yn(n,u),[a,r]),c=Vo(p),l=Math.floor(r/2)+1,d=mo(c),h=Qr(c),f=Bo(d,[l,r-l],d.shape.length-1),m=Bo(h,[l,r-l],h.shape.length-1),y=n.shape.slice();return y[n.shape.length-1]=l,En(Yn(f[0],m[0]),y)}});var jo=rn({squaredDifference_:function(t,e){var n,r=tn(t,"a","squaredDifference"),a=tn(e,"b","squaredDifference");r=(n=l(qe(r,a),2))[0],a=n[1],br(r.shape,a.shape);var o={a:r,b:a};return Qe.runKernel("SquaredDifference",o,{})}});var qo=rn({squeeze_:function(t,e){var n=tn(t,"x","squeeze","string_or_numeric");return En(n,function(t,e){for(var n=[],r=[],a=null!=e&&Array.isArray(e)&&0===e.length,o=null==e||a?null:ht(e,t).sort(),s=0,i=0;i<t.length;++i){if(null!=o){if(o[s]===i&&1!==t[i])throw new Error("Can't squeeze axis ".concat(i," since its dim '").concat(t[i],"' is not 1"));(null==o[s]||o[s]>i)&&1===t[i]&&(n.push(t[i]),r.push(i)),o[s]<=i&&s++}1!==t[i]&&(n.push(t[i]),r.push(i))}return{newShape:n,keptDims:r}}(n.shape,e).newShape)}});var Uo=rn({stack_:function(t,e){void 0===e&&(e=0);var n=en(t,"tensors","stack","string_or_numeric");ot(n.length>=1,(function(){return"Pass at least one tensor to tf.stack"})),n.length>0&&ot(e<=n[0].rank,(function(){return"Axis must be <= rank of the tensor"}));var r=n,a={axis:e};return Qe.runKernel("Pack",r,a)}});var Wo=rn({step_:function(t,e){void 0===e&&(e=0);var n={x:tn(t,"x","step")},r={alpha:e};return Qe.runKernel("Step",n,r)}});var Ho=rn({stridedSlice_:function(t,e,n,r,a,o,s,i,u){void 0===a&&(a=0),void 0===o&&(o=0),void 0===s&&(s=0),void 0===i&&(i=0),void 0===u&&(u=0);var p={x:tn(t,"x","stridedSlice","string_or_numeric")},c={begin:e,end:n,strides:r,beginMask:a,endMask:o,ellipsisMask:s,newAxisMask:i,shrinkAxisMask:u};return Qe.runKernel("StridedSlice",p,c)}});var Go=rn({tan_:function(t){var e={x:tn(t,"x","tan","float32")};return Qe.runKernel("Tan",e)}});function Zo(t,e,n){return Mr(t,e,Xe(t,n),n)}function Qo(t,e){it(t);var n=Xe(t,e);if(1!==n.length)throw new Error("tensor1d() requires values to be a flat/TypedArray");return Mr(t,null,n,e)}function Yo(t,e,n){if(it(t),null!=e&&2!==e.length)throw new Error("tensor2d() requires shape to have two numbers");var r=Xe(t,n);if(2!==r.length&&1!==r.length)throw new Error("tensor2d() requires values to be number[][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor2d() requires shape to be provided when `values` are a flat/TypedArray");return Mr(t,e,r,n)}var Xo=rn({topk_:function(t,e,n){void 0===e&&(e=1),void 0===n&&(n=!0);var r=tn(t,"x","topk");if(0===r.rank)throw new Error("topk() expects the input to be of rank 1 or higher");var a=r.shape[r.shape.length-1];if(e<0)throw new Error("'k' passed to topk() must be >= 0 but got ".concat(e));if(e>a)throw new Error("'k' passed to topk() must be <= the last dimension (".concat(a,") ")+"but got ".concat(e));var o={x:r},s={k:e,sorted:n},i=l(Qe.runKernel("TopK",o,s),2);return{values:i[0],indices:i[1]}}});var Jo=rn({truncatedNormal_:function(t,e,n,r,a){if(void 0===e&&(e=0),void 0===n&&(n=1),null!=r&&"bool"===r)throw new Error("Unsupported data type $ { dtype }");for(var o=new so(e,n,r,!0,a),s=Hn(t,r),i=0;i<s.values.length;i++)s.values[i]=o.nextValue();return s.toTensor()}});var $o=rn({unique_:function(t,e){void 0===e&&(e=0);var n=tn(t,"x","unique","string_or_numeric");ot(n.rank>0,(function(){return"The input tensor must be at least 1D"}));var r={x:n},a={axis:e},o=l(Qe.runKernel("Unique",r,a),2);return{values:o[0],indices:o[1]}}});var ts=rn({unsortedSegmentSum_:function(t,e,n){var r=tn(t,"x","unsortedSegmentSum"),a=tn(e,"segmentIds","unsortedSegmentSum","int32");ot(lt(n),(function(){return"numSegments must be of dtype int"}));var o={x:r,segmentIds:a},s={numSegments:n};return Qe.runKernel("UnsortedSegmentSum",o,s)}});var es=rn({unstack_:function(t,e){void 0===e&&(e=0);var n=tn(t,"x","unstack","string_or_numeric");ot(e>=-n.shape.length&&e<n.shape.length,(function(){return"Axis = ".concat(e," is not in [-").concat(n.shape.length,", ").concat(n.shape.length,")")}));var r={value:n},a={axis:e};return Qe.runKernel("Unpack",r,a)}});var ns=function(t){return u(this,void 0,void 0,(function(){var e,n,r;return p(this,(function(a){switch(a.label){case 0:return[4,(e=tn(t,"condition","whereAsync","bool")).data()];case 1:return n=a.sent(),r=function(t,e){for(var n=[],r=0;r<e.length;r++)e[r]&&n.push(r);var a=Hn(t,"int32"),o=Hn([n.length,t.length],"int32");for(r=0;r<n.length;r++){var s=a.indexToLoc(n[r]),i=r*t.length;o.values.set(s,i)}return o.toTensor()}(e.shape,n),t!==e&&e.dispose(),[2,r]}}))}))};var rs=function(t,e,n){return u(this,void 0,void 0,(function(){var r,a,o,s,i,u,c,l,d,h,f,m,y;return p(this,(function(p){switch(p.label){case 0:for(r=tn(t,"tensor","boolMask"),a=tn(e,"mask","boolMask","bool"),o=null==n?0:n,s=a.rank,i=r.shape,ot(s>0,(function(){return"mask cannot be scalar"})),st(i.slice(o,o+s),a.shape,"mask's shape must match the first K dimensions of tensor's shape,"),u=1,c=o;c<o+s;c++)u*=i[c];return l=i.slice(0,o).concat([u],i.slice(o+s)),d=En(r,l),h=En(a,[-1]),[4,ns(h)];case 1:return f=p.sent(),m=qo(f,[1]),y=Hr(d,m,o),t!==r&&r.dispose(),e!==a&&a.dispose(),m.dispose(),d.dispose(),h.dispose(),f.dispose(),[2,y]}}))}))};var as=rn({transpose_:function(t,e,n){var r=tn(t,"x","transpose");if(null==e&&(e=r.shape.map((function(t,e){return e})).reverse()),ot(r.rank===e.length,(function(){return"Error in transpose: rank of input ".concat(r.rank," ")+"must match length of perm ".concat(e,".")})),e.forEach((function(t){ot(t>=0&&t<r.rank,(function(){return"All entries in 'perm' must be between 0 and ".concat(r.rank-1)+" but got ".concat(e)}))})),r.rank<=1)return r.clone();var a,o,s={x:r},i={perm:e};return"complex64"===r.dtype?(a=function(){var t=mo(r),e=Qr(r);return t=Qe.runKernel(Pt,{x:t},i),e=Qe.runKernel(Pt,{x:e},i),n&&(e=sa(e)),Yn(t,e)},Qe.tidy(a,o)):Qe.runKernel(Pt,s,i)}});var os=rn({movingAverage_:function(t,e,n,r,a){void 0===a&&(a=!0);var o,s,i=tn(t,"v","movingAverage"),u=tn(e,"x","movingAverage"),p=tn(n,"decay","movingAverage");s=u,ot((o=i).dtype===s.dtype,(function(){return"The dtypes of the first(".concat(o.dtype,") and")+" second(".concat(s.dtype,") input must match")})),ot(ct(i.shape,u.shape),(function(){return"Shape mismatch in v and x"}));var c=Cr(1),l=pa(c,p),d=Cn(pa(u,i),l);if(a){ot(null!=r,(function(){return"When using zeroDebias: true, step is required."}));var h=tn(r,"step","movingAverage");d=vr(d,pa(c,Ar(p,h)))}return un(i,d)}});function ss(t,e,n){if(e.rank<1)throw new Error("tf.scatterND() expects the indices to be rank 1 or higher,"+" but the rank was ".concat(e.rank,"."));if(t.rank<1)throw new Error("tf.scatterND() expects the updates to be rank 1 or higher,"+" but the rank was ".concat(t.rank,"."));if("int32"!==e.dtype)throw new Error("The dtype of 'indices' should be int32, but got dtype: ".concat(e.dtype));if(n.length<1)throw new Error("Output rank must be greater or equal to 1, but got shape: ".concat(n));if(0===n.length){if(0===e.size)throw new Error("Indices specified for empty output. indices shape: ".concat(e.shape));if(0===t.size)throw new Error("Updates specified for empty output. updates shape: ".concat(t.shape))}!function(t,e,n){var r=e.rank>1?e.shape[e.rank-1]:1,a=e.rank>1?e.rank-1:1,o="Must have updates.shape = indices.shape[:batchDim] + "+"shape[sliceDim:], got updates.shape: ".concat(n.shape)+", indices.shape: ".concat(e.shape,", shape: ").concat(t)+", sliceDim: ".concat(r,", and batchDim: ").concat(a,".");if(n.rank<a)throw new Error(o+" update.rank < ".concat(a,". "));if(t.length<r+(n.rank-a))throw new Error(o+" Output shape length < ".concat(r+(n.rank-a)));if(n.rank!==a+t.length-r)throw new Error(o+" update.rank != ".concat(a+t.length-r));for(var s=0;s<a;++s)if(n.shape[s]!==e.shape[s])throw new Error(o+" updates.shape[".concat(s,"] (").concat(n.shape[s],") != indices.shape[").concat(s,"] (").concat(e.shape[s],")."));for(s=0;s<n.rank-a;++s)if(n.shape[s+a]!==t[s+r])throw new Error(o+" updates.shape[".concat(s+a,"] (").concat(n.shape[s+a],") != shape[").concat(s+a,"] (").concat(t[s+a],")"))}(n,e,t)}var is=rn({scatterND_:function(t,e,n){var r=tn(t,"indices","scatterND","int32"),a=tn(e,"updates","scatterND");ss(a,r,n);var o={indices:r,updates:a},s={shape:n};return Qe.runKernel("ScatterNd",o,s)}});var us=rn({sparseToDense_:function(t,e,n,r){void 0===r&&(r=0);var a=tn(t,"sparseIndices","sparseToDense","int32"),o=tn(e,"sparseValues","sparseToDense","string_or_numeric"),s=tn(r,"defaultValue","sparseToDense",o.dtype);!function(t,e,n,r){if("int32"!==t.dtype)throw new Error("tf.sparseToDense() expects the indices to be int32 type,"+" but the dtype was ".concat(t.dtype,"."));if(t.rank>2)throw new Error("sparseIndices should be a scalar, vector, or matrix,"+" but got shape ".concat(t.shape,"."));var a=t.rank>0?t.shape[0]:1,o=t.rank>1?t.shape[1]:1;if(n.length!==o)throw new Error("outputShape has incorrect number of elements:,"+" ".concat(n.length,", should be: ").concat(o,"."));var s=e.size;if(0!==e.rank&&(1!==e.rank||s!==a))throw new Error("sparseValues has incorrect shape "+"".concat(e.shape,", should be [] or [").concat(a,"]"));if(e.dtype!==r.dtype)throw new Error("sparseValues.dtype must match defaultValues.dtype")}(a,o,n,s);var i={sparseIndices:a,sparseValues:o,defaultValue:s},u={outputShape:n};return Qe.runKernel("SparseToDense",i,u)}});var ps=rn({gatherND_:function(t,e){var n=tn(e,"indices","gatherND","int32"),r={params:tn(t,"x","gatherND","string_or_numeric"),indices:n};return Qe.runKernel("GatherNd",r)}});var cs=rn({dropout_:function(t,e,n,r){var a=tn(t,"x","dropout");if(ot("float32"===a.dtype,(function(){return"x has to be a floating point tensor since it's going to be "+"scaled, but got a ".concat(a.dtype," tensor instead.")})),ot(e>=0&&e<1,(function(){return"rate must be a float in the range [0, 1), but got ".concat(e,".")})),0===e)return t instanceof ze?a.clone():a;var o=function(t,e){if(null==e)return t.shape.slice();if(ct(t.shape,e))return e;if(t.shape.length===e.length){for(var n=[],r=0;r<t.shape.length;r++)null==e[r]&&null!=t.shape[r]?n.push(t.shape[r]):n.push(e[r]);return n}return e}(a,n),s=1-e,i=vr(Wr(un(ho(o,0,1,"float32",r),s)),s);return Cn(a,i)}});function ls(t){return Math.floor(Math.pow(2,Math.ceil(Math.log(t)/Math.log(2))))}function ds(t,e,n){for(var r=1-t%2,a=new Float32Array(t),o=0;o<t;++o){var s=2*Math.PI*o/(t+r-1);a[o]=e-n*Math.cos(s)}return Qo(a,"float32")}var hs=function(t,e,n){return void 0===n&&(n=1),u(this,void 0,void 0,(function(){var r,a,o,s,i,u,c,d,h,f,m,y,g,v;return p(this,(function(p){switch(p.label){case 0:return r=tn(t,"predictions","inTopK"),a=tn(e,"targets","inTopK"),ot(r.rank>1,(function(){return"inTopK() expects the predictions to be of rank 2 or higher, "+"but got ".concat(r.rank)})),ot(r.rank-1===a.rank,(function(){return"predictions rank should be 1 larger than targets rank, but got predictions rank "+"".concat(r.rank," and targets rank ").concat(a.rank)})),st(r.shape.slice(0,r.shape.length-1),a.shape,"predictions's shape should be align with the targets' shape, except the last dimension."),o=r.shape[r.shape.length-1],ot(n>0&&n<=o,(function(){return"'k' passed to inTopK() must be > 0 && <= the predictions last "+"dimension (".concat(o,"), but got ").concat(n)})),[4,r.data()];case 1:return s=p.sent(),[4,a.data()];case 2:for(i=p.sent(),u=l([s.length/o,o],2),c=u[0],d=u[1],h=function(t,e){var n=null;if(null==t||"float32"===t)n=new Float32Array(e);else if("int32"===t)n=new Int32Array(e);else{if("bool"!==t)throw new Error("Unknown data type ".concat(t));n=new Uint8Array(e)}return n}("bool",c),f=0;f<c;f++){for(m=f*d,y=s.subarray(m,m+d),g=[],v=0;v<y.length;v++)g.push({value:y[v],index:v});for(g.sort((function(t,e){return e.value-t.value})),h[f]=0,v=0;v<n;v++)if(g[v].index===i[f]){h[f]=1;break}}return t!==r&&r.dispose(),e!==a&&a.dispose(),[2,Zo(h,a.shape,"bool")]}}))}))};var fs=rn({conv2DBackpropFilter_:function(t,e,n,r,a,o,s){void 0===o&&(o="NHWC");var i=t;3===t.rank&&(i=En(t,[1,t.shape[0],t.shape[1],t.shape[2]]));var u=e;3===u.rank&&(u=En(e,[1,e.shape[0],e.shape[1],e.shape[2]])),ot(4===i.rank,(function(){return"Error in conv2dDerFilter: input must be rank 4, but got shape "+"".concat(i.shape,".")})),ot(4===u.rank,(function(){return"Error in conv2dDerFilter: dy must be rank 4, but got shape "+"".concat(u.shape,".")})),ot(4===n.length,(function(){return"Error in conv2dDerFilter: filterShape must be length 4, but got "+"".concat(n,".")}));var p="NHWC"===o?i.shape[3]:i.shape[1],c="NHWC"===o?u.shape[3]:u.shape[1];ot(p===n[2],(function(){return"Error in conv2dDerFilter: depth of input ".concat(p,") must ")+"match input depth in filter (".concat(n[2],".")})),ot(c===n[3],(function(){return"Error in conv2dDerFilter: depth of dy (".concat(c,") must ")+"match output depth for filter (".concat(n[3],").")})),Sn("conv2dDerFilter",a,s);var l={x:i,dy:u},d={strides:r,pad:a,dataFormat:o,dimRoundingMode:s,filterShape:n};return Qe.runKernel("Conv2DBackpropFilter",l,d)}});function ms(t,e,n){if(null==n||"linear"===n)return t;if("relu"===n)return Cn(t,Wo(e));throw new Error("Cannot compute gradient for fused activation ".concat(n,"."))}function ys(t,e){var n=e,r=function(t,e){for(var n=[],r=0;r<e.length;r++){var a=t[t.length-r-1],o=e.length-r-1,s=e[o];(null==a||1===a&&s>1)&&n.unshift(o)}return n}(t.shape,e.shape);return r.length>0&&(n=Rr(n,r)),En(n,t.shape)}function gs(t,e,n,r){if("linear"===e)return t;if("relu"===e)return go(t);if("elu"===e)return Sr(t);if("relu6"===e)return vo(t);if("prelu"===e)return ja(t,n);if("leakyrelu"===e)return $r(t,r);if("sigmoid"===e)return Fn(t);throw new Error("Unknown fused activation ".concat(e,"."))}var vs=function(t,e){return!(t>0)||"linear"===e};var bs=rn({fusedConv2d_:function(t){var e,n=t.x,r=t.filter,a=t.strides,o=t.pad,s=t.dataFormat,i=void 0===s?"NHWC":s,u=t.dilations,p=void 0===u?[1,1]:u,c=t.dimRoundingMode,d=t.bias,h=t.activation,f=void 0===h?"linear":h,m=t.preluActivationWeights,y=t.leakyreluAlpha;if(f=f||"linear",!1===vs(Qe.state.gradientDepth,f)){ot("NHWC"===i,(function(){return"Error in fused conv2d: got dataFormat of ".concat(i," but ")+"only NHWC is currently supported for the case of gradient depth is 0 and the activation is not linear."}));var g=er(n,r,a,o,i,p,c);return null!=d&&(g=un(g,d)),gs(g,f,m,y)}var v=tn(n,"x","conv2d","float32"),b=tn(r,"filter","conv2d","float32"),x=v,N=!1;3===v.rank&&(N=!0,x=En(v,[1,v.shape[0],v.shape[1],v.shape[2]])),ot(4===x.rank,(function(){return"Error in fused conv2d: input must be rank 4, but got rank "+"".concat(x.rank,".")})),ot(4===b.rank,(function(){return"Error in fused conv2d: filter must be rank 4, but got rank "+"".concat(b.rank,".")})),Sn("fused conv2d",o,c);var w="NHWC"===i?x.shape[3]:x.shape[1];ot(b.shape[2]===w,(function(){return"Error in conv2d: depth of input (".concat(w,") must match ")+"input depth for filter ".concat(b.shape[2],".")})),ot(_n(a,p),(function(){return"Error in conv2D: Either strides or dilations must be 1. "+"Got strides ".concat(a," and dilations '").concat(p,"'")}));var k,T,_=xn(x.shape,b.shape,a,p,o,c);if(null!=d&&(e=l(qe(k=tn(d,"bias","fused conv2d"),v),1),k=e[0],"NHWC"===i?br(_.outShape,k.shape):(ot(k.shape.length<=1,(function(){return"Error in fused conv2d: only supports scalar or 1-D Tensor bias for NCHW format but got the bias of "+"rank-".concat(k.shape.length,".")})),ot(0===k.shape.length||k.shape[0]===_.outChannels||1===k.shape[0],(function(){return"Error in fused conv2d: bias shape (".concat(k.shape,") is not ")+"compatible with the number of output channels "+"(".concat(_.outChannels,")")})))),null!=m){var S=m.shape;if(ot(S.length<=1||3===S.length,(function(){return"Error in fused conv2d: only supports scalar, 1-D Tensor or 3-D Tensor PReLU activation weights but got a tensor of "+"rank-".concat(S.length,".")})),1===S.length)ot(1===S[0]||S[0]===_.outChannels,(function(){return"Error in fused conv2d: PReLU activation weights "+"(".concat(S,") is not compatible with the number of output ")+"channels (".concat(_.outChannels,").")}));else if(3===S.length)try{br(S,_.outShape)}catch(t){var E="Error in fused conv2d: PReLU activation weights (".concat(S,") ")+"is not compatible with the output shape of the conv2d "+"(".concat(_.outShape,").");throw Error(E)}T=tn(m,"prelu weights","fused conv2d")}var I=function(t,e){ot("NHWC"===i,(function(){return"Error in gradient of fused conv2D: got dataFormat of ".concat(i," but only NHWC is currently supported.")}));var n=l(e,4),r=n[0],s=n[1],u=n[2],c=n[3],d=ms(t,u,f);ot(Tn(p),(function(){return"Error in gradient of fused conv2D: dilation rates greater than 1 "+"are not yet supported in gradients. Got dilations '".concat(p,"'")}));var h=[rr(s.shape,d,r,a,o),fs(s,d,r.shape,a,o)];if(null!=c){var m=ys(c,d);h.push(m)}return h},O={x:x,filter:b,bias:k,preluActivationWeights:T},D={strides:a,pad:o,dataFormat:i,dilations:p,dimRoundingMode:c,activation:f,leakyreluAlpha:y};if(null==d){var A=oa((function(t,e,n){var r=Qe.runKernel(Kt,O,D);return n([e,t,r]),N&&(r=En(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:I}}));return A(x,b)}var M=oa((function(t,e,n,r){var a=Qe.runKernel(Kt,O,D);return r([e,t,a,n]),N&&(a=En(a,[a.shape[1],a.shape[2],a.shape[3]])),{value:a,gradFunc:I}}));return M(x,b,k)}});var xs=rn({depthwiseConv2dNativeBackpropFilter_:function(t,e,n,r,a,o,s){void 0===o&&(o=[1,1]);var i=t;3===t.rank&&(i=En(t,[1,t.shape[0],t.shape[1],t.shape[2]]));var u=e;3===u.rank&&(u=En(e,[1,e.shape[0],e.shape[1],e.shape[2]]));var p={x:i,dy:u},c={strides:r,pad:a,dimRoundingMode:s,dilations:o,filterShape:n};return Qe.runKernel("DepthwiseConv2dNativeBackpropFilter",p,c)}});var Ns=rn({depthwiseConv2dNativeBackpropInput_:function(t,e,n,r,a,o,s){void 0===o&&(o=[1,1]);var i=e,u=!1;3===e.rank&&(u=!0,i=En(e,[1,e.shape[0],e.shape[1],e.shape[2]]));var p={dy:i,filter:n},c={strides:r,pad:a,dimRoundingMode:s,dilations:o,inputShape:t},l=Qe.runKernel("DepthwiseConv2dNativeBackpropInput",p,c);return u?En(l,[l.shape[1],l.shape[2],l.shape[3]]):l}});var ws=rn({fusedDepthwiseConv2d_:function(t){var e,n=t.x,r=t.filter,a=t.strides,o=t.pad,s=t.dataFormat,i=void 0===s?"NHWC":s,u=t.dilations,p=void 0===u?[1,1]:u,c=t.dimRoundingMode,d=t.bias,h=t.activation,f=void 0===h?"linear":h,m=t.preluActivationWeights,y=t.leakyreluAlpha;if(!1===vs(Qe.state.gradientDepth,f)){var g=fr(n,r,a,o,i,p,c);return null!=d&&(g=un(g,d)),gs(g,f,m,y)}var v=tn(n,"x","depthwiseConv2d","float32"),b=tn(r,"filter","depthwiseConv2d","float32"),x=v,N=!1;3===v.rank&&(N=!0,x=En(v,[1,v.shape[0],v.shape[1],v.shape[2]])),ot(4===x.rank,(function(){return"Error in fused depthwiseConv2d: input must be rank 4, but got "+"rank ".concat(x.rank,".")})),ot(4===b.rank,(function(){return"Error in fused depthwiseConv2d: filter must be rank 4, "+"but got rank ".concat(b.rank,".")})),ot(x.shape[3]===b.shape[2],(function(){return"Error in fused depthwiseConv2d: number of input channels "+"(".concat(x.shape[3],") must match the inChannels dimension in ")+"filter ".concat(b.shape[2],".")})),null==p&&(p=[1,1]),ot(_n(a,p),(function(){return"Error in fused depthwiseConv2d: Either strides or dilations must "+"be 1. Got strides ".concat(a," and dilations '").concat(p,"'")})),Sn("fused depthwiseConv2d",o,c);var w,k,T=xn(x.shape,b.shape,a,p,o,c,!0);null!=d&&(e=l(qe(w=tn(d,"bias","fused conv2d"),v),1),w=e[0],br(T.outShape,w.shape)),null!=m&&(k=tn(m,"prelu weights","fused depthwiseConv2d"));var _=function(t,e){ot(Tn(p),(function(){return"Error in gradient of fused depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations "+"'".concat(p,"'")}));var n=l(e,4),r=n[0],s=n[1],i=n[2],u=n[3],d=ms(t,i,f),h=Ns(s.shape,d,r,a,o,p,c),m=xs(s,d,r.shape,a,o,p,c);return null!=u?[h,m,ys(w,d)]:[h,m]},S={x:x,filter:b,bias:w,preluActivationWeights:k},E={strides:a,pad:o,dataFormat:i,dilations:p,dimRoundingMode:c,activation:f,leakyreluAlpha:y};if(null==d){var I=oa((function(t,e,n){var r=Qe.runKernel(jt,S,E);return n([e,t,r]),N&&(r=En(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:_}}));return I(x,b)}var O=oa((function(t,e,n,r){var a=Qe.runKernel(jt,S,E);return r([e,t,a,n]),N&&(a=En(a,[a.shape[1],a.shape[2],a.shape[3]])),{value:a,gradFunc:_}}));return O(x,b,w)}});var ks={__proto__:null,conv2d:bs,depthwiseConv2d:ws,matMul:rn({fusedMatMul_:function(t){var e,n=t.a,r=t.b,a=t.transposeA,o=void 0!==a&&a,s=t.transposeB,i=void 0!==s&&s,u=t.bias,p=t.activation,c=void 0===p?"linear":p,d=t.preluActivationWeights,h=t.leakyreluAlpha,f=void 0===h?.2:h;if(!1===vs(Qe.state.gradientDepth,c)){var m=Mn(n,r,o,i);return null!=u&&(m=un(m,u)),gs(m,c,d,f)}var y=tn(n,"a","fused matMul"),g=tn(r,"b","fused matMul");e=l(qe(y,g),2),y=e[0],g=e[1];var v=o?y.shape[y.rank-2]:y.shape[y.rank-1],b=i?g.shape[g.rank-1]:g.shape[g.rank-2],x=o?y.shape[y.rank-1]:y.shape[y.rank-2],N=i?g.shape[g.rank-2]:g.shape[g.rank-1],w=y.shape.slice(0,-2),k=g.shape.slice(0,-2),T=pt(w),_=pt(k);ot(v===b,(function(){return"Error in fused matMul: inner shapes (".concat(v,") and (")+"".concat(b,") of Tensors with shapes ").concat(y.shape," and ")+"".concat(g.shape," and transposeA=").concat(o)+" and transposeB=".concat(i," must match.")}));var S,E,I=br(y.shape.slice(0,-2),g.shape.slice(0,-2)).concat([x,N]),O=En(y,o?[T,v,x]:[T,x,v]),D=En(g,i?[_,N,b]:[_,b,N]);null!=u&&(S=l(qe(S=tn(u,"bias","fused matMul"),y),1)[0],br(I,S.shape)),null!=d&&(E=tn(d,"prelu weights","fused matMul"));var A=function(t,e){var n,r,a=l(e,4),s=a[0],p=a[1],d=a[2],h=a[3],f=ms(En(t,d.shape),d,c);return o||i?!o&&i?(n=Mn(f,p,!1,!1),r=Mn(f,s,!0,!1)):o&&!i?(n=Mn(p,f,!1,!0),r=Mn(s,f,!1,!1)):(n=Mn(p,f,!0,!0),r=Mn(f,s,!0,!0)):(n=Mn(f,p,!1,!0),r=Mn(s,f,!0,!1)),null!=u?[n,r,ys(h,f)]:[n,r]},M={a:O,b:D,bias:S,preluActivationWeights:E},C={transposeA:o,transposeB:i,activation:c,leakyreluAlpha:f};if(null==u){var F=oa((function(t,e,n){var r=Qe.runKernel(Bt,M,C);return n([t,e,r]),{value:En(r,I),gradFunc:A}}));return F(O,D)}var z=oa((function(t,e,n,r){var a=Qe.runKernel(Bt,M,C);return r([t,e,a,n]),{value:En(a,I),gradFunc:A}}));return z(O,D,S)}})};var Ts=rn({hammingWindow_:function(t){return ds(t,.54,.46)}});var _s=rn({hannWindow_:function(t){return ds(t,.5,.5)}});var Ss=rn({frame_:function(t,e,n,r,a){void 0===r&&(r=!1),void 0===a&&(a=0);for(var o=0,s=[];o+e<=t.size;)s.push(zn(t,o,e)),o+=n;if(r)for(;o<t.size;){var i=o+e-t.size,u=An([zn(t,o,e-i),Zn([i],a)]);s.push(u),o+=n}return 0===s.length?Yo([],[0,e]):En(An(s),[s.length,e])}});var Es=rn({stft_:function(t,e,n,r,a){void 0===a&&(a=_s),null==r&&(r=ls(e));var o=Ss(t,e,n),s=Cn(o,a(e));return Ko(s,r)}});var Is=rn({cropAndResize_:function(t,e,n,r,a,o){void 0===a&&(a="bilinear"),void 0===o&&(o=0);var s=tn(t,"image","cropAndResize"),i=tn(e,"boxes","cropAndResize","float32"),u=tn(n,"boxInd","cropAndResize","int32"),p=i.shape[0];ot(4===s.rank,(function(){return"Error in cropAndResize: image must be rank 4,"+"but got rank ".concat(s.rank,".")})),ot(2===i.rank&&4===i.shape[1],(function(){return"Error in cropAndResize: boxes must be have size [".concat(p,",4] ")+"but had shape ".concat(i.shape,".")})),ot(1===u.rank&&u.shape[0]===p,(function(){return"Error in cropAndResize: boxInd must be have size [".concat(p,"] ")+"but had shape ".concat(i.shape,".")})),ot(2===r.length,(function(){return"Error in cropAndResize: cropSize must be of length 2, but got "+"length ".concat(r.length,".")})),ot(r[0]>=1&&r[1]>=1,(function(){return"cropSize must be atleast [1,1], but was ".concat(r)})),ot("bilinear"===a||"nearest"===a,(function(){return"method must be bilinear or nearest, but was ".concat(a)}));var c={image:s,boxes:i,boxInd:u},l={method:a,extrapolationValue:o,cropSize:r};return Qe.runKernel("CropAndResize",c,l)}});var Os=rn({flipLeftRight_:function(t){var e=tn(t,"image","flipLeftRight","float32");ot(4===e.rank,(function(){return"Error in flipLeftRight: image must be rank 4,"+"but got rank ".concat(e.rank,".")}));var n={image:e};return Qe.runKernel("FlipLeftRight",n,{})}});var Ds=rn({grayscaleToRGB_:function(t){var e=tn(t,"image","grayscaleToRGB"),n=e.rank-1,r=e.shape[n];ot(e.rank>=2,(function(){return"Error in grayscaleToRGB: images must be at least rank 2, "+"but got rank ".concat(e.rank,".")})),ot(1===r,(function(){return"Error in grayscaleToRGB: last dimension of a grayscale image "+"should be size 1, but got size ".concat(r,".")}));var a=new Array(e.rank);return a.fill(1,0,n),a[n]=3,qr(e,a)}});var As=rn({rotateWithOffset_:function(t,e,n,r){void 0===n&&(n=0),void 0===r&&(r=.5);var a=tn(t,"image","rotateWithOffset","float32");ot(4===a.rank,(function(){return"Error in rotateWithOffset: image must be rank 4,"+"but got rank ".concat(a.rank,".")}));var o={image:a},s={radians:e,fillValue:n,center:r};return Qe.runKernel("RotateWithOffset",o,s)}});function Ms(t,e,n,r,a,o){null==r&&(r=.5),null==a&&(a=Number.NEGATIVE_INFINITY),null==o&&(o=0);var s=t.shape[0];return n=Math.min(n,s),ot(0<=r&&r<=1,(function(){return"iouThreshold must be in [0, 1], but was '".concat(r,"'")})),ot(2===t.rank,(function(){return"boxes must be a 2D tensor, but was of rank '".concat(t.rank,"'")})),ot(4===t.shape[1],(function(){return"boxes must have 4 columns, but 2nd dimension was ".concat(t.shape[1])})),ot(1===e.rank,(function(){return"scores must be a 1D tensor"})),ot(e.shape[0]===s,(function(){return"scores has incompatible shape with boxes. Expected ".concat(s,", ")+"but was ".concat(e.shape[0])})),ot(0<=o&&o<=1,(function(){return"softNmsSigma must be in [0, 1], but was '".concat(o,"'")})),{maxOutputSize:n,iouThreshold:r,scoreThreshold:a,softNmsSigma:o}}var Cs=rn({nonMaxSuppression_:function(t,e,n,r,a){void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY);var o=tn(t,"boxes","nonMaxSuppression","float32"),s=tn(e,"scores","nonMaxSuppression","float32"),i=Ms(o,s,n,r,a),u={maxOutputSize:n=i.maxOutputSize,iouThreshold:r=i.iouThreshold,scoreThreshold:a=i.scoreThreshold};return Qe.runKernel("NonMaxSuppressionV3",{boxes:o,scores:s},u)}});function Fs(t,e,n){var r=function(t,e,n){return function(t,e,n){var r=0,a=t.length,o=0,s=!1;for(;r<a;){var i=n(e,t[o=r+(a-r>>>1)]);i>0?r=o+1:(a=o,s=!i)}return s?r:-r-1}(t,e,n||zs)}(t,e,n),a=r<0?-(r+1):r;t.splice(a,0,e)}function zs(t,e){return t>e?1:t<e?-1:0}function Rs(t,e,n,r,a,o,s,i,u){void 0===s&&(s=!1),void 0===i&&(i=!1),void 0===u&&(u=!1);for(var p=[],c=0;c<e.length;c++)e[c]>a&&p.push({score:e[c],boxIndex:c,suppressBeginIndex:0});p.sort(Ps);for(var h=o>0?-.5/o:0,f=[],m=[];f.length<n&&p.length>0;){var y=p.pop(),g=y.score,v=y.boxIndex,b=y.suppressBeginIndex;if(g<a)break;for(var x=!1,N=f.length-1;N>=b;--N){var w=Vs(t,v,f[N]);if(w>=r){x=!0;break}if(y.score=y.score*Ls(r,h,w),y.score<=a)break}y.suppressBeginIndex=f.length,x||(y.score===g?(f.push(v),m.push(y.score)):y.score>a&&Fs(p,y,Ps))}var k=f.length,T=n-k;i&&T>0&&(f.push.apply(f,d([],l(new Array(T).fill(0)),!1)),m.push.apply(m,d([],l(new Array(T).fill(0)),!1)));var _={selectedIndices:f};return s&&(_.selectedScores=m),u&&(_.validOutputs=k),_}function Vs(t,e,n){var r=t.subarray(4*e,4*e+4),a=t.subarray(4*n,4*n+4),o=Math.min(r[0],r[2]),s=Math.min(r[1],r[3]),i=Math.max(r[0],r[2]),u=Math.max(r[1],r[3]),p=Math.min(a[0],a[2]),c=Math.min(a[1],a[3]),l=Math.max(a[0],a[2]),d=Math.max(a[1],a[3]),h=(i-o)*(u-s),f=(l-p)*(d-c);if(h<=0||f<=0)return 0;var m=Math.max(o,p),y=Math.max(s,c),g=Math.min(i,l),v=Math.min(u,d),b=Math.max(g-m,0)*Math.max(v-y,0);return b/(h+f-b)}function Ls(t,e,n){var r=Math.exp(e*n*n);return n<=t?r:0}function Ps(t,e){return t.score-e.score||t.score===e.score&&e.boxIndex-t.boxIndex}var Bs=function(t,e,n,r,a){return void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY),u(this,void 0,void 0,(function(){var o,s,i,u,c,l,d;return p(this,(function(p){switch(p.label){case 0:return o=tn(t,"boxes","nonMaxSuppressionAsync"),s=tn(e,"scores","nonMaxSuppressionAsync"),i=Ms(o,s,n,r,a),n=i.maxOutputSize,r=i.iouThreshold,a=i.scoreThreshold,[4,Promise.all([o.data(),s.data()])];case 1:return u=p.sent(),c=u[0],l=u[1],d=function(t,e,n,r,a){return Rs(t,e,n,r,a,0)}(c,l,n,r,a).selectedIndices,o!==t&&o.dispose(),s!==e&&s.dispose(),[2,Qo(d,"int32")]}}))}))};var Ks=rn({nonMaxSuppressionWithScore_:function(t,e,n,r,a,o){void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY),void 0===o&&(o=0);var s=tn(t,"boxes","nonMaxSuppression"),i=tn(e,"scores","nonMaxSuppression"),u=Ms(s,i,n,r,a,o),p={boxes:s,scores:i},c={maxOutputSize:n=u.maxOutputSize,iouThreshold:r=u.iouThreshold,scoreThreshold:a=u.scoreThreshold,softNmsSigma:o=u.softNmsSigma},l=Qe.runKernel("NonMaxSuppressionV5",p,c);return{selectedIndices:l[0],selectedScores:l[1]}}});var js=function(t,e,n,r,a,o){return void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY),void 0===o&&(o=0),u(this,void 0,void 0,(function(){var s,i,u,c,l,d,h,f,m;return p(this,(function(p){switch(p.label){case 0:return s=tn(t,"boxes","nonMaxSuppressionAsync"),i=tn(e,"scores","nonMaxSuppressionAsync"),u=Ms(s,i,n,r,a,o),n=u.maxOutputSize,r=u.iouThreshold,a=u.scoreThreshold,o=u.softNmsSigma,[4,Promise.all([s.data(),i.data()])];case 1:return c=p.sent(),l=c[0],d=c[1],h=function(t,e,n,r,a,o){return Rs(t,e,n,r,a,o,!0)}(l,d,n,r,a,o),f=h.selectedIndices,m=h.selectedScores,s!==t&&s.dispose(),i!==e&&i.dispose(),[2,{selectedIndices:Qo(f,"int32"),selectedScores:Qo(m)}]}}))}))};var qs=rn({nonMaxSuppressionPadded_:function(t,e,n,r,a,o){void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY),void 0===o&&(o=!1);var s=tn(t,"boxes","nonMaxSuppression"),i=tn(e,"scores","nonMaxSuppression"),u=Ms(s,i,n,r,a,null),p={boxes:s,scores:i},c={maxOutputSize:u.maxOutputSize,iouThreshold:u.iouThreshold,scoreThreshold:u.scoreThreshold,padToMaxOutputSize:o},l=Qe.runKernel("NonMaxSuppressionV4",p,c);return{selectedIndices:l[0],validOutputs:l[1]}}});var Us=function(t,e,n,r,a,o){return void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY),void 0===o&&(o=!1),u(this,void 0,void 0,(function(){var s,i,u,c,d,h,f,m,y,g,v,b;return p(this,(function(p){switch(p.label){case 0:return s=tn(t,"boxes","nonMaxSuppressionAsync"),i=tn(e,"scores","nonMaxSuppressionAsync"),u=Ms(s,i,n,r,a,null),c=u.maxOutputSize,d=u.iouThreshold,h=u.scoreThreshold,[4,Promise.all([s.data(),i.data()])];case 1:return f=l.apply(void 0,[p.sent(),2]),m=f[0],y=f[1],g=function(t,e,n,r,a,o){return Rs(t,e,n,r,a,0,!1,o,!0)}(m,y,c,d,h,o),v=g.selectedIndices,b=g.validOutputs,s!==t&&s.dispose(),i!==e&&i.dispose(),[2,{selectedIndices:Qo(v,"int32"),validOutputs:Cr(b,"int32")}]}}))}))};var Ws=rn({resizeBilinear_:function(t,e,n,r){void 0===n&&(n=!1),void 0===r&&(r=!1);var a=tn(t,"images","resizeBilinear");ot(3===a.rank||4===a.rank,(function(){return"Error in resizeBilinear: x must be rank 3 or 4, but got "+"rank ".concat(a.rank,".")})),ot(2===e.length,(function(){return"Error in resizeBilinear: new shape must 2D, but got shape "+"".concat(e,".")})),ot(!1===r||!1===n,(function(){return"Error in resizeBilinear: If halfPixelCenters is true, alignCorners must be false."}));var o=a,s=!1;3===a.rank&&(s=!0,o=En(a,[1,a.shape[0],a.shape[1],a.shape[2]])),l(e,0);var i={images:o},u={alignCorners:n,halfPixelCenters:r,size:e},p=Qe.runKernel("ResizeBilinear",i,u);return s?En(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});var Hs=rn({resizeNearestNeighbor_:function(t,e,n,r){void 0===n&&(n=!1),void 0===r&&(r=!1);var a=tn(t,"images","resizeNearestNeighbor");ot(3===a.rank||4===a.rank,(function(){return"Error in resizeNearestNeighbor: x must be rank 3 or 4, but got "+"rank ".concat(a.rank,".")})),ot(2===e.length,(function(){return"Error in resizeNearestNeighbor: new shape must 2D, but got shape "+"".concat(e,".")})),ot("float32"===a.dtype||"int32"===a.dtype,(function(){return"`images` must have `int32` or `float32` as dtype"})),ot(!1===r||!1===n,(function(){return"Error in resizeNearestNeighbor: If halfPixelCenters is true, alignCorners must be false."}));var o=a,s=!1;3===a.rank&&(s=!0,o=En(a,[1,a.shape[0],a.shape[1],a.shape[2]])),l(e,0);var i={images:o},u={alignCorners:n,halfPixelCenters:r,size:e},p=Qe.runKernel("ResizeNearestNeighbor",i,u);return s?En(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});var Gs=rn({threshold_:function(t,e,n,r){var a;void 0===e&&(e="binary"),void 0===n&&(n=!1),void 0===r&&(r=.5);var o,s,i,u,p=tn(t,"image","threshold"),c=p.shape[0]*p.shape[1],d=Cn(Qo([r]),255);if(ot(3===p.rank,(function(){return"Error in threshold: image must be rank 3,"+"but got rank ".concat(p.rank,".")})),ot(3===p.shape[2]||1===p.shape[2],(function(){return"Error in threshold: image color channel must be equal to 3 or 1"+"but got ".concat(p.shape[2],".")})),ot("int32"===p.dtype||"float32"===p.dtype,(function(){return"Error in dtype: image dtype must be int32 or float32,"+"but got dtype ".concat(p.dtype,".")})),ot("otsu"===e||"binary"===e,(function(){return"Method must be binary or otsu, but was ".concat(e)})),3===p.shape[2]){o=(a=l(Bo(p,[1,1,1],-1),3))[0],s=a[1],i=a[2];var h=Cn(o,.2989),f=Cn(s,.587),m=Cn(i,.114);u=un(un(h,f),m)}else u=t;"otsu"===e&&(d=function(t,e){for(var n,r,a,o,s,i,u=Qo([-1]),p=Qo([0]),c=Qo([0]),l=0;l<t.size-1;l++){n=zn(t,0,l+1),r=zn(t,l+1),s=vr(Rr(n),e),i=vr(Rr(r),e);var d=Rr(Cn(n,fo(0,n.size)));a=vr(d,Rr(n));var h=Zn(r.shape,n.size),f=un(fo(0,r.size),h),m=Cn(r,f);o=vr(Rr(m),Rr(r));var y=pa(a,o),g=pa(a,o),v=Cn(s,i);c=Cn(Cn(v,y),g);var b=Gr(c,p);p=Nr(b,c,p),u=Nr(b,Qo([l]),u)}return u}(qn(bn(To(u),"int32"),Zo([]),256),c));var y=n?ea(u,d):Gr(u,d);return bn(Cn(y,255),"int32")}});var Zs=rn({transform_:function(t,e,n,r,a,o){void 0===n&&(n="nearest"),void 0===r&&(r="constant"),void 0===a&&(a=0);var s=tn(t,"image","transform","float32"),i=tn(e,"transforms","transform","float32");ot(4===s.rank,(function(){return"Error in transform: image must be rank 4,"+"but got rank ".concat(s.rank,".")})),ot(2===i.rank&&(i.shape[0]===s.shape[0]||1===i.shape[0])&&8===i.shape[1],(function(){return"Error in transform: Input transform should be batch x 8 or 1 x 8"})),ot(null==o||2===o.length,(function(){return"Error in transform: outputShape must be [height, width] or null, "+"but got ".concat(o,".")}));var u={image:s,transforms:i},p={interpolation:n,fillMode:r,fillValue:a,outputShape:o};return Qe.runKernel("Transform",u,p)}});var Qs=rn({bandPart_:function(t,e,n){ot(e%1==0,(function(){return"bandPart(): numLower must be an integer, got ".concat(e,".")})),ot(n%1==0,(function(){return"bandPart(): numUpper must be an integer, got ".concat(n,".")}));var r=tn(t,"a","bandPart");ot(r.rank>=2,(function(){return"bandPart(): Rank must be at least 2, got ".concat(r.rank,".")}));var a=r.shape,o=l(r.shape.slice(-2),2),s=o[0],i=o[1];if(!(e<=s))throw new Error("bandPart(): numLower (".concat(e,")")+" must not be greater than the number of rows (".concat(s,")."));if(!(n<=i))throw new Error("bandPart(): numUpper (".concat(n,")")+" must not be greater than the number of columns (".concat(i,")."));e<0&&(e=s),n<0&&(n=i);var u=En(fo(0,s,1,"int32"),[-1,1]),p=fo(0,i,1,"int32"),c=pa(u,p),d=da(ea(c,Cr(+e,"int32")),Zr(c,Cr(-n,"int32"))),h=ka([s,i],r.dtype);return En(Uo(es(En(r,[-1,s,i])).map((function(t){return Nr(d,t,h)}))),a)}});var Ys=rn({gramSchmidt_:function(t){var e;if(Array.isArray(t)){e=!1,ot(null!=t&&t.length>0,(function(){return"Gram-Schmidt process: input must not be null, undefined, or empty"}));for(var n=t[0].shape[0],r=function(e){ot(t[e].shape[0]===n,(function(){return"Gram-Schmidt: Non-unique lengths found in the input vectors: "+"(".concat(t[e].shape[0]," vs. ").concat(n,")")}))},a=1;a<t.length;++a)r(a)}else e=!0,t=Bo(t,t.shape[0],0).map((function(t){return qo(t,[0])}));ot(t.length<=t[0].shape[0],(function(){return"Gram-Schmidt: Number of vectors (".concat(t.length,") exceeds ")+"number of dimensions (".concat(t[0].shape[0],").")}));var o=[],s=t,i=function(t){o.push(Qe.tidy((function(){var e=s[t];if(t>0)for(var n=0;n<t;++n){var r=Cn(Rr(Cn(o[n],e)),o[n]);e=pa(e,r)}return vr(e,Lr(e,"euclidean"))})))};for(a=0;a<t.length;++a)i(a);return e?Uo(o,0):o}});function Xs(t,e){return void 0===e&&(e=!1),Qe.tidy((function(){ot(2===t.shape.length,(function(){return"qr2d() requires a 2D Tensor, but got a ".concat(t.shape.length,"D Tensor.")}));for(var n=t.shape[0],r=t.shape[1],a=Ur(n),o=Dn(t),s=Yo([[1]],[1,1]),i=Dn(s),u=n>=r?r:n,p=function(t){var e,u=o,p=i,c=a;e=l(Qe.tidy((function(){var e=zn(o,[t,t],[n-t,1]),u=Lr(e),p=zn(o,[t,t],[1,1]),c=Nr(Gr(p,0),Yo([[-1]]),Yo([[1]])),l=pa(p,Cn(c,u)),d=vr(e,l);i=1===d.shape[0]?Dn(s):An([s,zn(d,[1,0],[d.shape[0]-1,d.shape[1]])],0);var h=sa(vr(Mn(c,l),u)),f=zn(o,[t,0],[n-t,r]),m=Cn(h,i),y=as(i);if(0===t)o=pa(f,Mn(m,Mn(y,f)));else{var g=pa(f,Mn(m,Mn(y,f)));o=An([zn(o,[0,0],[t,r]),g],0)}var v=as(m),b=zn(a,[0,t],[n,a.shape[1]-t]);if(0===t)a=pa(b,Mn(Mn(b,i),v));else{var x=pa(b,Mn(Mn(b,i),v));a=An([zn(a,[0,0],[n,t]),x],1)}return[i,o,a]})),3),i=e[0],o=e[1],a=e[2],Ue([u,p,c]).forEach((function(t){return t.dispose()}))},c=0;c<u;++c)p(c);return!e&&n>r&&(a=zn(a,[0,0],[n,r]),o=zn(o,[0,0],[r,r])),[a,o]}))}var Js,$s=rn({qr_:function(t,e){if(void 0===e&&(e=!1),ot(t.rank>=2,(function(){return"qr() requires input tensor to have a rank >= 2, but got rank ".concat(t.rank)})),2===t.rank)return Xs(t,e);var n=t.shape.slice(0,t.shape.length-2).reduce((function(t,e){return t*e})),r=es(En(t,[n,t.shape[t.shape.length-2],t.shape[t.shape.length-1]]),0),a=[],o=[];return r.forEach((function(t){var n=l(Xs(t,e),2),r=n[0],s=n[1];a.push(r),o.push(s)})),[En(Uo(a,0),t.shape),En(Uo(o,0),t.shape)]}});!function(t){t[t.NONE=0]="NONE",t[t.MEAN=1]="MEAN",t[t.SUM=2]="SUM",t[t.SUM_BY_NONZERO_WEIGHTS=3]="SUM_BY_NONZERO_WEIGHTS"}(Js||(Js={}));var ti=rn({computeWeightedLoss_:function(t,e,n){void 0===n&&(n=Js.SUM_BY_NONZERO_WEIGHTS);var r=tn(t,"losses","computeWeightedLoss"),a=null;null!=e&&(a=tn(e,"weights","computeWeightedLoss"));var o=null==a?r:Cn(r,a);if(n===Js.NONE)return o;if(n===Js.SUM)return Rr(o);if(n===Js.MEAN){if(null==a)return wa(o);var s=r.size/a.size,i=vr(Rr(o),Rr(a));return s>1?vr(i,Cr(s)):i}if(n===Js.SUM_BY_NONZERO_WEIGHTS){if(null==a)return vr(Rr(o),Cr(r.size));var u=Cn(a,Ta(r.shape)),p=bn(Rr(Aa(u,Cr(0))),"float32");return vr(Rr(o),p)}throw Error("Unknown reduction: ".concat(n))}});var ei=rn({absoluteDifference_:function(t,e,n,r){void 0===r&&(r=Js.SUM_BY_NONZERO_WEIGHTS);var a=tn(t,"labels","absoluteDifference"),o=tn(e,"predictions","absoluteDifference"),s=null;null!=n&&(s=tn(n,"weights","absoluteDifference")),st(a.shape,o.shape,"Error in absoluteDifference: ");var i=an(pa(a,o));return ti(i,s,r)}});var ni=rn({cosineDistance_:function(t,e,n,r,a){void 0===a&&(a=Js.SUM_BY_NONZERO_WEIGHTS);var o=tn(t,"labels","cosineDistance"),s=tn(e,"predictions","cosineDistance"),i=null;null!=r&&(i=tn(r,"weights","cosineDistance")),st(o.shape,s.shape,"Error in cosineDistance: ");var u=Cr(1),p=pa(u,Rr(Cn(o,s),n,!0));return ti(p,i,a)}});var ri=rn({hingeLoss_:function(t,e,n,r){void 0===r&&(r=Js.SUM_BY_NONZERO_WEIGHTS);var a=tn(t,"labels","hingeLoss"),o=tn(e,"predictions","hingeLoss"),s=null;null!=n&&(s=tn(n,"weights","hingeLoss")),st(a.shape,o.shape,"Error in hingeLoss: ");var i=Cr(1);a=pa(Cn(Cr(2),a),i);var u=go(pa(i,Cn(a,o)));return ti(u,s,r)}});var ai=rn({huberLoss_:function(t,e,n,r,a){void 0===r&&(r=1),void 0===a&&(a=Js.SUM_BY_NONZERO_WEIGHTS);var o=tn(t,"labels","huberLoss"),s=tn(e,"predictions","huberLoss"),i=null;null!=n&&(i=tn(n,"weights","huberLoss")),st(o.shape,s.shape,"Error in huberLoss: ");var u=Cr(r),p=an(pa(s,o)),c=_a(p,u),l=pa(p,c),d=un(Cn(Cr(.5),zr(c)),Cn(u,l));return ti(d,i,a)}});var oi=rn({logLoss_:function(t,e,n,r,a){void 0===r&&(r=1e-7),void 0===a&&(a=Js.SUM_BY_NONZERO_WEIGHTS);var o=tn(t,"labels","logLoss"),s=tn(e,"predictions","logLoss"),i=null;null!=n&&(i=tn(n,"weights","logLoss")),st(o.shape,s.shape,"Error in logLoss: ");var u=Cr(1),p=Cr(r),c=sa(Cn(o,ra(un(s,p)))),l=Cn(pa(u,o),ra(un(pa(u,s),p))),d=pa(c,l);return ti(d,i,a)}});var si=rn({meanSquaredError_:function(t,e,n,r){void 0===r&&(r=Js.SUM_BY_NONZERO_WEIGHTS);var a=tn(t,"labels","meanSquaredError"),o=tn(e,"predictions","meanSquaredError"),s=null;null!=n&&(s=tn(n,"weights","meanSquaredError")),st(a.shape,o.shape,"Error in meanSquaredError: ");var i=jo(a,o);return ti(i,s,r)}});var ii=rn({sigmoidCrossEntropy_:function(t,e,n,r,a){void 0===r&&(r=0),void 0===a&&(a=Js.SUM_BY_NONZERO_WEIGHTS);var o=tn(t,"multiClassLabels","sigmoidCrossEntropy"),s=tn(e,"logits","sigmoidCrossEntropy"),i=null;if(null!=n&&(i=tn(n,"weights","sigmoidCrossEntropy")),st(o.shape,s.shape,"Error in sigmoidCrossEntropy: "),r>0){var u=Cr(r),p=Cr(1),c=Cr(.5);o=un(Cn(o,pa(p,u)),Cn(c,u))}var l=function(t,e){var n=tn(t,"labels","sigmoidCrossEntropyWithLogits"),r=tn(e,"logits","sigmoidCrossEntropyWithLogits");st(n.shape,r.shape,"Error in sigmoidCrossEntropyWithLogits: ");var a=go(r),o=Cn(r,n),s=aa(Br(sa(an(r))));return un(pa(a,o),s)}(o,s);return ti(l,i,a)}});var ui=rn({softmaxCrossEntropy_:function(t,e,n,r,a){void 0===r&&(r=0),void 0===a&&(a=Js.SUM_BY_NONZERO_WEIGHTS);var o=tn(t,"onehotLabels","softmaxCrossEntropy"),s=tn(e,"logits","softmaxCrossEntropy"),i=null;if(null!=n&&(i=tn(n,"weights","softmaxCrossEntropy")),st(o.shape,s.shape,"Error in softmaxCrossEntropy: "),r>0){var u=Cr(r),p=Cr(1),c=Cr(o.shape[1]);o=un(Cn(o,pa(p,u)),vr(u,c))}var d=function(t,e,n){if(void 0===n&&(n=-1),-1===n&&(n=e.rank-1),n!==e.rank-1)throw Error("Softmax cross entropy along a non-last dimension is not yet "+"supported. Labels / logits was rank ".concat(e.rank," ")+"and dim was ".concat(n));var r=oa((function(t,e,r){var a=la(e,[n],!0),o=pa(bn(e,"float32"),a);r([t,o]);var s=sa(Cn(o,t));return{value:Rr(s,[n]),gradFunc:function(t,e){var r=l(e,2),a=r[0],o=r[1],s=Ir(t.shape,[n]);return[Cn(En(t,s),pa(bn(a,"float32"),Br(o))),Cn(En(t,s),pa(Br(o),bn(a,"float32")))]}}}));return r(t,e)}(o,s);return ti(d,i,a)}});var pi=rn({sparseFillEmptyRows_:function(t,e,n,r){var a=tn(t,"indices","sparseFillEmptyRows","int32"),o=tn(e,"values","sparseFillEmptyRows"),s=tn(n,"denseShape","sparseFillEmptyRows","int32"),i=tn(r,"defaultValue","sparseFillEmptyRows",o.dtype);if(2!==a.rank)throw new Error("Indices should be Tensor2D but received shape\n        ".concat(a.shape));if(1!==o.rank)throw new Error("Values should be Tensor1D but received shape ".concat(o.shape));if(1!==s.rank)throw new Error("Dense shape should be Tensor1D but received shape ".concat(s.shape));if(0!==i.rank)throw new Error("Default value should be a scalar but received shape ".concat(i.shape));var u={indices:a,values:o,denseShape:s,defaultValue:i},p=Qe.runKernel("SparseFillEmptyRows",u);return{outputIndices:p[0],outputValues:p[1],emptyRowIndicator:p[2],reverseIndexMap:p[3]}}});var ci=rn({sparseReshape_:function(t,e,n){var r=tn(t,"inputIndices","sparseReshape","int32"),a=tn(e,"inputShape","sparseReshape","int32"),o=tn(n,"newShape","sparseReshape","int32");if(2!==r.rank)throw new Error("Input indices should be Tensor2D but received shape\n        ".concat(r.shape));if(1!==a.rank)throw new Error("Input shape should be Tensor1D but received shape ".concat(a.shape));if(1!==o.rank)throw new Error("New shape should be Tensor1D but received shape ".concat(o.shape));var s={inputIndices:r,inputShape:a,newShape:o},i=Qe.runKernel("SparseReshape",s);return{outputIndices:i[0],outputShape:i[1]}}});var li=rn({sparseSegmentMean_:function(t,e,n){var r=tn(t,"data","sparseSegmentMean"),a=tn(e,"indices","sparseSegmentMean","int32"),o=tn(n,"segmentIds","sparseSegmentMean","int32");if(r.rank<1)throw new Error("Data should be at least 1 dimensional but received scalar");if(1!==a.rank)throw new Error("Indices should be Tensor1D but received shape\n          ".concat(a.shape));if(1!==o.rank)throw new Error("Segment ids should be Tensor1D but received shape\n          ".concat(o.shape));var s={data:r,indices:a,segmentIds:o};return Qe.runKernel("SparseSegmentMean",s)}});var di=rn({sparseSegmentSum_:function(t,e,n){var r=tn(t,"data","sparseSegmentSum"),a=tn(e,"indices","sparseSegmentSum","int32"),o=tn(n,"segmentIds","sparseSegmentSum","int32");if(r.rank<1)throw new Error("Data should be at least 1 dimensional but received scalar");if(1!==a.rank)throw new Error("Indices should be Tensor1D but received shape\n         ".concat(a.shape));if(1!==o.rank)throw new Error("Segment ids should be Tensor1D but received shape\n         ".concat(o.shape));var s={data:r,indices:a,segmentIds:o};return Qe.runKernel("SparseSegmentSum",s)}});var hi=rn({stringNGrams_:function(t,e,n,r,a,o,s,i){var u=tn(t,"data","stringNGrams","string");if("string"!==u.dtype)throw new Error("Data must be of datatype string");if(1!==u.shape.length)throw new Error("Data must be a vector, saw: ".concat(u.shape));var p=tn(e,"dataSplits","stringNGrams");if("int32"!==p.dtype)throw new Error("Data splits must be of datatype int32");var c={separator:n,nGramWidths:r,leftPad:a,rightPad:o,padWidth:s,preserveShortSequences:i},l={data:u,dataSplits:p},d=Qe.runKernel("StringNGrams",l,c);return{nGrams:d[0],nGramsSplits:d[1]}}});var fi=rn({stringSplit_:function(t,e,n){void 0===n&&(n=!0);var r=tn(t,"input","stringSplit","string"),a=tn(e,"delimiter","stringSplit","string");if(1!==r.rank)throw new Error("Input should be Tensor1D but received shape ".concat(r.shape));if(0!==a.rank)throw new Error("Delimiter should be a scalar but received shape ".concat(a.shape));var o={skipEmpty:n},s={input:r,delimiter:a},i=Qe.runKernel("StringSplit",s,o);return{indices:i[0],values:i[1],shape:i[2]}}});var mi=rn({stringToHashBucketFast_:function(t,e){var n=tn(t,"input","stringToHashBucketFast","string"),r={numBuckets:e};if(e<=0)throw new Error("Number of buckets must be at least 1");var a={input:n};return Qe.runKernel("StringToHashBucketFast",a,r)}}),yi={__proto__:null,abs:an,acos:on,acosh:sn,add:un,addN:pn,all:cn,any:ln,argMax:dn,argMin:hn,asin:fn,asinh:mn,atan:yn,atan2:gn,atanh:vn,avgPool:In,avgPool3d:On,basicLSTMCell:Vn,batchToSpaceND:Ln,batchNorm:Pn,batchNorm2d:Bn,batchNorm3d:Kn,batchNorm4d:jn,bincount:qn,broadcastArgs:Un,broadcastTo:Wn,buffer:Hn,cast:bn,ceil:Gn,clipByValue:Qn,clone:Dn,complex:Yn,concat:An,concat1d:Xn,concat2d:Jn,concat3d:$n,concat4d:tr,conv1d:nr,conv2d:er,conv2dTranspose:ar,conv3d:or,conv3dTranspose:ir,cos:ur,cosh:pr,cumprod:cr,cumsum:lr,denseBincount:dr,depthToSpace:hr,depthwiseConv2d:fr,diag:mr,dilation2d:yr,div:vr,divNoNan:kr,dot:Tr,einsum:_r,elu:Sr,equal:xr,erf:Er,euclideanNorm:Pr,exp:Br,expandDims:Kr,expm1:jr,eye:Ur,fill:Zn,floor:Wr,floorDiv:gr,gather:Hr,greater:Gr,greaterEqual:Zr,imag:Qr,isFinite:Yr,isInf:Xr,isNaN:Jr,leakyRelu:$r,less:ta,lessEqual:ea,linspace:function(t,e,n){if(n<=0)throw new Error("The number of values should be positive.");var r={start:t,stop:e,num:n};return Qe.runKernel("LinSpace",{},r)},localResponseNormalization:na,log:ra,log1p:aa,logSigmoid:ua,logSoftmax:ca,logSumExp:la,logicalAnd:da,logicalNot:ha,logicalOr:fa,logicalXor:ma,lowerBound:function(t,e){return ga(t,e,"left")},matMul:Mn,max:Or,maxPool:va,maxPool3d:ba,maxPoolWithArgmax:xa,maximum:Na,mean:wa,meshgrid:function(t,e,n){var r=(void 0===n?{}:n).indexing,a=void 0===r?"xy":r;if("xy"!==a&&"ij"!==a)throw new TypeError("".concat(a," is not a valid third argument to meshgrid"));if(void 0===t)return[];var o=tn(t,"x","meshgrid",t instanceof ze?t.dtype:"float32");if(void 0===e)return[o];var s=tn(e,"y","meshgrid",e instanceof ze?e.dtype:"float32"),i=pt(o.shape),u=pt(s.shape);return"xy"===a?(o=En(o,[1,-1]),s=En(s,[-1,1]),[Mn(Ta([u,1],o.dtype),o),Mn(s,Ta([1,i],s.dtype))]):(o=En(o,[-1,1]),s=En(s,[1,-1]),[Mn(o,Ta([1,u],o.dtype)),Mn(Ta([i,1],s.dtype),s)])},min:Dr,minimum:_a,mirrorPad:Sa,mod:Ea,moments:Ia,mul:Cn,multiRNNCell:Oa,multinomial:Da,neg:sa,notEqual:Aa,oneHot:Ma,ones:Ta,onesLike:Ca,outerProduct:Fa,pad:za,pad1d:Ra,pad2d:Va,pad3d:La,pad4d:Pa,pool:Ka,pow:Ar,prelu:ja,print:function(t,e){void 0===e&&(e=!1),console.log(t.toString(e))},prod:qa,raggedGather:Ua,raggedRange:Wa,raggedTensorToTensor:Ha,rand:Ga,randomGamma:po,randomNormal:co,randomStandardNormal:lo,randomUniform:ho,range:fo,real:mo,reciprocal:yo,relu:go,relu6:vo,reshape:En,reverse:bo,reverse1d:xo,reverse2d:No,reverse3d:wo,reverse4d:ko,round:To,rsqrt:_o,scalar:Cr,selu:So,separableConv2d:Eo,setdiff1dAsync:Io,sigmoid:Fn,sign:Oo,sin:Do,sinh:Ao,slice:zn,slice1d:Mo,slice2d:Co,slice3d:Fo,slice4d:zo,softmax:Ro,softplus:ia,spaceToBatchND:Ba,fft:Vo,ifft:Lo,irfft:Po,rfft:Ko,split:Bo,sqrt:Fr,square:zr,squaredDifference:jo,squeeze:qo,stack:Uo,step:Wo,stridedSlice:Ho,sub:pa,sum:Rr,tan:Go,tanh:Rn,tensor:Zo,tensor1d:Qo,tensor2d:Yo,tensor3d:function(t,e,n){if(it(t),null!=e&&3!==e.length)throw new Error("tensor3d() requires shape to have three numbers");var r=Xe(t,n);if(3!==r.length&&1!==r.length)throw new Error("tensor3d() requires values to be number[][][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor3d() requires shape to be provided when `values` are a flat array");return Mr(t,e,r,n)},tensor4d:function(t,e,n){if(it(t),null!=e&&4!==e.length)throw new Error("tensor4d() requires shape to have four numbers");var r=Xe(t,n);if(4!==r.length&&1!==r.length)throw new Error("tensor4d() requires values to be number[][][][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor4d() requires shape to be provided when `values` are a flat array");return Mr(t,e,r,n)},tensor5d:function(t,e,n){if(it(t),null!=e&&5!==e.length)throw new Error("tensor5d() requires shape to have five numbers");var r=Xe(t,n);if(5!==r.length&&1!==r.length)throw new Error("tensor5d() requires values to be number[][][][][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor5d() requires shape to be provided when `values` are a flat array");return Mr(t,e,r,n)},tensor6d:function(t,e,n){if(it(t),null!=e&&6!==e.length)throw new Error("tensor6d() requires shape to have six numbers");var r=Xe(t,n);if(6!==r.length&&1!==r.length)throw new Error("tensor6d() requires values to be number[][][][][][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor6d() requires shape to be provided when `values` are a flat array");return Mr(t,e=e||r,r,n)},tile:qr,topk:Xo,truncatedNormal:Jo,unique:$o,unsortedSegmentSum:ts,unstack:es,upperBound:function(t,e){return ga(t,e,"right")},variable:function(t,e,n,r){return void 0===e&&(e=!0),Qe.makeVariable(t,e,n,r)},where:Nr,whereAsync:ns,zeros:ka,zerosLike:wr,op:rn,OP_SCOPE_SUFFIX:nn,booleanMaskAsync:rs,transpose:as,norm:Lr,movingAverage:os,scatterND:is,searchSorted:ga,sparseToDense:us,gatherND:ps,dropout:cs,enclosingPowerOfTwo:ls,cosineWindow:ds,inTopKAsync:hs,image:{flipLeftRight:Os,grayscaleToRGB:Ds,resizeNearestNeighbor:Hs,resizeBilinear:Ws,rotateWithOffset:As,cropAndResize:Is,nonMaxSuppression:Cs,nonMaxSuppressionAsync:Bs,nonMaxSuppressionWithScore:Ks,nonMaxSuppressionWithScoreAsync:js,nonMaxSuppressionPadded:qs,nonMaxSuppressionPaddedAsync:Us,threshold:Gs,transform:Zs},linalg:{bandPart:Qs,gramSchmidt:Ys,qr:$s},losses:{absoluteDifference:ei,computeWeightedLoss:ti,cosineDistance:ni,hingeLoss:ri,huberLoss:ai,logLoss:oi,meanSquaredError:si,sigmoidCrossEntropy:ii,softmaxCrossEntropy:ui},spectral:{fft:Vo,ifft:Lo,rfft:Ko,irfft:Po},fused:ks,signal:{hammingWindow:Ts,hannWindow:_s,frame:Ss,stft:Es},sparse:{sparseFillEmptyRows:pi,sparseReshape:ci,sparseSegmentMean:li,sparseSegmentSum:di},string:{stringNGrams:hi,stringSplit:fi,stringToHashBucketFast:mi}};function gi(t,n,r){if(void 0===r&&(r=""),"number"!=typeof t&&"number"!=typeof n){e.util.assert(t.length===n.length,(function(){return r+" Shapes ".concat(t," and ").concat(n," must match")}));for(var a=0;a<t.length;a++){var o=t[a],s=n[a];e.util.assert(o<0||s<0||o===s,(function(){return r+" Shapes ".concat(t," and ").concat(n," must match")}))}}}function vi(t){return"number"!=typeof t&&!t.some((function(t){return t<0}))}function bi(t,e,n){var r=xi(t,n),a=!vi(r);if(a&&0===e.length)throw new Error("Tried to calculate elements of an empty list"+" with non-fully-defined elementShape: ".concat(r));if(a&&e.forEach((function(t){r=xi(t.shape,r)})),!vi(r))throw new Error("Non-fully-defined elementShape: ".concat(r));return r}function xi(t,e){if("number"==typeof t)return e;if("number"==typeof e)return t;if(t.length!==e.length)throw new Error("Incompatible ranks during merge: ".concat(t," vs. ").concat(e));for(var n=[],r=0;r<t.length;++r){var a=t[r],o=e[r];if(a>=0&&o>=0&&a!==o)throw new Error("Incompatible shape during merge: ".concat(t," vs. ").concat(e));n[r]=a>=0?a:o}return n}var Ni=function(){function t(t,n,r,a,o,s,i){this.name=t,this.dtype=n,this.maxSize=r,this.elementShape=a,this.identicalElementShapes=o,this.dynamicSize=s,this.clearAfterRead=i,this.tensors=[],this.closed_=!1,this.idTensor=e.scalar(0),e.keep(this.idTensor)}return Object.defineProperty(t.prototype,"id",{get:function(){return this.idTensor.id},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"closed",{get:function(){return this.closed_},enumerable:!1,configurable:!0}),t.prototype.clearAndClose=function(t){this.tensors.forEach((function(e){null!=t&&t.has(e.tensor.id)||e.tensor.dispose()})),this.tensors=[],this.closed_=!0,this.idTensor.dispose()},t.prototype.size=function(){return this.tensors.length},t.prototype.read=function(t){if(this.closed_)throw new Error("TensorArray ".concat(this.name," has already been closed."));if(t<0||t>=this.size())throw new Error("Tried to read from index ".concat(t,", but array size is: ").concat(this.size()));var e=this.tensors[t];if(e.cleared)throw new Error("TensorArray ".concat(this.name,": Could not read index ").concat(t," twice because it was cleared after a previous read ")+"(perhaps try setting clear_after_read = false?).");return this.clearAfterRead&&(e.cleared=!0),e.read=!0,e.tensor},t.prototype.readMany=function(t){var e=this;return t.map((function(t){return e.read(t)}))},t.prototype.write=function(t,n){if(this.closed_)throw new Error("TensorArray ".concat(this.name," has already been closed."));if(t<0||!this.dynamicSize&&t>=this.maxSize)throw new Error("Tried to write to index ".concat(t,", but array is not resizeable and size is: ").concat(this.maxSize));var r=this.tensors[t]||{};if(n.dtype!==this.dtype)throw new Error("TensorArray ".concat(this.name,": Could not write to TensorArray index ").concat(t,",\n          because the value dtype is ").concat(n.dtype,", but TensorArray dtype is ").concat(this.dtype,"."));if(0!==this.size()||null!=this.elementShape&&0!==this.elementShape.length||(this.elementShape=n.shape),gi(this.elementShape,n.shape,"TensorArray ".concat(this.name,": Could not write to TensorArray index ").concat(t,".")),r.read)throw new Error("TensorArray ".concat(this.name,": Could not write to TensorArray index ").concat(t,", because it has already been read."));if(r.written)throw new Error("TensorArray ".concat(this.name,": Could not write to TensorArray index ").concat(t,", because it has already been written."));r.tensor=n,e.keep(n),r.written=!0,this.tensors[t]=r},t.prototype.writeMany=function(t,e){var n=this;if(t.length!==e.length)throw new Error("TensorArray ".concat(this.name,": could not write multiple tensors,")+"because the index size: ".concat(t.length," is not the same as tensors size: ").concat(e.length,"."));t.forEach((function(t,r){return n.write(t,e[r])}))},t.prototype.gather=function(t,n){if(n&&n!==this.dtype)throw new Error("TensorArray dtype is ".concat(this.dtype," but gather requested dtype ").concat(n));if(t)t=t.slice(0,this.size());else{t=[];for(var r=0;r<this.size();r++)t.push(r)}if(0===t.length)return e.tensor([],[0].concat(this.elementShape));var a=this.readMany(t);return gi(this.elementShape,a[0].shape,"TensorArray shape mismatch: "),e.stack(a,0)},t.prototype.concat=function(t){if(t&&t!==this.dtype)throw new Error("TensorArray dtype is ".concat(this.dtype," but concat requested dtype ").concat(t));if(0===this.size())return e.tensor([],[0].concat(this.elementShape));for(var n=[],r=0;r<this.size();r++)n.push(r);var a=this.readMany(n);return gi(this.elementShape,a[0].shape,"TensorArray shape mismatch: tensor array shape (".concat(this.elementShape,") vs first tensor shape (").concat(a[0].shape,")")),e.concat(a,0)},t.prototype.scatter=function(t,n){if(n.dtype!==this.dtype)throw new Error("TensorArray dtype is ".concat(this.dtype," but tensor has dtype ").concat(n.dtype));if(t.length!==n.shape[0])throw new Error("Expected len(indices) == tensor.shape[0], but saw: ".concat(t.length," vs. ").concat(n.shape[0]));var r=Math.max.apply(Math,d([],l(t),!1));if(!this.dynamicSize&&r>=this.maxSize)throw new Error("Max index must be < array size (".concat(r,"  vs. ").concat(this.maxSize,")"));this.writeMany(t,e.unstack(n,0))},t.prototype.split=function(t,n){var r=this;if(n.dtype!==this.dtype)throw new Error("TensorArray dtype is ".concat(this.dtype," but tensor has dtype ").concat(n.dtype));var a=0,o=t.map((function(t){return a+=t}));if(a!==n.shape[0])throw new Error("Expected sum of lengths to be equal to\n          tensor.shape[0], but sum of lengths is\n        ".concat(a,", and tensor's shape is: ").concat(n.shape));if(!this.dynamicSize&&t.length!==this.maxSize)throw new Error("TensorArray's size is not equal to the size of lengths (".concat(this.maxSize," vs. ").concat(t.length,"), ")+"and the TensorArray is not marked as dynamically resizeable");var s=0===a?0:n.size/a,i=[];e.tidy((function(){n=e.reshape(n,[1,a,s]);for(var u=0;u<t.length;++u){var p=[0,0===u?0:o[u-1],0],c=[1,t[u],s];i[u]=e.reshape(e.slice(n,p,c),r.elementShape)}return i}));for(var u=[],p=0;p<t.length;p++)u[p]=p;this.writeMany(u,i)},t}(),wi=function(){function t(t,n,r,a){void 0===a&&(a=-1),this.tensors=t,this.elementShape=n,this.elementDtype=r,null!=t&&t.forEach((function(t){if(r!==t.dtype)throw new Error("Invalid data types; op elements ".concat(r,", but list elements ").concat(t.dtype));gi(n,t.shape,"TensorList shape mismatch: "),e.keep(t)})),this.idTensor=e.scalar(0),this.maxNumElements=a,e.keep(this.idTensor)}return Object.defineProperty(t.prototype,"id",{get:function(){return this.idTensor.id},enumerable:!1,configurable:!0}),t.prototype.copy=function(){return new t(d([],l(this.tensors),!1),this.elementShape,this.elementDtype)},t.prototype.clearAndClose=function(t){this.tensors.forEach((function(e){null!=t&&t.has(e.id)||e.dispose()})),this.tensors.length=0,this.idTensor.dispose()},t.prototype.size=function(){return this.tensors.length},t.prototype.stack=function(t,n,r){var a=this;if(void 0===r&&(r=-1),n!==this.elementDtype)throw new Error("Invalid data types; op elements ".concat(n,", but list elements ").concat(this.elementDtype));if(-1!==r&&this.tensors.length!==r)throw new Error("Operation expected a list with ".concat(r," elements but got a list with ").concat(this.tensors.length," elements."));gi(t,this.elementShape,"TensorList shape mismatch: ");var o=bi(this.elementShape,this.tensors,t);return e.tidy((function(){var t=a.tensors.map((function(t){return e.reshape(t,o)}));return e.stack(t,0)}))},t.prototype.popBack=function(t,n){if(n!==this.elementDtype)throw new Error("Invalid data types; op elements ".concat(n,", but list elements ").concat(this.elementDtype));if(0===this.size())throw new Error("Trying to pop from an empty list.");var r=bi(this.elementShape,this.tensors,t),a=this.tensors.pop();return a.kept=!1,gi(a.shape,t,"TensorList shape mismatch: "),e.reshape(a,r)},t.prototype.pushBack=function(t){if(t.dtype!==this.elementDtype)throw new Error("Invalid data types; op elements ".concat(t.dtype,", but list elements ").concat(this.elementDtype));if(gi(t.shape,this.elementShape,"TensorList shape mismatch: "),this.maxNumElements===this.size())throw new Error("Trying to push element into a full list.");e.keep(t),this.tensors.push(t)},t.prototype.resize=function(e){if(e<0)throw new Error("TensorListResize expects size to be non-negative. Got: ".concat(e));if(-1!==this.maxNumElements&&e>this.maxNumElements)throw new Error("TensorListResize input size ".concat(e," is greater maxNumElement ").concat(this.maxNumElements,"."));var n=new t([],this.elementShape,this.elementDtype,this.maxNumElements);n.tensors.length=e;for(var r=0;r<Math.min(this.tensors.length,e);++r)n.tensors[r]=this.tensors[r];return n},t.prototype.getItem=function(t,n,r){if(r!==this.elementDtype)throw new Error("Invalid data types; op elements ".concat(r,", but list elements ").concat(this.elementDtype));if(t<0||t>this.tensors.length)throw new Error("Trying to access element ".concat(t," in a list with ").concat(this.tensors.length," elements."));if(null==this.tensors[t])throw new Error("element at index ".concat(t," is null."));gi(this.tensors[t].shape,n,"TensorList shape mismatch: ");var a=bi(this.elementShape,this.tensors,n);return e.reshape(this.tensors[t],a)},t.prototype.setItem=function(t,n){if(n.dtype!==this.elementDtype)throw new Error("Invalid data types; op elements ".concat(n.dtype,", but list elements ").concat(this.elementDtype));if(t<0||-1!==this.maxNumElements&&t>=this.maxNumElements)throw new Error("Trying to set element ".concat(t," in a list with max ").concat(this.maxNumElements," elements."));gi(this.elementShape,n.shape,"TensorList shape mismatch: "),e.keep(n),null!=this.tensors[t]&&(this.tensors[t].kept=!1),this.tensors[t]=n},t.prototype.gather=function(t,n,r){var a=this;if(n!==this.elementDtype)throw new Error("Invalid data types; op elements ".concat(n,", but list elements ").concat(this.elementDtype));gi(this.elementShape,r,"TensorList shape mismatch: "),t=t.slice(0,this.size());var o=bi(this.elementShape,this.tensors,r);return 0===t.length?e.tensor([],[0].concat(o)):e.tidy((function(){var n=t.map((function(t){return e.reshape(a.tensors[t],o)}));return e.stack(n,0)}))},t.prototype.concat=function(t,n){var r=this;if(t&&t!==this.elementDtype)throw new Error("TensorList dtype is ".concat(this.elementDtype," but concat requested dtype ").concat(t));gi(this.elementShape,n,"TensorList shape mismatch: ");var a=bi(this.elementShape,this.tensors,n);return 0===this.size()?e.tensor([],[0].concat(a)):e.tidy((function(){var t=r.tensors.map((function(t){return e.reshape(t,a)}));return e.concat(t,0)}))},t}();var ki=function(t,n,r){return u(void 0,void 0,void 0,(function(){var a,o,s,i,u,c,h,f,g,v,b,x,w,k,T,_,S,E,I,O,D,A,M,C,F,z,R,V,L,P,B,K,j,q,U,W,H,G,Z,Q,Y,X,J,$,tt,et,nt,rt,at,ot,st,it,ut,pt,ct,lt,dt;return p(this,(function(ht){switch(ht.label){case 0:switch(t.op){case"If":case"StatelessIf":return[3,1];case"While":case"StatelessWhile":return[3,3];case"LoopCond":return[3,9];case"Switch":return[3,10];case"Merge":return[3,12];case"Enter":return[3,13];case"Exit":return[3,14];case"NextIteration":return[3,15];case"TensorArrayV3":return[3,16];case"TensorArrayWriteV3":return[3,17];case"TensorArrayReadV3":return[3,18];case"TensorArrayGatherV3":return[3,19];case"TensorArrayScatterV3":return[3,20];case"TensorArrayConcatV3":return[3,21];case"TensorArraySplitV3":return[3,22];case"TensorArraySizeV3":return[3,23];case"TensorArrayCloseV3":return[3,24];case"TensorListSetItem":return[3,25];case"TensorListGetItem":return[3,26];case"TensorListScatterV2":case"TensorListScatter":return[3,27];case"TensorListReserve":case"EmptyTensorList":return[3,28];case"TensorListGather":return[3,29];case"TensorListStack":return[3,30];case"TensorListFromTensor":return[3,31];case"TensorListConcat":case"TensorListConcatV2":return[3,32];case"TensorListPushBack":return[3,33];case"TensorListPopBack":return[3,34];case"TensorListSplit":return[3,35];case"TensorListLength":return[3,36];case"TensorListResize":return[3,37]}return[3,38];case 1:return a=m("thenBranch",t,n,r),o=m("elseBranch",t,n,r),s=m("cond",t,n,r),c=m("args",t,n,r),[4,s.data()];case 2:return(g=ht.sent())[0]?[2,r.functionMap[a].executeFunctionAsync(c,r.tensorArrayMap,r.tensorListMap)]:[2,r.functionMap[o].executeFunctionAsync(c,r.tensorArrayMap,r.tensorListMap)];case 3:return i=m("body",t,n,r),u=m("cond",t,n,r),c=m("args",t,n,r),[4,r.functionMap[u].executeFunctionAsync(c,r.tensorArrayMap,r.tensorListMap)];case 4:return h=ht.sent(),f=c.map((function(t){return t.id})),[4,h[0].data()];case 5:g=ht.sent(),h.forEach((function(t){t.kept||-1!==f.indexOf(t.id)||t.dispose()})),v=c,b=function(){var t,e,n;return p(this,(function(a){switch(a.label){case 0:return t=v,[4,r.functionMap[i].executeFunctionAsync(v,r.tensorArrayMap,r.tensorListMap)];case 1:return v=a.sent(),e=v.map((function(t){return t.id})),t.forEach((function(t){t.kept||-1!==f.indexOf(t.id)||-1!==e.indexOf(t.id)||t.dispose()})),[4,r.functionMap[u].executeFunctionAsync(v,r.tensorArrayMap,r.tensorListMap)];case 2:return[4,(n=a.sent())[0].data()];case 3:return g=a.sent(),n.forEach((function(t){t.kept||-1!==f.indexOf(t.id)||-1!==e.indexOf(t.id)||t.dispose()})),[2]}}))},ht.label=6;case 6:return g[0]?[5,b()]:[3,8];case 7:return ht.sent(),[3,6];case 8:return[2,v];case 9:return[2,[N(x=m("pred",t,n,r))]];case 10:return x=m("pred",t,n,r),(T=m("data",t,n,r)).kept||(T=N(T)),[4,x.data()];case 11:return[2,ht.sent()[0]?[void 0,T]:[T,void 0]];case 12:return w=t.inputNames.find((function(t){return void 0!==y(t,n,r)})),w?[2,[N(T=y(w,n,r))]]:[2,void 0];case 13:return k=m("frameName",t,n,r),T=m("tensor",t,n,r),r.enterFrame(k),[2,[N(T)]];case 14:return T=m("tensor",t,n,r),r.exitFrame(),[2,[N(T)]];case 15:return T=m("tensor",t,n,r),r.nextIteration(),[2,[N(T)]];case 16:return ct=m("size",t,n,r),_=m("dtype",t,n,r),st=m("elementShape",t,n,r),S=m("dynamicSize",t,n,r),E=m("clearAfterRead",t,n,r),I=m("identicalElementShapes",t,n,r),O=m("name",t,n,r),D=new Ni(O,_,ct,st,I,S,E),r.addTensorArray(D),[2,[D.idTensor,e.scalar(1)]];case 17:return A=m("tensorArrayId",t,n,r),U=m("index",t,n,r),rt=m("tensor",t,n,r),(M=r.getTensorArray(A.id)).write(U,rt),[2,[M.idTensor]];case 18:return C=m("tensorArrayId",t,n,r),W=m("index",t,n,r),[2,[r.getTensorArray(C.id).read(W)]];case 19:return Y=m("tensorArrayId",t,n,r),X=m("indices",t,n,r),F=m("dtype",t,n,r),[2,[r.getTensorArray(Y.id).gather(X,F)]];case 20:return z=m("tensorArrayId",t,n,r),H=m("indices",t,n,r),G=m("tensor",t,n,r),(R=r.getTensorArray(z.id)).scatter(H,G),[2,[R.idTensor]];case 21:return et=m("tensorArrayId",t,n,r),V=r.getTensorArray(et.id),nt=m("dtype",t,n,r),[2,[V.concat(nt)]];case 22:return L=m("tensorArrayId",t,n,r),ot=m("tensor",t,n,r),it=m("lengths",t,n,r),(P=r.getTensorArray(L.id)).split(it,ot),[2,[P.idTensor]];case 23:return B=m("tensorArrayId",t,n,r),K=r.getTensorArray(B.id),[2,[e.scalar(K.size(),"int32")]];case 24:return j=m("tensorArrayId",t,n,r),(q=r.getTensorArray(j.id)).clearAndClose(),[2,[q.idTensor]];case 25:return pt=m("tensorListId",t,n,r),U=m("index",t,n,r),rt=m("tensor",t,n,r),(ut=r.getTensorList(pt.id)).setItem(U,rt),[2,[ut.idTensor]];case 26:return pt=m("tensorListId",t,n,r),W=m("index",t,n,r),st=m("elementShape",t,n,r),at=m("elementDType",t,n,r),[2,[(ut=r.getTensorList(pt.id)).getItem(W,st,at)]];case 27:return H=m("indices",t,n,r),G=m("tensor",t,n,r),st=m("elementShape",t,n,r),J=m("numElements",t,n,r),ut=function(t,n,r,a){if(n.length!==t.shape[0])throw new Error("Expected len(indices) == tensor.shape[0], but saw: ".concat(n.length," vs. ").concat(t.shape[0]));var o=Math.max.apply(Math,d([],l(n),!1));if(null!=a&&-1!==a&&o>=a)throw new Error("Max index must be < array size (".concat(o,"  vs. ").concat(a,")"));var s=new wi([],r,t.dtype,a),i=e.unstack(t,0);return n.forEach((function(t,e){s.setItem(t,i[e])})),s}(G,H,st,J),r.addTensorList(ut),[2,[ut.idTensor]];case 28:return st=m("elementShape",t,n,r),tt=m("elementDType",t,n,r),Z=void 0,Z="TensorListReserve"===t.op?"numElements":"maxNumElements",J=m(Z,t,n,r),Q="TensorListReserve"===t.op?-1:J,ut=function(t,e,n,r){return new wi([],t,e,r)}(st,tt,0,Q),r.addTensorList(ut),[2,[ut.idTensor]];case 29:return Y=m("tensorListId",t,n,r),X=m("indices",t,n,r),st=m("elementShape",t,n,r),tt=m("elementDType",t,n,r),[2,[(ut=r.getTensorList(Y.id)).gather(X,tt,st)]];case 30:return pt=m("tensorListId",t,n,r),st=m("elementShape",t,n,r),tt=m("elementDType",t,n,r),J=m("numElements",t,n,r),[2,[(ut=r.getTensorList(pt.id)).stack(st,tt,J)]];case 31:return $=m("tensor",t,n,r),st=m("elementShape",t,n,r),tt=m("elementDType",t,n,r),ut=function(t,n,r){var a=t.dtype;if(t.shape.length<1)throw new Error("Tensor must be at least a vector, but saw shape: ".concat(t.shape));if(t.dtype!==r)throw new Error("Invalid data types; op elements ".concat(t.dtype,", but list elements ").concat(r));gi(t.shape.slice(1),n,"TensorList shape mismatch: ");var o=e.unstack(t);return new wi(o,n,a)}($,st,tt),r.addTensorList(ut),[2,[ut.idTensor]];case 32:return et=m("tensorListId",t,n,r),ut=r.getTensorList(et.id),nt=m("dtype",t,n,r),st=m("elementShape",t,n,r),[2,[ut.concat(nt,st)]];case 33:return pt=m("tensorListId",t,n,r),rt=m("tensor",t,n,r),(ut=r.getTensorList(pt.id)).pushBack(rt),[2,[ut.idTensor]];case 34:return pt=m("tensorListId",t,n,r),st=m("elementShape",t,n,r),at=m("elementDType",t,n,r),[2,[(ut=r.getTensorList(pt.id)).popBack(st,at)]];case 35:return ot=m("tensor",t,n,r),st=m("elementShape",t,n,r),it=m("lengths",t,n,r),ut=function(t,n,r){var a=0,o=n.map((function(t){return a+=t}));if(a!==t.shape[0])throw new Error("Expected sum of lengths to be equal to\n          tensor.shape[0], but sum of lengths is\n        ".concat(a,", and tensor's shape is: ").concat(t.shape));for(var s=xi(t.shape.slice(1),r),i=0===a?0:t.size/a,u=e.tidy((function(){var r=[];t=e.reshape(t,[1,a,i]);for(var u=0;u<n.length;++u){var p=[0,0===u?0:o[u-1],0],c=[1,n[u],i];r[u]=e.reshape(e.slice(t,p,c),s)}return t.dispose(),r})),p=new wi([],r,t.dtype,n.length),c=0;c<u.length;c++)p.setItem(c,u[c]);return p}(ot,it,st),r.addTensorList(ut),[2,[ut.idTensor]];case 36:return pt=m("tensorListId",t,n,r),ut=r.getTensorList(pt.id),[2,[e.scalar(ut.size(),"int32")]];case 37:return pt=m("tensorListId",t,n,r),ct=m("size",t,n,r),lt=r.getTensorList(pt.id),dt=lt.resize(ct),r.addTensorList(dt),[2,[dt.idTensor]];case 38:throw TypeError("Node type ".concat(t.op," is not implemented"))}}))}))};function Ti(t,e,n){var r=l(m("fusedOps",t,e,n),2),a=r[0],o=r[1],s="biasadd"===a,i=!s,u="prelu"===o,p="fusedbatchnorm"===a,c=m("numArgs",t,e,n);if(s){if(u&&2!==c)throw new Error("FusedConv2d and DepthwiseConv2d with BiasAdd and Prelu must have two extra arguments: bias and alpha.");if(!u&&s&&1!==c)throw new Error("FusedConv2d and DepthwiseConv2d with BiasAdd must have one extra argument: bias.")}if(p)throw new Error("FusedConv2d and DepthwiseConv2d with FusedBatchNorm is not supported");var d=m("strides",t,e,n),h=x(t,e,n),f=m("dataFormat",t,e,n).toUpperCase(),y=m("dilations",t,e,n),g=l(m("args",t,e,n),2),v=g[0],b=g[1];return i&&(b=v,v=void 0),{stride:d,pad:h,dataFormat:f,dilations:y,biasArg:v,preluArg:b,activationFunc:o,leakyreluAlpha:m("leakyreluAlpha",t,e,n)}}function _i(t,e,n){return{boxes:m("boxes",t,e,n),scores:m("scores",t,e,n),maxOutputSize:m("maxOutputSize",t,e,n),iouThreshold:m("iouThreshold",t,e,n),scoreThreshold:m("scoreThreshold",t,e,n),softNmsSigma:m("softNmsSigma",t,e,n)}}var Si=function(){function t(t,n){this.keyDType=t,this.valueDType=n,this.handle=e.scalar(0),this.tensorMap=new Map,e.keep(this.handle)}return Object.defineProperty(t.prototype,"id",{get:function(){return this.handle.id},enumerable:!1,configurable:!0}),t.prototype.clearAndClose=function(){this.tensorMap.forEach((function(t){return t.dispose()})),this.tensorMap.clear(),this.handle.dispose()},t.prototype.size=function(){return this.tensorMap.size},t.prototype.tensorSize=function(){return Cr(this.size(),"int32")},t.prototype.import=function(t,n){return u(this,void 0,void 0,(function(){var r,a=this;return p(this,(function(o){switch(o.label){case 0:return this.checkKeyAndValueTensor(t,n),[4,t.data()];case 1:return r=o.sent(),this.tensorMap.forEach((function(t){return t.dispose()})),this.tensorMap.clear(),[2,e.tidy((function(){var t=e.unstack(n),o=r.length,s=t.length;e.util.assert(o===s,(function(){return"The number of elements doesn't match, keys has "+"".concat(o," elements, the values has ").concat(s," ")+"elements."}));for(var i=0;i<o;i++){var u=r[i],p=t[i];e.keep(p),a.tensorMap.set(u,p)}return a.handle}))]}}))}))},t.prototype.find=function(t,n){return u(this,void 0,void 0,(function(){var r,a=this;return p(this,(function(o){switch(o.label){case 0:return this.checkKeyAndValueTensor(t,n),[4,t.data()];case 1:return r=o.sent(),[2,e.tidy((function(){for(var t=[],o=0;o<r.length;o++){var s=r[o],i=a.findWithDefault(s,n);t.push(i)}return e.stack(t)}))]}}))}))},t.prototype.findWithDefault=function(t,e){var n=this.tensorMap.get(t);return null!=n?n:e},t.prototype.checkKeyAndValueTensor=function(t,e){if(t.dtype!==this.keyDType)throw new Error("Expect key dtype ".concat(this.keyDType,", but got ")+"".concat(t.dtype));if(e.dtype!==this.valueDType)throw new Error("Expect value dtype ".concat(this.valueDType,", but got ")+"".concat(e.dtype))},t}();function Ei(t,n,r,o,s){void 0===s&&(s=a.tidy);var i=function(t,n,r){switch(t.category){case"arithmetic":return s((function(){return function(t,e,n,r){switch(void 0===r&&(r=yi),t.op){case"BiasAdd":case"AddV2":case"Add":return[r.add(m("a",t,e,n),m("b",t,e,n))];case"AddN":return[r.addN(m("tensors",t,e,n))];case"FloorMod":case"Mod":return[r.mod(m("a",t,e,n),m("b",t,e,n))];case"Mul":return[r.mul(m("a",t,e,n),m("b",t,e,n))];case"RealDiv":case"Div":return[r.div(m("a",t,e,n),m("b",t,e,n))];case"DivNoNan":return[r.divNoNan(m("a",t,e,n),m("b",t,e,n))];case"FloorDiv":return[r.floorDiv(m("a",t,e,n),m("b",t,e,n))];case"Sub":return[r.sub(m("a",t,e,n),m("b",t,e,n))];case"Minimum":return[r.minimum(m("a",t,e,n),m("b",t,e,n))];case"Maximum":return[r.maximum(m("a",t,e,n),m("b",t,e,n))];case"Pow":return[r.pow(m("a",t,e,n),m("b",t,e,n))];case"SquaredDifference":return[r.squaredDifference(m("a",t,e,n),m("b",t,e,n))];default:throw TypeError("Node type ".concat(t.op," is not implemented"))}}(t,n,r)}));case"basic_math":return s((function(){return function(t,e,n,r){switch(void 0===r&&(r=yi),t.op){case"Abs":case"ComplexAbs":return[r.abs(m("x",t,e,n))];case"Acos":return[r.acos(m("x",t,e,n))];case"Acosh":return[r.acosh(m("x",t,e,n))];case"Asin":return[r.asin(m("x",t,e,n))];case"Asinh":return[r.asinh(m("x",t,e,n))];case"Atan":return[r.atan(m("x",t,e,n))];case"Atan2":return[r.atan2(m("x",t,e,n),m("y",t,e,n))];case"Atanh":return[r.atanh(m("x",t,e,n))];case"Ceil":return[r.ceil(m("x",t,e,n))];case"Complex":return[r.complex(m("real",t,e,n),m("imag",t,e,n))];case"Cos":return[r.cos(m("x",t,e,n))];case"Cosh":return[r.cosh(m("x",t,e,n))];case"Elu":return[r.elu(m("x",t,e,n))];case"Erf":return[r.erf(m("x",t,e,n))];case"Exp":return[r.exp(m("x",t,e,n))];case"Expm1":return[r.expm1(m("x",t,e,n))];case"Floor":return[r.floor(m("x",t,e,n))];case"Log":return[r.log(m("x",t,e,n))];case"Log1p":return[r.log1p(m("x",t,e,n))];case"Imag":return[r.imag(m("x",t,e,n))];case"Neg":return[r.neg(m("x",t,e,n))];case"Reciprocal":return[r.reciprocal(m("x",t,e,n))];case"Real":return[r.real(m("x",t,e,n))];case"Relu":return[r.relu(m("x",t,e,n))];case"Round":return[r.round(m("x",t,e,n))];case"Selu":return[r.selu(m("x",t,e,n))];case"Sigmoid":return[r.sigmoid(m("x",t,e,n))];case"Sin":return[r.sin(m("x",t,e,n))];case"Sign":return[r.sign(m("x",t,e,n))];case"Sinh":return[r.sinh(m("x",t,e,n))];case"Softplus":return[r.softplus(m("x",t,e,n))];case"Sqrt":return[r.sqrt(m("x",t,e,n))];case"Square":return[r.square(m("x",t,e,n))];case"Tanh":return[r.tanh(m("x",t,e,n))];case"Tan":return[r.tan(m("x",t,e,n))];case"ClipByValue":return[r.clipByValue(m("x",t,e,n),m("clipValueMin",t,e,n),m("clipValueMax",t,e,n))];case"Relu6":return[r.relu6(m("x",t,e,n))];case"Rsqrt":return[r.rsqrt(y(t.inputNames[0],e,n))];case"Prod":return[r.prod(m("x",t,e,n),m("axes",t,e,n))];case"LeakyRelu":return[r.leakyRelu(m("x",t,e,n),m("alpha",t,e,n))];case"Prelu":return[r.prelu(m("x",t,e,n),m("alpha",t,e,n))];case"IsNan":return[r.isNaN(y(t.inputNames[0],e,n))];default:throw TypeError("Node type ".concat(t.op," is not implemented"))}}(t,n,r)}));case"control":return ki(t,n,r);case"convolution":return s((function(){return function(t,e,n,r){switch(void 0===r&&(r=yi),t.op){case"Conv1D":var a=m("stride",t,e,n),o=m("pad",t,e,n),s=m("dataFormat",t,e,n).toUpperCase(),i=m("dilation",t,e,n);return[r.conv1d(m("x",t,e,n),m("filter",t,e,n),a,o,s,i)];case"Conv2D":a=m("strides",t,e,n),o=x(t,e,n),s=m("dataFormat",t,e,n).toUpperCase();var u=m("dilations",t,e,n);return[r.conv2d(m("x",t,e,n),m("filter",t,e,n),[a[1],a[2]],o,s,[u[1],u[2]])];case"_FusedConv2D":var p=Ti(t,e,n),c=(a=p.stride,o=p.pad,s=p.dataFormat,u=p.dilations,p.biasArg),l=p.preluArg,d=p.activationFunc,h=p.leakyreluAlpha;return[r.fused.conv2d({x:m("x",t,e,n),filter:m("filter",t,e,n),strides:[a[1],a[2]],pad:o,dataFormat:s,dilations:[u[1],u[2]],bias:c,activation:d,preluActivationWeights:l,leakyreluAlpha:h})];case"FusedDepthwiseConv2dNative":var f=Ti(t,e,n);return a=f.stride,o=f.pad,s=f.dataFormat,u=f.dilations,c=f.biasArg,l=f.preluArg,d=f.activationFunc,h=f.leakyreluAlpha,[r.fused.depthwiseConv2d({x:m("x",t,e,n),filter:m("filter",t,e,n),strides:[a[1],a[2]],pad:o,dataFormat:s,dilations:[u[1],u[2]],bias:c,activation:d,preluActivationWeights:l,leakyreluAlpha:h})];case"Conv2DBackpropInput":case"Conv2dTranspose":var y=m("outputShape",t,e,n);return a=m("strides",t,e,n),o=x(t,e,n),[r.conv2dTranspose(m("x",t,e,n),m("filter",t,e,n),y,[a[1],a[2]],o)];case"DepthwiseConv2dNative":case"DepthwiseConv2d":return a=m("strides",t,e,n),o=x(t,e,n),u=m("dilations",t,e,n),s=m("dataFormat",t,e,n).toUpperCase(),[r.depthwiseConv2d(m("input",t,e,n),m("filter",t,e,n),[a[1],a[2]],o,s,[u[1],u[2]])];case"Conv3D":return a=m("strides",t,e,n),o=m("pad",t,e,n),s=m("dataFormat",t,e,n).toUpperCase(),u=m("dilations",t,e,n),[r.conv3d(m("x",t,e,n),m("filter",t,e,n),[a[1],a[2],a[3]],o,s,[u[1],u[2],u[3]])];case"AvgPool":a=m("strides",t,e,n),o=m("pad",t,e,n);var g=m("kernelSize",t,e,n);return[r.avgPool(m("x",t,e,n),[g[1],g[2]],[a[1],a[2]],o)];case"MaxPool":return a=m("strides",t,e,n),o=m("pad",t,e,n),g=m("kernelSize",t,e,n),[r.maxPool(m("x",t,e,n),[g[1],g[2]],[a[1],a[2]],o)];case"MaxPoolWithArgmax":a=m("strides",t,e,n),o=m("pad",t,e,n),g=m("kernelSize",t,e,n);var v=m("includeBatchInIndex",t,e,n),b=r.maxPoolWithArgmax(m("x",t,e,n),[g[1],g[2]],[a[1],a[2]],o,v);return[b.result,b.indexes];case"AvgPool3D":return a=m("strides",t,e,n),o=m("pad",t,e,n),g=m("kernelSize",t,e,n),[r.avgPool3d(m("x",t,e,n),[g[1],g[2],g[3]],[a[1],a[2],a[3]],o)];case"MaxPool3D":return a=m("strides",t,e,n),o=m("pad",t,e,n),g=m("kernelSize",t,e,n),[r.maxPool3d(m("x",t,e,n),[g[1],g[2],g[3]],[a[1],a[2],a[3]],o)];case"Dilation2D":var N=m("strides",t,e,n),w=(o=m("pad",t,e,n),u=m("dilations",t,e,n),N[1]),k=N[2],T=u[1],_=u[2];return[r.dilation2d(m("x",t,e,n),m("filter",t,e,n),[w,k],o,[T,_],"NHWC")];default:throw TypeError("Node type ".concat(t.op," is not implemented"))}}(t,n,r)}));case"creation":return s((function(){return function(t,e,n,r){switch(void 0===r&&(r=yi),t.op){case"Fill":var a=m("shape",t,e,n),o=m("dtype",t,e,n),s=m("value",t,e,n);return[r.fill(a,s,o)];case"LinSpace":var i=m("start",t,e,n),u=m("stop",t,e,n),p=m("num",t,e,n);return[r.linspace(i,u,p)];case"Multinomial":var c=m("logits",t,e,n),l=m("numSamples",t,e,n),d=m("seed",t,e,n);return[r.multinomial(c,l,d)];case"OneHot":var h=m("indices",t,e,n),f=m("depth",t,e,n),y=m("onValue",t,e,n),g=m("offValue",t,e,n);return o=m("dtype",t,e,n),[r.oneHot(h,f,y,g,o)];case"Ones":return[r.ones(m("shape",t,e,n),m("dtype",t,e,n))];case"OnesLike":return[r.onesLike(m("x",t,e,n))];case"RandomStandardNormal":return[r.randomStandardNormal(m("shape",t,e,n),m("dtype",t,e,n),m("seed",t,e,n))];case"RandomUniform":return[r.randomUniform(m("shape",t,e,n),m("minval",t,e,n),m("maxval",t,e,n),m("dtype",t,e,n))];case"Range":i=m("start",t,e,n),u=m("stop",t,e,n);var v=m("step",t,e,n);return[r.range(i,u,v,m("dtype",t,e,n))];case"TruncatedNormal":a=m("shape",t,e,n);var b=m("mean",t,e,n),x=m("stdDev",t,e,n);return d=m("seed",t,e,n),[r.truncatedNormal(a,b,x,m("dtype",t,e,n),d)];case"Zeros":return[r.zeros(m("shape",t,e,n),m("dtype",t,e,n))];case"ZerosLike":return[r.zerosLike(m("x",t,e,n))];default:throw TypeError("Node type ".concat(t.op," is not implemented"))}}(t,n,r)}));case"dynamic":return function(t,e,n,r,a){return void 0===a&&(a=yi),u(void 0,void 0,void 0,(function(){var r,o,s,i,u,c,l,d,h,f,y,g;return p(this,(function(p){switch(p.label){case 0:switch(t.op){case"NonMaxSuppressionV5":return[3,1];case"NonMaxSuppressionV4":return[3,3];case"NonMaxSuppressionV3":case"NonMaxSuppressionV2":return[3,5];case"Where":return[3,7];case"ListDiff":return[3,9]}return[3,10];case 1:return r=_i(t,e,n),c=r.boxes,l=r.scores,d=r.maxOutputSize,h=r.iouThreshold,f=r.scoreThreshold,o=r.softNmsSigma,[4,a.image.nonMaxSuppressionWithScoreAsync(c,l,d,h,f,o)];case 2:return[2,[(g=p.sent()).selectedIndices,g.selectedScores]];case 3:return s=_i(t,e,n),c=s.boxes,l=s.scores,d=s.maxOutputSize,h=s.iouThreshold,f=s.scoreThreshold,i=m("padToMaxOutputSize",t,e,n),[4,a.image.nonMaxSuppressionPaddedAsync(c,l,d,h,f,i)];case 4:return[2,[(g=p.sent()).selectedIndices,g.validOutputs]];case 5:return u=_i(t,e,n),c=u.boxes,l=u.scores,d=u.maxOutputSize,h=u.iouThreshold,f=u.scoreThreshold,[4,a.image.nonMaxSuppressionAsync(c,l,d,h,f)];case 6:return[2,[p.sent()]];case 7:return y=a.cast(m("condition",t,e,n),"bool"),[4,a.whereAsync(y)];case 8:return g=[p.sent()],y.dispose(),[2,g];case 9:return[2,a.setdiff1dAsync(m("x",t,e,n),m("y",t,e,n))];case 10:throw TypeError("Node type ".concat(t.op," is not implemented"))}}))}))}(t,n,r);case"evaluation":return s((function(){return function(t,e,n,r){switch(void 0===r&&(r=yi),t.op){case"LowerBound":var a=m("sortedSequence",t,e,n),o=m("values",t,e,n);return[r.lowerBound(a,o)];case"TopKV2":var s=m("x",t,e,n),i=m("k",t,e,n),u=m("sorted",t,e,n);return[(p=r.topk(s,i,u)).values,p.indices];case"UpperBound":return a=m("sortedSequence",t,e,n),o=m("values",t,e,n),[r.upperBound(a,o)];case"Unique":return s=m("x",t,e,n),[(p=r.unique(s)).values,p.indices];case"UniqueV2":s=m("x",t,e,n);var p,c=m("axis",t,e,n);return[(p=r.unique(s,c)).values,p.indices];default:throw TypeError("Node type ".concat(t.op," is not implemented"))}}(t,n,r)}));case"image":return s((function(){return function(t,e,n,r){switch(void 0===r&&(r=yi),t.op){case"ResizeBilinear":var a=m("images",t,e,n),o=m("size",t,e,n),s=m("alignCorners",t,e,n),i=m("halfPixelCenters",t,e,n);return[r.image.resizeBilinear(a,[o[0],o[1]],s,i)];case"ResizeNearestNeighbor":return a=m("images",t,e,n),o=m("size",t,e,n),s=m("alignCorners",t,e,n),i=m("halfPixelCenters",t,e,n),[r.image.resizeNearestNeighbor(a,[o[0],o[1]],s,i)];case"CropAndResize":var u=m("image",t,e,n),p=m("boxes",t,e,n),c=m("boxInd",t,e,n),l=m("cropSize",t,e,n),d=m("method",t,e,n),h=m("extrapolationValue",t,e,n);return[r.image.cropAndResize(u,p,c,l,d,h)];case"ImageProjectiveTransformV3":a=m("images",t,e,n);var f=m("transforms",t,e,n),y=m("outputShape",t,e,n),g=m("fillValue",t,e,n),v=m("interpolation",t,e,n),b=m("fillMode",t,e,n);return[r.image.transform(a,f,v.toLowerCase(),b.toLowerCase(),g,y)];default:throw TypeError("Node type ".concat(t.op," is not implemented"))}}(t,n,r)}));case"graph":return s((function(){return function(t,e,n,r){switch(void 0===r&&(r=yi),t.op){case"Const":return e[t.name];case"PlaceholderWithDefault":var a=m("default",t,e,n);return[y(t.name,e,n)||a];case"Placeholder":return[y(t.name,e,n)];case"Identity":case"StopGradient":case"FakeQuantWithMinMaxVars":case"Snapshot":return[N(m("x",t,e,n))];case"IdentityN":return m("x",t,e,n).map((function(t){return N(t)}));case"Shape":return[r.tensor1d(m("x",t,e,n).shape,"int32")];case"ShapeN":return m("x",t,e,n).map((function(t){return r.tensor1d(t.shape)}));case"Size":return[r.scalar(m("x",t,e,n).size,"int32")];case"Rank":return[r.scalar(m("x",t,e,n).rank,"int32")];case"NoOp":return[r.scalar(1)];case"Print":var o=m("x",t,e,n),s=m("data",t,e,n),i=m("message",t,e,n),u=m("summarize",t,e,n);console.warn("The graph has a tf.print() operation,usually used for debugging, which slows down performance."),console.log(i);for(var p=0;p<s.length;p++)console.log(Array.prototype.slice.call(s[p].dataSync()).slice(0,u));return[o];default:throw TypeError("Node type ".concat(t.op," is not implemented"))}}(t,n,r)}));case"logical":return s((function(){return function(t,e,n,r){switch(void 0===r&&(r=yi),t.op){case"Equal":return[r.equal(m("a",t,e,n),m("b",t,e,n))];case"NotEqual":return[r.notEqual(m("a",t,e,n),m("b",t,e,n))];case"Greater":return[r.greater(m("a",t,e,n),m("b",t,e,n))];case"GreaterEqual":return[r.greaterEqual(m("a",t,e,n),m("b",t,e,n))];case"Less":return[r.less(m("a",t,e,n),m("b",t,e,n))];case"LessEqual":return[r.lessEqual(m("a",t,e,n),m("b",t,e,n))];case"LogicalAnd":return[r.logicalAnd(m("a",t,e,n),m("b",t,e,n))];case"LogicalNot":return[r.logicalNot(m("a",t,e,n))];case"LogicalOr":return[r.logicalOr(m("a",t,e,n),m("b",t,e,n))];case"Select":case"SelectV2":return[r.where(m("condition",t,e,n),m("a",t,e,n),m("b",t,e,n))];default:throw TypeError("Node type ".concat(t.op," is not implemented"))}}(t,n,r)}));case"matrices":return s((function(){return function(t,e,n,r){switch(void 0===r&&(r=yi),t.op){case"BatchMatMul":case"BatchMatMulV2":case"MatMul":return[r.matMul(m("a",t,e,n),m("b",t,e,n),m("transposeA",t,e,n),m("transposeB",t,e,n))];case"Einsum":return[r.einsum.apply(r,d([m("equation",t,e,n)],l(m("tensors",t,e,n)),!1))];case"Transpose":return[r.transpose(m("x",t,e,n),m("perm",t,e,n))];case"_FusedMatMul":var a=l(m("fusedOps",t,e,n),2),o=a[0],s=a[1],i="biasadd"===o,u="prelu"===s,p=m("numArgs",t,e,n),c=m("leakyreluAlpha",t,e,n);if(i){if(u&&2!==p)throw new Error("Fused MatMul with BiasAdd and Prelu must have two extra arguments: bias and alpha.");if(!u&&1!==p)throw new Error("Fused MatMul with BiasAdd must have one extra argument: bias.")}var h=l(m("args",t,e,n),2),f=h[0],y=h[1];return[r.fused.matMul({a:m("a",t,e,n),b:m("b",t,e,n),transposeA:m("transposeA",t,e,n),transposeB:m("transposeB",t,e,n),bias:f,activation:s,preluActivationWeights:y,leakyreluAlpha:c})];default:throw TypeError("Node type ".concat(t.op," is not implemented"))}}(t,n,r)}));case"normalization":return s((function(){return function(t,e,n,r){switch(void 0===r&&(r=yi),t.op){case"EuclideanNorm":return[r.euclideanNorm(m("x",t,e,n),m("axis",t,e,n),m("keepDims",t,e,n))];case"FusedBatchNorm":case"FusedBatchNormV2":case"FusedBatchNormV3":return[r.batchNorm(m("x",t,e,n),m("mean",t,e,n),m("variance",t,e,n),m("offset",t,e,n),m("scale",t,e,n),m("epsilon",t,e,n))];case"LRN":return[r.localResponseNormalization(m("x",t,e,n),m("radius",t,e,n),m("bias",t,e,n),m("alpha",t,e,n),m("beta",t,e,n))];case"Softmax":return[r.softmax(m("x",t,e,n))];case"LogSoftmax":return[r.logSoftmax(m("x",t,e,n))];case"SparseToDense":return[r.sparseToDense(m("sparseIndices",t,e,n),m("outputShape",t,e,n),m("sparseValues",t,e,n),m("defaultValue",t,e,n))];default:throw TypeError("Node type ".concat(t.op," is not implemented"))}}(t,n,r)}));case"reduction":return s((function(){return function(t,e,n,r){switch(void 0===r&&(r=yi),t.op){case"Max":var a=m("axis",t,e,n),o=m("keepDims",t,e,n);return[r.max(m("x",t,e,n),a,o)];case"Mean":return a=m("axis",t,e,n),o=m("keepDims",t,e,n),[r.mean(m("x",t,e,n),a,o)];case"Min":return a=m("axis",t,e,n),o=m("keepDims",t,e,n),[r.min(m("x",t,e,n),a,o)];case"Sum":return a=m("axis",t,e,n),o=m("keepDims",t,e,n),[r.sum(m("x",t,e,n),a,o)];case"All":return a=m("axis",t,e,n),o=m("keepDims",t,e,n),[r.all(m("x",t,e,n),a,o)];case"Any":return a=m("axis",t,e,n),o=m("keepDims",t,e,n),[r.any(m("x",t,e,n),a,o)];case"ArgMax":return a=m("axis",t,e,n),[r.argMax(m("x",t,e,n),a)];case"ArgMin":return a=m("axis",t,e,n),[r.argMin(m("x",t,e,n),a)];case"Prod":return a=m("axis",t,e,n),o=m("keepDims",t,e,n),[r.prod(m("x",t,e,n),a,o)];case"Cumprod":a=m("axis",t,e,n);var s=m("exclusive",t,e,n),i=m("reverse",t,e,n);return[r.cumprod(m("x",t,e,n),a,s,i)];case"Cumsum":return a=m("axis",t,e,n),s=m("exclusive",t,e,n),i=m("reverse",t,e,n),[r.cumsum(m("x",t,e,n),a,s,i)];case"Bincount":var u=m("x",t,e,n),p=m("weights",t,e,n),c=m("size",t,e,n);return[r.bincount(u,p,c)];case"DenseBincount":var l=m("x",t,e,n),d=m("weights",t,e,n),h=m("size",t,e,n),f=m("binaryOutput",t,e,n);return[r.denseBincount(l,d,h,f)];default:throw TypeError("Node type ".concat(t.op," is not implemented"))}}(t,n,r)}));case"slice_join":return s((function(){return function(t,n,r,a){switch(void 0===a&&(a=yi),t.op){case"ConcatV2":case"Concat":var o=m("n",t,n,r),s=m("axis",t,n,r),i=m("tensors",t,n,r);return i=i.slice(0,o),[a.concat(i,s)];case"Gather":var u=m("x",t,n,r),p=m("indices",t,n,r);return[a.gather(u,a.cast(p,"int32"),0)];case"GatherV2":s=m("axis",t,n,r);var c=m("batchDims",t,n,r);return u=m("x",t,n,r),p=m("indices",t,n,r),[a.gather(u,a.cast(p,"int32"),s,c)];case"Reverse":for(var l=m("dims",t,n,r),d=(s=[],0);d<l.length;d++)l[d]&&s.push(d);return u=m("x",t,n,r),[a.reverse(u,s)];case"ReverseV2":return s=m("axis",t,n,r),u=m("x",t,n,r),[a.reverse(u,s)];case"Slice":var h=m("begin",t,n,r),f=m("size",t,n,r);return[a.slice(m("x",t,n,r),h,f)];case"StridedSlice":h=m("begin",t,n,r);var y=m("end",t,n,r),g=m("strides",t,n,r),v=m("beginMask",t,n,r),b=m("endMask",t,n,r),x=m("ellipsisMask",t,n,r),N=m("newAxisMask",t,n,r),w=m("shrinkAxisMask",t,n,r),k=m("x",t,n,r);return[a.stridedSlice(k,h,y,g,v,b,x,N,w)];case"Pack":return e.tidy((function(){var o=m("axis",t,n,r),s=m("tensors",t,n,r),i=s[0].shape,u=a.squeeze(s[0]).shape,p=s.map((function(t){var n=e.util.arraysEqual(t.shape,i);if(!n&&!e.util.arraysEqual(a.squeeze(t).shape,u))throw new Error("the input tensors shape does not match");return n?t:a.reshape(t,i)}));return[a.stack(p,o)]}));case"Unpack":return s=m("axis",t,n,r),k=m("tensor",t,n,r),a.unstack(k,s);case"Tile":var T=m("reps",t,n,r);return[a.tile(m("x",t,n,r),T)];case"Split":case"SplitV":s=m("axis",t,n,r);var _=m("numOrSizeSplits",t,n,r);return k=m("x",t,n,r),a.split(k,_,s);case"ScatterNd":p=m("indices",t,n,r);var S=m("values",t,n,r),E=m("shape",t,n,r);return[a.scatterND(p,S,E)];case"GatherNd":var I=m("x",t,n,r);return p=m("indices",t,n,r),[a.gatherND(I,p)];case"SparseToDense":p=m("sparseIndices",t,n,r),E=m("outputShape",t,n,r);var O=m("sparseValues",t,n,r),D=m("defaultValue",t,n,r);return[a.sparseToDense(p,O,E,O.dtype===D.dtype?D:a.cast(D,O.dtype))];default:throw TypeError("Node type ".concat(t.op," is not implemented"))}}(t,n,r)}));case"sparse":return s((function(){return function(t,e,n,r){switch(void 0===r&&(r=yi),t.op){case"SparseFillEmptyRows":var a=r.sparse.sparseFillEmptyRows(m("indices",t,e,n),m("values",t,e,n),m("denseShape",t,e,n),m("defaultValue",t,e,n));return[a.outputIndices,a.outputValues,a.emptyRowIndicator,a.reverseIndexMap];case"SparseReshape":var o=r.sparse.sparseReshape(m("inputIndices",t,e,n),m("inputShape",t,e,n),m("newShape",t,e,n));return[o.outputIndices,o.outputShape];case"SparseSegmentMean":return[r.sparse.sparseSegmentMean(m("data",t,e,n),m("indices",t,e,n),m("segmentIds",t,e,n))];case"SparseSegmentSum":return[r.sparse.sparseSegmentSum(m("data",t,e,n),m("indices",t,e,n),m("segmentIds",t,e,n))];default:throw TypeError("Node type ".concat(t.op," is not implemented"))}}(t,n,r)}));case"spectral":return s((function(){return function(t,e,n,r){switch(void 0===r&&(r=yi),t.op){case"FFT":return[r.fft(m("x",t,e,n))];case"IFFT":return[r.ifft(m("x",t,e,n))];case"RFFT":return[r.rfft(m("x",t,e,n))];case"IRFFT":return[r.irfft(m("x",t,e,n))];default:throw TypeError("Node type ".concat(t.op," is not implemented"))}}(t,n,r)}));case"string":return s((function(){return function(t,e,n,r){switch(void 0===r&&(r=yi),t.op){case"StringNGrams":var a=r.string.stringNGrams(m("data",t,e,n),m("dataSplits",t,e,n),m("separator",t,e,n),m("nGramWidths",t,e,n),m("leftPad",t,e,n),m("rightPad",t,e,n),m("padWidth",t,e,n),m("preserveShortSequences",t,e,n));return[a.nGrams,a.nGramsSplits];case"StringSplit":var o=r.string.stringSplit(m("input",t,e,n),m("delimiter",t,e,n),m("skipEmpty",t,e,n));return[o.indices,o.values,o.shape];case"StringToHashBucketFast":return[r.string.stringToHashBucketFast(m("input",t,e,n),m("numBuckets",t,e,n))];default:throw TypeError("Node type ".concat(t.op," is not implemented"))}}(t,n,r)}));case"transformation":return s((function(){return function(t,e,n,r){switch(void 0===r&&(r=yi),t.op){case"Cast":return[r.cast(m("x",t,e,n),m("dtype",t,e,n))];case"ExpandDims":var a=m("axis",t,e,n);return[r.expandDims(m("x",t,e,n),a)];case"Squeeze":return a=m("axis",t,e,n),[r.squeeze(m("x",t,e,n),a)];case"Reshape":return[r.reshape(m("x",t,e,n),m("shape",t,e,n))];case"MirrorPad":return[r.mirrorPad(m("x",t,e,n),m("padding",t,e,n),m("mode",t,e,n))];case"PadV2":case"Pad":return[r.pad(m("x",t,e,n),m("padding",t,e,n),m("constantValue",t,e,n))];case"SpaceToBatchND":var o=m("blockShape",t,e,n),s=m("paddings",t,e,n);return[r.spaceToBatchND(m("x",t,e,n),o,s)];case"BatchToSpaceND":o=m("blockShape",t,e,n);var i=m("crops",t,e,n);return[r.batchToSpaceND(m("x",t,e,n),o,i)];case"DepthToSpace":var u=m("blockSize",t,e,n),p=m("dataFormat",t,e,n).toUpperCase();return[r.depthToSpace(m("x",t,e,n),u,p)];case"BroadcastTo":return[r.broadcastTo(m("x",t,e,n),m("shape",t,e,n))];case"BroadcastArgs":return[r.broadcastArgs(m("s0",t,e,n),m("s1",t,e,n))];default:throw TypeError("Node type ".concat(t.op," is not implemented"))}}(t,n,r)}));case"hash_table":return function(t,e,n,r){return u(void 0,void 0,void 0,(function(){var a,o,s,i,u,c,l,d;return p(this,(function(p){switch(p.label){case 0:switch(t.op){case"HashTable":case"HashTableV2":return[3,1];case"LookupTableImport":case"LookupTableImportV2":return[3,2];case"LookupTableFind":case"LookupTableFindV2":return[3,4];case"LookupTableSize":case"LookupTableSizeV2":return[3,6]}return[3,7];case 1:return null!=(a=r.getHashTableHandleByName(t.name))?[2,[a]]:(o=m("keyDType",t,e,n),s=m("valueDType",t,e,n),d=new Si(o,s),r.addHashTable(t.name,d),[2,[d.handle]]);case 2:return l=m("tableHandle",t,e,n,r),u=m("keys",t,e,n),i=m("values",t,e,n),[4,(d=r.getHashTableById(l.id)).import(u,i)];case 3:case 5:return[2,[p.sent()]];case 4:return l=m("tableHandle",t,e,n,r),u=m("keys",t,e,n),c=m("defaultValue",t,e,n),[4,(d=r.getHashTableById(l.id)).find(u,c)];case 6:return l=m("tableHandle",t,e,n,r),[2,[(d=r.getHashTableById(l.id)).tensorSize()]];case 7:throw TypeError("Node type ".concat(t.op," is not implemented"))}}))}))}(t,n,r,o);case"custom":var a=f(t.op);if(a&&a.customExecutor)return a.customExecutor(new nt(t,n,r));throw TypeError("Custom op ".concat(t.op," is not registered."));default:throw TypeError("Unknown op '".concat(t.op,"'. File an issue at ")+"https://github.com/tensorflow/tfjs/issues so we can add it, or register a custom execution with tf.registerOp()")}}(t,n,r);return a.util.isPromise(i)?i.then((function(t){return[].concat(t)})):[].concat(i)}var Ii=function(){function t(t,e,n,r){void 0===t&&(t={}),void 0===e&&(e={}),void 0===n&&(n={}),void 0===r&&(r={}),this.weightMap=t,this.tensorArrayMap=e,this.tensorListMap=n,this.functionMap=r,this.rootContext={id:0,frameName:"",iterationId:0},this.contexts=[this.rootContext],this.lastId=0,this.generateCurrentContextIds()}return t.prototype.newFrame=function(t,e){return{id:t,frameName:e,iterationId:0}},Object.defineProperty(t.prototype,"currentContext",{get:function(){return this.contexts},set:function(t){this.contexts!==t&&(this.contexts=t,this.generateCurrentContextIds())},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"currentContextId",{get:function(){return this._currentContextIds[0]},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"currentContextIds",{get:function(){return this._currentContextIds},enumerable:!1,configurable:!0}),t.prototype.generateCurrentContextIds=function(){for(var t=[],e=0;e<this.contexts.length-1;e++){var n=this.contexts.slice(0,this.contexts.length-e);t.push(this.contextIdforContexts(n))}t.push(""),this._currentContextIds=t},t.prototype.contextIdforContexts=function(t){return t?t.map((function(t){return 0===t.id&&0===t.iterationId?"":"".concat(t.frameName,"-").concat(t.iterationId)})).join("/"):""},t.prototype.enterFrame=function(t){this.contexts&&(this.lastId++,this.contexts=this.contexts.slice(),this.contexts.push(this.newFrame(this.lastId,t)),this._currentContextIds.unshift(this.contextIdforContexts(this.contexts)))},t.prototype.exitFrame=function(){if(!(this.contexts&&this.contexts.length>1))throw new Error("Cannot exit frame, the context is empty");this.contexts=this.contexts.slice(),this.contexts.splice(-1),this.currentContextIds.shift()},t.prototype.nextIteration=function(){if(!(this.contexts&&this.contexts.length>0))throw new Error("Cannot increase frame iteration, the context is empty");this.contexts=this.contexts.slice(),this.lastId++;var t=Object.assign({},this.contexts[this.contexts.length-1]);t.iterationId+=1,t.id=this.lastId,this.contexts.splice(-1,1,t),this._currentContextIds.splice(0,1,this.contextIdforContexts(this.contexts))},t.prototype.getWeight=function(t){return this.weightMap[t]},t.prototype.addTensorArray=function(t){this.tensorArrayMap[t.id]=t},t.prototype.getTensorArray=function(t){return this.tensorArrayMap[t]},t.prototype.addTensorList=function(t){this.tensorListMap[t.id]=t},t.prototype.getTensorList=function(t){return this.tensorListMap[t]},t.prototype.dispose=function(t){for(var e in this.tensorArrayMap)this.tensorArrayMap[e].clearAndClose(t);for(var e in this.tensorListMap)this.tensorListMap[e].clearAndClose(t)},t}();function Oi(t,e,n,r){var a=new Set,o=[],s=null,i=null,u=new Set,p=Object.keys(t).map((function(t){return b(t)[0]})),c=[];null!=r&&(c=r.map((function(t){return b(t.name)[0]})));for(var h=d([],l(e),!1);h.length>0;){var f=h.pop();(Ci(f)||Fi(f)||zi(f))&&null==s&&(i=(s=f).children.map((function(t){return t.name})).filter((function(t){return a.has(t)}))),a.add(f.name),null==n[f.name]&&(-1===p.indexOf(f.name)&&-1===c.indexOf(f.name)&&(0!==f.inputs.length?f.inputs.forEach((function(t){u.has(t.name)||(u.add(t.name),h.push(t))})):o.push(f.name)))}return{inputs:t,outputs:e,usedNodes:a,missingInputs:o,dynamicNode:s,syncInputs:i}}var Di=["Switch","Merge","Enter","Exit","NextIteration","StatelessIf","StatelessWhile","if","While"],Ai=["NonMaxSuppressionV2","NonMaxSuppressionV3","NonMaxSuppressionV5","Where"],Mi=["HashTable","HashTableV2","LookupTableImport","LookupTableImportV2","LookupTableFind","LookupTableFindV2","LookupTableSize","LookupTableSizeV2"];function Ci(t){return Di.indexOf(t.op)>=0}function Fi(t){return Ai.indexOf(t.op)>=0}function zi(t){return Mi.indexOf(t.op)>=0}var Ri=function(){function t(e,n){var r=this;this.graph=e,this.parent=n,this.compiledMap=new Map,this._weightMap={},this.SEPERATOR=",",this._functions={},this._functionExecutorMap={},this.intermediateTensors={},this.keepTensorForDebug=!1,this._outputs=e.outputs,this._inputs=e.inputs,this._initNodes=e.initNodes,this._signature=e.signature,this._functions=e.functions,null!=e.functions&&Object.keys(e.functions).forEach((function(n){r._functionExecutorMap[n]=new t(e.functions[n],r)}))}return Object.defineProperty(t.prototype,"weightIds",{get:function(){return this.parent?this.parent.weightIds:this._weightIds},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"functionExecutorMap",{get:function(){return this.parent?this.parent.functionExecutorMap:this._functionExecutorMap},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"weightMap",{get:function(){return this.parent?this.parent.weightMap:this._weightMap},set:function(t){var e=Object.keys(t).map((function(e){return t[e].map((function(t){return t.id}))}));this._weightIds=[].concat.apply([],d([],l(e),!1)),this._weightMap=t},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"resourceManager",{set:function(t){this._resourceManager=t},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"inputs",{get:function(){return this._inputs.map((function(t){return{name:t.name,shape:t.attrParams.shape?t.attrParams.shape.value:void 0,dtype:t.attrParams.dtype?t.attrParams.dtype.value:void 0}}))},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"outputs",{get:function(){return this._outputs.map((function(t){return{name:t.name,shape:t.attrParams.shape?t.attrParams.shape.value:void 0,dtype:t.attrParams.dtype?t.attrParams.dtype.value:void 0}}))},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"inputNodes",{get:function(){return this._inputs.map((function(t){return t.signatureKey||t.name}))},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"outputNodes",{get:function(){return this._outputs.map((function(t){var e=t.signatureKey||t.name;return t.defaultOutput?"".concat(e,":").concat(t.defaultOutput):e}))},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"functions",{get:function(){var t=this;return Object.keys(this._functions).reduce((function(e,n){return e[n]=t._functions[n].signature,e}),{})},enumerable:!1,configurable:!0}),t.prototype.getCompilationKey=function(t,e){var n=t.map((function(t){return t.name})).sort(),r=e.map((function(t){return t.name})).sort();return n.join(this.SEPERATOR)+"--"+r.join(this.SEPERATOR)},t.prototype.compile=function(t,e){var n=Oi(t,e,this.weightMap,this._initNodes),r=n.missingInputs,a=n.dynamicNode,o=n.syncInputs;if(null!=a)throw new Error("This execution contains the node '".concat(a.name,"', which has ")+"the dynamic op '".concat(a.op,"'. Please use ")+"model.executeAsync() instead. Alternatively, to avoid the "+"dynamic ops, specify the inputs [".concat(o,"]"));if(r.length>0){var s=e.map((function(t){return t.name})),i=Object.keys(t);throw new Error("Cannot compute the outputs [".concat(s,"] from the provided inputs ")+"[".concat(i,"]. Missing the following inputs: [").concat(r,"]"))}return function(t,e,n){var r=n.usedNodes,a=n.inputs,o=[],s=Object.keys(a).map((function(t){return b(t)[0]})).map((function(e){return t.nodes[e]})),i=t.initNodes;s.forEach((function(t){r.has(t.name)&&o.push(t)})),t.weights.forEach((function(t){r.has(t.name)&&o.push(t)})),null!=i&&i.forEach((function(t){r.has(t.name)&&o.push(t)}));for(var u=new Set,p=[];o.length>0;){var c=o.pop();u.add(c.name),e[c.name]||p.push(c),c.children.forEach((function(t){!u.has(t.name)&&r.has(t.name)&&t.inputs.every((function(t){return u.has(t.name)}))&&o.push(t)}))}return p}(this.graph,this.weightMap,n)},t.prototype.execute=function(t,n){var r=this;t=this.mapInputs(t);var a=Object.keys(t).sort();this.checkInputs(t),this.checkInputShapeAndType(t),n=this.mapOutputs(n),this.checkOutputs(n);var o=a.map((function(t){return r.graph.nodes[b(t)[0]]})),s=n.map((function(t){return b(t)[0]})),i=s.map((function(t){return r.graph.nodes[t]}));this.resetIntermediateTensors(),0===i.length&&(i=this._outputs);var u=this.getCompilationKey(o,i),p=this.compiledMap.get(u);null==p&&(p=this.compile(t,i),this.compiledMap.set(u,p));var c={},d={};return e.tidy((function(){var a=new Ii(r.weightMap,c,d,r.functionExecutorMap),o=Object.assign({},r.weightMap);Object.keys(t).forEach((function(e){var n=l(b(e),2),r=n[0],a=[];a[n[1]]=t[e],o[r]=a}));for(var i=r.getFrozenTensorIds(o),u={},h=0;h<p.length;h++){var f=p[h];if(!o[f.name]){var m=Ei(f,o,a,r._resourceManager);if(e.util.isPromise(m))throw new Error("The execution of the op '".concat(f.op,"' returned a promise. ")+"Please use model.executeAsync() instead.");o[f.name]=m,r.checkTensorForDisposal(f.name,f,o,a,i,s,u)}}return null==r.parent&&a.dispose(i),n.map((function(t){return y(t,o,a)}))}))},t.prototype.getFrozenTensorIds=function(t){var e=[].concat.apply([],Object.keys(t).map((function(e){return t[e]})).map((function(t){return t.map((function(t){return t.id}))})));return new Set(e)},t.prototype.checkTensorForDisposal=function(t,e,n,r,a,o,s){var i=this;"control"!==e.category&&-1===o.indexOf(t)&&(n[t].forEach((function(t){null!=t&&(s[t.id]=(s[t.id]||0)+e.children.length)})),e.inputs.forEach((function(t){if("control"!==t.category){var o=function(t,e,n){return e[v(t,n.currentContextId)]}(t.name,n,r);null!=o&&o.forEach((function(t){if(t&&!t.kept&&!a.has(t.id)){var n=s[t.id];if(1===n){if(i.keepTensorForDebug){var o=l(g(e.name,r),2),u=o[0],p=o[1];i.intermediateTensors[u]||(i.intermediateTensors[u]=[]),i.intermediateTensors[u][p]=t}else t.dispose();delete s[t.id]}else null!=n&&s[t.id]--}}))}})))},t.prototype.executeAsync=function(t,e){return u(this,void 0,void 0,(function(){return p(this,(function(n){return[2,this._executeAsync(t,e)]}))}))},t.prototype.disposeIntermediateTensors=function(){var t=this;this.intermediateTensors&&(Object.keys(this.intermediateTensors).forEach((function(e){return t.intermediateTensors[e].forEach((function(t){return t.dispose()}))})),this.disposeTensorsMap())},t.prototype.disposeTensorsMap=function(){var t=this;this.tensorsMap&&Object.keys(this.tensorsMap).forEach((function(e){t.tensorsMap[e].forEach((function(e){!e||e.kept||e.isDisposed||t.keepIds.has(e.id)||e.dispose()}))}))},t.prototype.getIntermediateTensors=function(){return this.tensorsMap},t.prototype.resetIntermediateTensors=function(){for(var t in this.intermediateTensors)this.intermediateTensors[t].forEach((function(t){return t.dispose()})),delete this.intermediateTensors[t]},t.prototype._executeAsync=function(t,n,r,a,o){return void 0===r&&(r=!1),void 0===a&&(a={}),void 0===o&&(o={}),u(this,void 0,void 0,(function(){var s,i,u,c,h,f=this;return p(this,(function(p){switch(p.label){case 0:r||(t=this.mapInputs(t),this.checkInputs(t),this.checkInputShapeAndType(t),n=this.mapOutputs(n),this.checkOutputs(n));try{this.keepTensorForDebug=e.env().getBool("KEEP_INTERMEDIATE_TENSORS")}catch(t){console.warn(t.message)}return this.resetIntermediateTensors(),s=new Ii(this.weightMap,a,o,this.functionExecutorMap),i=this,[4,this.executeWithControlFlow(t,s,n,r)];case 1:return i.tensorsMap=p.sent(),u=n.map((function(t){return y(t,f.tensorsMap,s)})),c=u.map((function(t){return t.id})),h=Object.keys(t).map((function(e){return t[e].id})),this.keepIds=new Set(d(d(d([],l(c),!1),l(h),!1),l(this.weightIds),!1)),this.keepTensorForDebug||this.disposeTensorsMap(),null==this.parent&&s.dispose(this.keepIds),[2,u]}}))}))},t.prototype.executeFunctionAsync=function(t,e,n){return u(this,void 0,void 0,(function(){var r,a=this;return p(this,(function(o){return r=t.reduce((function(t,e,n){return t[a.inputs[n].name]=e,t}),{}),[2,this._executeAsync(r,this.outputNodes,!0,e,n)]}))}))},t.prototype.executeWithControlFlow=function(t,e,n,r){return u(this,void 0,void 0,(function(){var a,o,s,i,u,c,h,f,m,g,v,x,N,w,k,T,_,S=this;return p(this,(function(p){switch(p.label){case 0:a=Object.keys(t),o=a.map((function(t){return S.graph.nodes[b(t)[0]]})),s=n.map((function(t){return b(t)[0]})),0===(i=s.map((function(t){return S.graph.nodes[t]}))).length&&(i=this._outputs),u=Oi(t,i,this.weightMap,this._initNodes),c=u.usedNodes,h=u.missingInputs,f=u.dynamicNode,m=u.syncInputs,g=d(d(d([],l(o),!1),l(this.graph.weights),!1),l(this._initNodes||[]),!1).map((function(t){return{node:t,contexts:e.currentContext}})),v=Object.assign({},this.weightMap),Object.keys(t).forEach((function(e){var n=l(b(e),2),r=n[0],a=[];a[n[1]]=t[e],v[r]=a})),x={},N=this.getFrozenTensorIds(v),w={},p.label=1;case 1:return g.length>0?(k=this.processStack(o,g,e,v,w,N,s,x,c),[4,Promise.all(k)]):[3,3];case 2:return p.sent(),[3,1];case 3:if(null!=f||r||console.warn("This model execution did not contain any nodes with control flow or dynamic output shapes. You can use model.execute() instead."),(T=i.filter((function(t){return!Ci(t)&&!y(t.name,v,e)})).map((function(t){return t.name}))).length>0)throw _="",null!=f&&(_="Alternatively, to avoid the dynamic ops, use model.execute() "+"and specify the inputs [".concat(m,"]")),new Error("Cannot compute the outputs [".concat(T,"] from the provided ")+"inputs [".concat(a,"]. Consider providing the following inputs: ")+"[".concat(h,"]. ").concat(_));return[2,v]}}))}))},t.prototype.processStack=function(t,n,r,a,o,s,i,u,p){for(var c=this,d=[],h=function(){var t,h,y=n.pop();r.currentContext=y.contexts;var v="";if("Enter"===y.node.op&&m("isConstant",y.node,a,r)&&(t=l(g(y.node.name,r),1),v=t[0]),null==a[y.node.name]){var b=Ei(y.node,a,r,f._resourceManager);v||(h=l(g(y.node.name,r),1),v=h[0]);var x=r.currentContext;e.util.isPromise(b)?d.push(b.then((function(t){return a[v]=t,r.currentContext=x,c.checkTensorForDisposal(v,y.node,a,r,s,i,u),c.processChildNodes(y.node,n,r,a,o,p),t}))):(a[v]=b,f.checkTensorForDisposal(v,y.node,a,r,s,i,u),f.processChildNodes(y.node,n,r,a,o,p))}else f.processChildNodes(y.node,n,r,a,o,p)},f=this;n.length>0;)h();return d},t.prototype.processChildNodes=function(t,e,n,r,a,o){t.children.forEach((function(t){var s=l(g(t.name,n),1)[0];!a[s]&&o.has(t.name)&&("Merge"===t.op?t.inputNames.some((function(t){return!!y(t,r,n)}))&&(a[s]=!0,e.push({contexts:n.currentContext,node:t})):t.inputNames.every((function(t){return!!y(t,r,n)}))&&(a[s]=!0,e.push({contexts:n.currentContext,node:t})))}))},t.prototype.dispose=function(){var t=this;Object.keys(this.weightMap).forEach((function(e){return t.weightMap[e].forEach((function(t){return t.dispose()}))}))},t.prototype.checkInputShapeAndType=function(t){var n=this;Object.keys(t).forEach((function(r){var a=t[r],o=l(b(r),1)[0],s=n.graph.nodes[o];if(s.attrParams.shape&&s.attrParams.shape.value){var i=s.attrParams.shape.value,u=i.length===a.shape.length&&a.shape.every((function(t,e){return-1===i[e]||i[e]===t}));e.util.assert(u,(function(){return"The shape of dict['".concat(s.name,"'] provided in ")+"model.execute(dict) must be [".concat(i,"], but was ")+"[".concat(a.shape,"]")}))}s.attrParams.dtype&&s.attrParams.dtype.value&&e.util.assert(a.dtype===s.attrParams.dtype.value,(function(){return"The dtype of dict['".concat(s.name,"'] provided in ")+"model.execute(dict) must be "+"".concat(s.attrParams.dtype.value,", but was ").concat(a.dtype)}))}))},t.prototype.mapInputs=function(t){var e={};for(var n in t){if(null!=this._signature&&null!=this._signature.inputs&&null!=this._signature.inputs[n])e[this._signature.inputs[n].name]=t[n];else e[n]=t[n]}return e},t.prototype.checkInputs=function(t){var e=this,n=Object.keys(t).filter((function(t){var n=l(b(t),1)[0];return null==e.graph.nodes[n]}));if(n.length>0)throw new Error("The dict provided in model.execute(dict) has "+"keys: [".concat(n,"] that are not part of graph"))},t.prototype.mapOutputs=function(t){var e=this;return t.map((function(t){return null!=e._signature&&null!=e._signature.outputs&&null!=e._signature.outputs[t]?e._signature.outputs[t].name:t}),{})},t.prototype.checkOutputs=function(t){var e=this;t.forEach((function(t){var n=l(b(t),1)[0];if(!e.graph.nodes[n])throw new Error("The output '".concat(t,"' is not found in the graph"))}))},t}(),Vi=function(){function t(t,e){void 0===t&&(t={}),void 0===e&&(e={}),this.hashTableNameToHandle=t,this.hashTableMap=e}return t.prototype.addHashTable=function(t,e){this.hashTableNameToHandle[t]=e.handle,this.hashTableMap[e.id]=e},t.prototype.getHashTableHandleByName=function(t){return this.hashTableNameToHandle[t]},t.prototype.getHashTableById=function(t){return this.hashTableMap[t]},t.prototype.dispose=function(){for(var t in this.hashTableMap)this.hashTableMap[t].clearAndClose(),delete this.hashTableMap[t];for(var e in this.hashTableNameToHandle)this.hashTableNameToHandle[e].dispose(),delete this.hashTableNameToHandle[e]},t}(),Li="?tfjs-format=file",Pi="model.json",Bi=function(){function t(t,n,r){void 0===n&&(n={}),void 0===r&&(r=e.io),this.modelUrl=t,this.loadOptions=n,this.version="n/a",this.io=r,null==n&&(this.loadOptions={}),this.resourceManager=new Vi}return Object.defineProperty(t.prototype,"modelVersion",{get:function(){return this.version},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"inputNodes",{get:function(){return this.executor.inputNodes},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"outputNodes",{get:function(){return this.executor.outputNodes},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"inputs",{get:function(){return this.executor.inputs},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"outputs",{get:function(){return this.executor.outputs},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"weights",{get:function(){return this.executor.weightMap},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"metadata",{get:function(){return this.artifacts.userDefinedMetadata},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"modelSignature",{get:function(){return this.signature},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"modelStructuredOutputKeys",{get:function(){return this.structuredOutputKeys},enumerable:!1,configurable:!0}),t.prototype.findIOHandler=function(){var t=this.modelUrl;if(null!=t.load)this.handler=t;else if(null!=this.loadOptions.requestInit)this.handler=this.io.browserHTTPRequest(t,this.loadOptions);else{var e=this.io.getLoadHandlers(t,this.loadOptions);if(0===e.length)e.push(this.io.browserHTTPRequest(t,this.loadOptions));else if(e.length>1)throw new Error("Found more than one (".concat(e.length,") load handlers for ")+"URL '".concat([t],"'"));this.handler=e[0]}},t.prototype.load=function(){var t=this;if(this.findIOHandler(),null==this.handler.load)throw new Error("Cannot proceed with model loading because the IOHandler provided does not have the `load` method implemented.");var n=this.handler.load();return e.util.isPromise(n)?n.then((function(e){return t.loadSync(e)})):this.loadSync(n)},t.prototype.loadSync=function(t){this.artifacts=t;var e=this.artifacts.modelTopology,n=this.artifacts.signature;if(null!=this.artifacts.userDefinedMetadata){var r=this.artifacts.userDefinedMetadata;null!=r.signature&&(n=r.signature),null!=r.structuredOutputKeys&&(this.structuredOutputKeys=r.structuredOutputKeys)}this.signature=n,this.version="".concat(e.versions.producer,".").concat(e.versions.minConsumer);var a=this.io.decodeWeights(this.artifacts.weightData,this.artifacts.weightSpecs);if(this.executor=new Ri(K.Instance.transformGraph(e,this.signature)),this.executor.weightMap=this.convertTensorMapToTensorsMap(a),this.executor.resourceManager=this.resourceManager,null!=t.modelInitializer&&null!=t.modelInitializer.node){var o=K.Instance.transformGraph(t.modelInitializer);this.initializer=new Ri(o),this.initializer.weightMap=this.executor.weightMap,this.initializer.resourceManager=this.resourceManager,this.initializerSignature=t.initializerSignature}return!0},t.prototype.save=function(t,e){return u(this,void 0,void 0,(function(){var e;return p(this,(function(n){if("string"==typeof t){if(0===(e=this.io.getSaveHandlers(t)).length)throw new Error("Cannot find any save handlers for URL '".concat(t,"'"));if(e.length>1)throw new Error("Found more than one (".concat(e.length,") save handlers for ")+"URL '".concat(t,"'"));t=e[0]}if(null==t.save)throw new Error("GraphModel.save() cannot proceed because the IOHandler provided does not have the `save` attribute defined.");return[2,t.save(this.artifacts)]}))}))},t.prototype.predict=function(t,n){var r=this,a=this.execute(t,this.outputNodes);if(this.structuredOutputKeys){var o=a instanceof e.Tensor?[a]:a,s={};return o.forEach((function(t,e){return s[r.structuredOutputKeys[e]]=t})),s}return a},t.prototype.normalizeInputs=function(t){var n=this;if(!(t instanceof e.Tensor||Array.isArray(t))){if(null!=this.signature&&null!=this.signature.inputs)for(var r in this.signature.inputs){var a=this.signature.inputs[r];null!=a.resourceId&&(t[r]=this.resourceIdToCapturedInput[a.resourceId])}return t}t=Array.isArray(t)?t:[t];var o=Object.keys(this.resourceIdToCapturedInput).length;if(t.length+o!==this.inputNodes.length)throw new Error("Input tensor count mismatch, the graph model has ".concat(this.inputNodes.length-o," non-resource placeholders, while there are ").concat(t.length," input tensors provided."));var s=0;return this.inputNodes.reduce((function(e,r){var a=n.signature?n.signature.inputs[r]:null;return null!=a&&null!=a.resourceId?e[r]=n.resourceIdToCapturedInput[a.resourceId]:e[r]=t[s++],e}),{})},t.prototype.normalizeOutputs=function(t){return t=t||this.outputNodes,Array.isArray(t)?t:[t]},t.prototype.executeInitializerGraph=function(){return null==this.initializer?[]:null==this.initializerSignature?this.initializer.execute({},[]):this.initializer.execute({},Object.keys(this.initializerSignature.outputs))},t.prototype.executeInitializerGraphAsync=function(){return u(this,void 0,void 0,(function(){return p(this,(function(t){return null==this.initializer?[2,[]]:null==this.initializerSignature?[2,this.initializer.executeAsync({},[])]:[2,this.initializer.executeAsync({},Object.keys(this.initializerSignature.outputs))]}))}))},t.prototype.setResourceIdToCapturedInput=function(t){if(this.resourceIdToCapturedInput={},this.initializerSignature)for(var e=Object.keys(this.initializerSignature.outputs),n=0;n<e.length;n++){var r=e[n],a=this.initializerSignature.outputs[r];this.resourceIdToCapturedInput[a.resourceId]=t[n]}},t.prototype.execute=function(t,e){null==this.resourceIdToCapturedInput&&this.setResourceIdToCapturedInput(this.executeInitializerGraph()),t=this.normalizeInputs(t),e=this.normalizeOutputs(e);var n=this.executor.execute(t,e);return n.length>1?n:n[0]},t.prototype.executeAsync=function(t,e){return u(this,void 0,void 0,(function(){var n,r;return p(this,(function(a){switch(a.label){case 0:return null!=this.resourceIdToCapturedInput?[3,2]:(n=this.setResourceIdToCapturedInput,[4,this.executeInitializerGraphAsync()]);case 1:n.apply(this,[a.sent()]),a.label=2;case 2:return t=this.normalizeInputs(t),e=this.normalizeOutputs(e),[4,this.executor.executeAsync(t,e)];case 3:return[2,(r=a.sent()).length>1?r:r[0]]}}))}))},t.prototype.getIntermediateTensors=function(){return this.executor.getIntermediateTensors()},t.prototype.disposeIntermediateTensors=function(){this.executor.disposeIntermediateTensors()},t.prototype.convertTensorMapToTensorsMap=function(t){return Object.keys(t).reduce((function(e,n){return e[n]=[t[n]],e}),{})},t.prototype.dispose=function(){this.executor.dispose(),this.initializer&&(this.initializer.dispose(),this.resourceIdToCapturedInput&&e.dispose(this.resourceIdToCapturedInput)),this.resourceManager.dispose()},t}();t.GraphModel=Bi,t.deregisterOp=function(t){delete h[t]},t.loadGraphModel=function(t,n,r){return void 0===n&&(n={}),void 0===r&&(r=e.io),u(this,void 0,void 0,(function(){var e;return p(this,(function(a){switch(a.label){case 0:if(null==t)throw new Error("modelUrl in loadGraphModel() cannot be null. Please provide a url or an IOHandler that loads the model");return null==n&&(n={}),n.fromTFHub&&"string"==typeof t&&(t=function(t){t.endsWith("/")||(t+="/");return"".concat(t).concat(Pi).concat(Li)}(t)),[4,(e=new Bi(t,n,r)).load()];case 1:return a.sent(),[2,e]}}))}))},t.loadGraphModelSync=function(t){if(null==t)throw new Error("modelUrl in loadGraphModelSync() cannot be null. Please provide model artifacts or an IOHandler that loads the model");var n;if(t instanceof Array){var r=l(t,2),a=r[0],o=r[1];if(!a)throw new Error("modelJSON must be the first element of the array");if(!(o&&o instanceof ArrayBuffer))throw new Error("An ArrayBuffer of weights must be the second element of the array");if(!("modelTopology"in a))throw new Error("Model JSON is missing 'modelTopology'");if(!("weightsManifest"in a))throw new Error("Model JSON is missing 'weightsManifest'");var s=e.io.getWeightSpecs(a.weightsManifest),i=e.io.getModelArtifactsForJSONSync(a,s,o);n=e.io.fromMemorySync(i)}else if("load"in t)n=t;else{if(!("modelTopology"in t&&"weightSpecs"in t&&"weightData"in t))throw new Error("Unknown model format");n=e.io.fromMemorySync(t)}var u=new Bi(n);return u.load(),u},t.registerOp=function(t,e){var n={tfOpName:t,category:"custom",inputs:[],attrs:[],customExecutor:e};h[t]=n},t.version_converter="4.0.0",Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-converter.min.js.map
